import { ColumnExchanger as ColumnExchanger_internal } from "./ColumnExchanger";
/**
 * Indicates a column that should be exchanged with another.
*/
export class IgxColumnExchanger {
    createImplementation() {
        return new ColumnExchanger_internal(0);
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The desired location of the new column
    */
    get targetIndex() {
        return this.i.b;
    }
    set targetIndex(v) {
        this.i.b = +v;
    }
}
//# sourceMappingURL=igx-column-exchanger.js.map