import { DateTimeFormats_$type } from "./DateTimeFormats";
import { IgxCellInfo } from "./igx-cell-info";
import { DateTimeCellModel as DateTimeCellModel_internal } from "./DateTimeCellModel";
import { ensureEnum, ensureBool } from "igniteui-angular-core";
/**
 * Backing information about a date time cell for the grid.
*/
export class IgxDateTimeCellInfo extends IgxCellInfo {
    createImplementation() {
        return new DateTimeCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the DateTime value for the cell.
    */
    get dateTimeValue() {
        return this.i.ip;
    }
    set dateTimeValue(v) {
        this.i.ip = v;
    }
    /**
     * The format options to apply to the value
    */
    get formatOverride() {
        return this.i.ix;
    }
    set formatOverride(v) {
        this.i.ix = v;
    }
    /**
     * Sets or gets the simple DateTimeFormat to use for the cell.
    */
    get dateTimeFormat() {
        return this.i.ik;
    }
    set dateTimeFormat(v) {
        this.i.ik = ensureEnum(DateTimeFormats_$type, v);
    }
    /**
     * Sets or gets whether the value to use is a DateTimeOffset value.
    */
    get isOffsetValue() {
        return this.i.im;
    }
    set isOffsetValue(v) {
        this.i.im = ensureBool(v);
    }
}
//# sourceMappingURL=igx-date-time-cell-info.js.map