var IgxDateTimeColumnComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { DateTimeFormats, DateTimeFormats_$type } from "./DateTimeFormats";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { DateTimeColumn } from "./DateTimeColumn";
import { ensureEnum } from "igniteui-angular-core";
/**
 * A column for displaying date/time values.
*/
export const IgxDateTimeColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxDateTimeColumnComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxDateTimeColumnComponent) }];
let IgxDateTimeColumnComponent = IgxDateTimeColumnComponent_1 = class IgxDateTimeColumnComponent extends IgxColumnComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new DateTimeColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    get dateTimeFormat() {
        return this.i.gv;
    }
    set dateTimeFormat(v) {
        this.i.gv = ensureEnum(DateTimeFormats_$type, v);
    }
    /**
     * Gets or sets the INTL DateTimeFormat object to use for formatting the date values.
    */
    get formatOverride() {
        return this.i.gy;
    }
    set formatOverride(v) {
        this.i.gy = v;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxDateTimeColumnComponent.prototype, "dateTimeFormat", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Object),
    tslib_1.__metadata("design:paramtypes", [Object])
], IgxDateTimeColumnComponent.prototype, "formatOverride", null);
IgxDateTimeColumnComponent = IgxDateTimeColumnComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-date-time-column',
        template: ``,
        providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxDateTimeColumnComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxDateTimeColumnComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxDateTimeColumnComponent);
export { IgxDateTimeColumnComponent };
//# sourceMappingURL=igx-date-time-column-component.js.map