import { GridColumnAnimationSettings as GridColumnAnimationSettings_internal } from "./GridColumnAnimationSettings";
/**
 * Column animation settings for the grid.
*/
export class IgxGridColumnAnimationSettings {
    constructor() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new GridColumnAnimationSettings_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
//# sourceMappingURL=igx-grid-column-animation-settings.js.map