import { IgxColumnGroupDescriptionCollection } from "./igx-column-group-description-collection";
import { GridGroupDescriptionsChangedEventArgs as GridGroupDescriptionsChangedEventArgs_internal } from "./GridGroupDescriptionsChangedEventArgs";
/**
 * Information about the current grouping applied to the grid.
*/
export class IgxGridGroupDescriptionsChangedEventArgs {
    createImplementation() {
        return new GridGroupDescriptionsChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get groupDescriptions() {
        if (this.i.groupDescriptions == null) {
            return null;
        }
        if (!this.i.groupDescriptions.externalObject) {
            let e = new IgxColumnGroupDescriptionCollection();
            e._implementation = this.i.groupDescriptions;
            this.i.groupDescriptions.externalObject = e;
        }
        return this.i.groupDescriptions.externalObject;
    }
    set groupDescriptions(v) {
        v == null ? this.i.groupDescriptions = null : this.i.groupDescriptions = v.i;
    }
}
//# sourceMappingURL=igx-grid-group-descriptions-changed-event-args.js.map