import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { CellKey as CellKey_internal } from './CellKey';
import { IgxCellKey as IgxCellKey } from './igx-cell-key';
export class IgxGridSelectedCellsCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxCellKey.$type) {
            IgxCellKey.$type = markType(IgxCellKey, "IgxCellKey");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxCellKey.$type) {
            IgxCellKey.$type = markType(IgxCellKey, "IgxCellKey");
        }
        let coll = new SyncableObservableCollection$2(IgxCellKey.$type, CellKey_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxCellKey();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-grid-selected-cells-collection.js.map