import { IgxColumnSortDescriptionCollection } from "./igx-column-sort-description-collection";
import { GridSortDescriptionsChangedEventArgs as GridSortDescriptionsChangedEventArgs_internal } from "./GridSortDescriptionsChangedEventArgs";
/**
 * Information about the current sorting applied to the grid.
*/
export class IgxGridSortDescriptionsChangedEventArgs {
    createImplementation() {
        return new GridSortDescriptionsChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get sortDescriptions() {
        if (this.i.sortDescriptions == null) {
            return null;
        }
        if (!this.i.sortDescriptions.externalObject) {
            let e = new IgxColumnSortDescriptionCollection();
            e._implementation = this.i.sortDescriptions;
            this.i.sortDescriptions.externalObject = e;
        }
        return this.i.sortDescriptions.externalObject;
    }
    set sortDescriptions(v) {
        v == null ? this.i.sortDescriptions = null : this.i.sortDescriptions = v.i;
    }
}
//# sourceMappingURL=igx-grid-sort-descriptions-changed-event-args.js.map