import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { ImageResourceType_$type } from "./ImageResourceType";
import { IgxCellInfo } from "./igx-cell-info";
import { ImageCellModel as ImageCellModel_internal } from "./ImageCellModel";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for an image cell in the grid.
*/
export class IgxImageCellInfo extends IgxCellInfo {
    createImplementation() {
        return new ImageCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resource path to use to get the image for the cell.
    */
    get imagePath() {
        return this.i.iq;
    }
    set imagePath(v) {
        this.i.iq = v;
    }
    /**
     * Sets or gets the image stretching behavior for the image.
    */
    get imageStretchOption() {
        return this.i.ik;
    }
    set imageStretchOption(v) {
        this.i.ik = ensureEnum(ImageStretchOptions_$type, v);
    }
    /**
     * Sets or gets the image resource type. Indicates which type of resource should be fetched and how ImagePath should be interpreted.
    */
    get imageResourceType() {
        return this.i.ii;
    }
    set imageResourceType(v) {
        this.i.ii = ensureEnum(ImageResourceType_$type, v);
    }
}
//# sourceMappingURL=igx-image-cell-info.js.map