var IgxImageColumnComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { ImageStretchOptions, ImageStretchOptions_$type } from "./ImageStretchOptions";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ImageColumn } from "./ImageColumn";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
export const IgxImageColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxImageColumnComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxImageColumnComponent) }];
let IgxImageColumnComponent = IgxImageColumnComponent_1 = class IgxImageColumnComponent extends IgxColumnComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ImageColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the stretch option to use when rendering images
    */
    get imageStretchOption() {
        return this.i.gw;
    }
    set imageStretchOption(v) {
        this.i.gw = ensureEnum(ImageStretchOptions_$type, v);
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxImageColumnComponent.prototype, "imageStretchOption", null);
IgxImageColumnComponent = IgxImageColumnComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-image-column',
        template: ``,
        providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxImageColumnComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxImageColumnComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxImageColumnComponent);
export { IgxImageColumnComponent };
//# sourceMappingURL=igx-image-column-component.js.map