import * as tslib_1 from "tslib";
import { Component, EventEmitter, Output, ViewContainerRef, ComponentFactoryResolver, Injector, NgZone, Renderer2, ViewChild, Input, ChangeDetectionStrategy, ContentChildren, QueryList } from '@angular/core';
import { IgxSectionHeaderComponent } from './igx-section-header-component';
import { IgxSummaryRowRootComponent } from './igx-summary-row-root-component';
import { IgxSummaryRowSectionComponent } from './igx-summary-row-section-component';
import { IgxColumnWidth } from './igx-column-width';
import { ColumnWidth as ColumnWidth_internal } from './ColumnWidth';
import { HeaderClickAction, HeaderClickAction_$type } from './HeaderClickAction';
import { ColumnShowingAnimationMode, ColumnShowingAnimationMode_$type } from './ColumnShowingAnimationMode';
import { ColumnPropertyUpdatingAnimationMode, ColumnPropertyUpdatingAnimationMode_$type } from './ColumnPropertyUpdatingAnimationMode';
import { CellDataLoadedAnimationMode, CellDataLoadedAnimationMode_$type } from './CellDataLoadedAnimationMode';
import { RowSelectionAnimationMode, RowSelectionAnimationMode_$type } from './RowSelectionAnimationMode';
import { ColumnMovingAnimationMode, ColumnMovingAnimationMode_$type } from './ColumnMovingAnimationMode';
import { ColumnHidingAnimationMode, ColumnHidingAnimationMode_$type } from './ColumnHidingAnimationMode';
import { CellSelectionAnimationMode, CellSelectionAnimationMode_$type } from './CellSelectionAnimationMode';
import { ColumnExchangingAnimationMode, ColumnExchangingAnimationMode_$type } from './ColumnExchangingAnimationMode';
import { GridSelectionMode, GridSelectionMode_$type } from './GridSelectionMode';
import { GridActivationMode, GridActivationMode_$type } from './GridActivationMode';
import { GridSelectionBehavior, GridSelectionBehavior_$type } from './GridSelectionBehavior';
import { IgxGridCellEventArgs } from './igx-grid-cell-event-args';
import { IgxGridColumnsAutoGeneratedEventArgs } from './igx-grid-columns-auto-generated-event-args';
import { IgxGridSelectedItemsChangedEventArgs } from './igx-grid-selected-items-changed-event-args';
import { IgxGridSelectedKeysChangedEventArgs } from './igx-grid-selected-keys-changed-event-args';
import { IgxGridSelectedCellsChangedEventArgs } from './igx-grid-selected-cells-changed-event-args';
import { IgxGridSelectedCellRangesChangedEventArgs } from './igx-grid-selected-cell-ranges-changed-event-args';
import { IgxGridSortDescriptionsChangedEventArgs } from './igx-grid-sort-descriptions-changed-event-args';
import { IgxGridGroupDescriptionsChangedEventArgs } from './igx-grid-group-descriptions-changed-event-args';
import { Grid } from "./Grid";
import { ensureEnum, ensureBool, CollectionAdapter, initializePropertiesFromCss, NamePatcher, stringToBrush, brushToString, toSpinal } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AngularRenderer, AngularWrapper } from "igniteui-angular-core";
import { Column } from './Column';
import { IgxColumnComponent } from './igx-column-component';
import { DataGridCellLayoutPanel } from './DataGridCellLayoutPanel';
import { Base } from "igniteui-angular-core";
import { GridExternalWrapper } from './GridExternalWrapper';
import { BrowserTickProvider } from './BrowserTickProvider';
import { BrowserPixelConverter } from './BrowserPixelConverter';
import { DataGridPresenterManager } from './DataGridPresenterManager';
import { DataGridViewportManager } from './DataGridViewportManager';
import { DataGridDelayedExecutionManager } from './DataGridDelayedExecutionManager';
import { DataGridPropertySetter } from './DataGridPropertySetter';
import { IgxGridColumnCollection } from './igx-grid-column-collection';
import { SyncableObservableCollection$1 } from "igniteui-angular-core";
import { NotifyCollectionChangedAction } from "igniteui-angular-core";
import { Scroller } from "igniteui-angular-core";
import { Dragger } from "./Dragger";
import { LiveGridStylingDefaults } from './LiveGridStylingDefaults';
import { delegateCombine } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { IgxColumnSortDescriptionCollection } from './igx-column-sort-description-collection';
import { IgxColumnGroupDescriptionCollection } from './igx-column-group-description-collection';
import { IgxFilterExpressionCollection } from "igniteui-angular-core";
import { IgxColumnSummaryDescriptionCollection } from './igx-column-summary-description-collection';
import { IgxGridSelectedItemsCollection } from "./igx-grid-selected-items-collection";
import { IgxGridSelectedKeysCollection } from "./igx-grid-selected-keys-collection";
import { IgxGridSelectedCellsCollection } from "./igx-grid-selected-cells-collection";
import { IgxGridSelectedCellRangesCollection } from "./igx-grid-selected-cell-ranges-collection";
import { GridSelectedItemsCollection as GridSelectedItemsCollection_internal } from "./GridSelectedItemsCollection";
import { GridSelectedKeysCollection as GridSelectedKeysCollection_internal } from "./GridSelectedKeysCollection";
import { GridSelectedCellsCollection as GridSelectedCellsCollection_internal } from "./GridSelectedCellsCollection";
import { GridSelectedCellRangesCollection as GridSelectedCellRangesCollection_internal } from "./GridSelectedCellRangesCollection";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { CellKey } from "./CellKey";
import { CellRange } from "./CellRange";
import { IgxGridFilterExpressionsEventArgs } from './igx-grid-filter-expressions-event-args';
import { GridColumnCollection as GridColumnCollection_internal } from './GridColumnCollection';
import { ResponsiveStatesCollection as ResponsiveStatesCollection_internal } from './ResponsiveStatesCollection';
import { IgxResponsiveStatesCollection } from './igx-responsive-states-collection';
import { ResponsiveState } from './ResponsiveState';
import { IgxGridAnimationSettings } from './igx-grid-animation-settings';
import { IgxRowSeparatorComponent } from './igx-row-separator-component';
import { IgxGridCellPosition } from "./igx-grid-cell-position";
import { IgxGridActiveCellChangedEventArgs } from "./igx-grid-active-cell-changed-event-args";
import { DataGridScrollerKeyboardListener } from "./DataGridScrollerKeyboardListener";
import { IgxHeaderSeparatorComponent } from "./igx-header-separator-component";
import { IgxColumnResizingSeparatorComponent } from './igx-column-resizing-separator-component';
import { ColumnResizingMode, ColumnResizingMode_$type } from "./ColumnResizingMode";
import { ColumnResizingAnimationMode, ColumnResizingAnimationMode_$type } from "./ColumnResizingAnimationMode";
import { ColumnMovingMode, ColumnMovingMode_$type } from "./ColumnMovingMode";
import { IgxColumnMovingSeparatorComponent } from './igx-column-moving-separator-component';
import { SortIndicatorStyle, SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { DataSourceSectionHeaderDisplayMode, DataSourceSectionHeaderDisplayMode_$type } from "igniteui-angular-core";
import { DataSourceSummaryScope, DataSourceSummaryScope_$type } from "igniteui-angular-core";
import { GroupSummaryDisplayMode, GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { fromRect } from "igniteui-angular-core";
export const IgxGridComponent_PROVIDERS = [];
let GridStylingDefaults = {};
let IgxLiveGridComponent = class IgxLiveGridComponent {
    constructor(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._ngZone = _ngZone;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._injector = _injector;
        /**
         * The columns actually present in the grid. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing columns from the manual columns collection on the columns property.
         */
        this.combinedColumns = [];
        this._columns = null;
        this._disableManualColumnSync = false;
        this._scrollerStyle = 1 /* Fading */;
        this._columnsAdapter = null;
        this._scroller = null;
        this._dragger = null;
        this._wrapper = null;
        this._grid = null;
        this.containerResized = function () {
            var width = this._container.clientWidth;
            var height = this._container.clientHeight;
            this._scroller.viewportWidth = width;
            this._scroller.viewportHeight = height;
            this._grid.dragger.viewportWidth = width;
            this._grid.dragger.viewportHeight = height;
            this._grid.sizeChanged(width, height);
            if (this._grid.model.actualVisibleRegion.isEmpty &&
                width > 0 && height > 0) {
                this._grid.setViewport(0, 0, width, height);
            }
            else {
                this.onScroll();
            }
        };
        this._dataSource = null;
        this._insetLeft = 0;
        this._insetTop = 0;
        this._insetRight = 0;
        this._insetBottom = 0;
        this._selectedItems = null;
        this._selectedKeys = null;
        this._selectedCells = null;
        this._selectedCellRanges = null;
        this._pinnedItems = null;
        this._pinnedKeys = null;
        this._responsiveStates = null;
        this._actualColumns = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._filterExpressionsChanging = null;
        this._filterExpressionsChanged = null;
        this._cellPreviewPointerDown = null;
        this._cellPreviewPointerUp = null;
        this._cellPointerDown = null;
        this._cellPointerUp = null;
        this._cellClicked = null;
        this._sortDescriptionsChanged = null;
        this._groupDescriptionsChanged = null;
        this._columnsAutoGenerated = null;
        this._selectedItemsChanged = null;
        this._selectedKeysChanged = null;
        this._selectedCellsChanged = null;
        this._activeCellChanged = null;
        this._selectedCellRangesChanged = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        let useCanvas = false;
        this._zoneRunner = (act) => this._ngZone.run(act);
        this._container = _renderer.createElement("div");
        _renderer.appendChild(_elRef.element.nativeElement, this._container);
        _renderer.setStyle(this._container, "display", "block");
        _renderer.setStyle(this._container, "width", "100%");
        _renderer.setStyle(this._container, "height", "100%");
        _renderer.setStyle(this._container, "box-sizing", "border-box");
        var root;
        root = this._container;
        if (this._container.nativeElement != null) {
            root = this._container.nativeElement;
        }
        var ren = new AngularRenderer(root, this._renderer, window.document, this._ngZone, true, LiveGridStylingDefaults);
        this._wrapper = ren;
        this._implementation = new Grid();
        var grid = this.i;
        this._grid = grid;
        this._columnsAdapter = new CollectionAdapter([], this.i.columns, this.combinedColumns, (c) => c.i, (i) => {
            i._provideRenderer(this._wrapper);
            if (this._elRef && this._elRef.element.nativeElement.parentElement) {
                i._styling(this._elRef.element.nativeElement, this, this);
            }
        }, (i) => { i._provideRenderer(null); });
        grid.externalGrid = new GridExternalWrapper(this);
        grid.tickProvider = new BrowserTickProvider(ren);
        grid.platformPixelConverter = new BrowserPixelConverter();
        this._contentLayout = new DataGridCellLayoutPanel(ren, new DataGridPresenterManager(this._grid, useCanvas), window.devicePixelRatio);
        grid.renderingEngine = this._contentLayout;
        grid.viewportManager = new DataGridViewportManager(this);
        grid.delayedExecutionManager = new DataGridDelayedExecutionManager(ren);
        grid.propertySetter = new DataGridPropertySetter();
        //grid.provideContainer(ren);
        let scroller = new Scroller();
        this._scroller = scroller;
        scroller.scrollbarStyle = this.scrollbarStyle;
        scroller.provideContainer(ren);
        this._content = (this._contentLayout.element.getNativeElement());
        scroller.keyboardListener = new DataGridScrollerKeyboardListener(grid);
        scroller.provideContent(new AngularWrapper(this._content, this._renderer, this._ngZone));
        scroller.onScrolling = () => this.onScroll();
        scroller.viewportWidth = this._container.clientWidth;
        scroller.viewportHeight = this._container.clientHeight;
        scroller.verticalTrackStartInset = this.headerHeight;
        grid.dragger = new Dragger();
        grid.dragger.provideContainer(ren);
        grid.dragger.viewportWidth = this._container.clientWidth;
        grid.dragger.viewportHeight = this._container.clientHeight;
        ren.addSizeWatcher(() => {
            this.containerResized();
        });
        // supports angular themes or custom properties set in CSS 
        //this._styling(_elRef.element.nativeElement, this);
    }
    _ensureColumnsAreManual() {
        this._disableManualColumnSync = true;
        this._columnsAdapter.shiftContentToManual(this.columns, (i) => i.isFromMarkup = false);
        this._disableManualColumnSync = false;
    }
    /**
     * A collection or manually added columns for the grid.
    */
    get columns() {
        if (this._columns === null) {
            let coll = new IgxGridColumnCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                if (this._disableManualColumnSync) {
                    return;
                }
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._columnsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._columnsAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._columnsAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._columnsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._columnsAdapter.clearManualItems();
                        break;
                }
            });
            this._columns = coll;
        }
        return this._columns;
    }
    set height(value) {
        this._height = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this.containerResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this.containerResized();
    }
    get width() {
        return this._width;
    }
    set scrollbarStyle(style) {
        this._scrollerStyle = style;
        if (this._scroller) {
            this._scroller.scrollbarStyle = this._scrollerStyle;
        }
    }
    get scrollbarStyle() {
        return this._scrollerStyle;
    }
    createImplementation() {
        let test = Grid;
        return new Grid();
    }
    ngOnInit() {
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _focusScroller() {
        this._scroller.focus();
    }
    _setDefaultCursor() {
        if (this._elRef.element.nativeElement.style.cursor !== "") {
            this._elRef.element.nativeElement.style.cursor = "";
        }
    }
    _setResizeCursor() {
        if (this._elRef.element.nativeElement.style.cursor !== "col-resize") {
            this._elRef.element.nativeElement.style.cursor = "col-resize";
        }
    }
    _setHandCursor() {
        if (this._elRef.element.nativeElement.style.cursor !== "grabbing") {
            this._elRef.element.nativeElement.style.cursor = "grabbing";
        }
    }
    _insertExternalColumnAtIndex(index, column) {
        //let contentCount = this.contentColumns.length;
        let contentCount = this._columnsAdapter.actualContent.length;
        this.columns.insert(index - contentCount, column);
    }
    _removeExternalColumn(column) {
        let ind = -1;
        for (let i = 0; i < this.columns.count; i++) {
            if (this.columns.item(i) === column) {
                ind = i;
                break;
            }
        }
        if (ind >= 0) {
            this.columns.removeAt(ind);
        }
    }
    ngAfterContentInit() {
        let prev = this._grid.columnPropertyUpdatingAnimationMode;
        this._grid.columnPropertyUpdatingAnimationMode = ColumnPropertyUpdatingAnimationMode.None;
        this._styling(this._elRef.element.nativeElement, this);
        this._grid.columnPropertyUpdatingAnimationMode = prev;
        this._columnsAdapter.updateQuery(this.contentColumns);
        prev = this._grid.columnPropertyUpdatingAnimationMode;
        this._grid.columnPropertyUpdatingAnimationMode = ColumnPropertyUpdatingAnimationMode.None;
        for (let i = 0; i < this.actualColumns.count; i++) {
            let c = this.actualColumns.item(i);
            c._styling(this._elRef.element.nativeElement, this, this);
        }
        this._grid.columnPropertyUpdatingAnimationMode = prev;
        this._grid.itemsSource = this._dataSource;
    }
    get actualDataSource() {
        return this.i.actualDataSource;
    }
    refreshContentSize() {
        if (this._content != null) {
            var width = this._grid.model.absoluteWidth;
            var height = this._grid.model.absoluteHeight;
            if (this._scroller != null) {
                this._scroller.contentWidth = width;
                this._scroller.contentHeight = height;
            }
        }
    }
    onScroll() {
        let top = this._scroller.scrollTop;
        let left = this._scroller.scrollLeft;
        let width = this._scroller.viewportWidth;
        let height = this._scroller.viewportHeight;
        //console.log("top:" + top);
        this._grid.setViewport(left, top, left + width, top + height);
    }
    set dataSource(value) {
        this._dataSource = value;
        if (this._grid != null) {
            this._grid.itemsSource = this._dataSource;
        }
    }
    get dataSource() {
        return this._dataSource;
    }
    forColumnsWithPropertyPath(propertyPath, callback) {
        for (let i = 0; i < this.i.actualColumns.count; i++) {
            let col = this.i.actualColumns.item(i).externalObject;
            if (col.propertyPath == propertyPath) {
                callback(col);
            }
        }
    }
    /**
     * Gets or sets the default column width to use if a column as no local width.
     * */
    get defaultColumnWidth() {
        let ext = this.i.defaultColumnWidth.externalObject;
        if (!ext) {
            ext = new IgxColumnWidth();
            ext._implementation = this.i.defaultColumnWidth;
        }
        return ext;
    }
    set defaultColumnWidth(value) {
        if (typeof value == "string") {
            let int = ColumnWidth_internal.parse(value);
            let ext = new IgxColumnWidth();
            ext._implementation = int;
            value = ext;
        }
        this.i.defaultColumnWidth = value.i;
    }
    /**
     * Gets or sets the amount of left inset space to use around the grid content.
    */
    get insetLeft() {
        return this._insetLeft;
    }
    set insetLeft(v) {
        this._insetLeft = +v;
        let inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
        this.i.inset = inset;
    }
    /**
     * Gets or sets the amount of top inset space to use around the grid content.
    */
    get insetTop() {
        return this._insetTop;
    }
    set insetTop(v) {
        this._insetTop = +v;
        let inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
        this.i.inset = inset;
    }
    /**
     * Gets or sets the amount of right inset space to use around the grid content.
    */
    get insetRight() {
        return this._insetLeft;
    }
    set insetRight(v) {
        this._insetRight = +v;
        let inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
        this.i.inset = inset;
    }
    /**
     * Gets or sets the amount of bottom inset space to use around the grid content.
    */
    get insetBottom() {
        return this._insetBottom;
    }
    set insetBottom(v) {
        this._insetBottom = +v;
        let inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
        this.i.inset = inset;
    }
    /**
 * Gets or sets the type of column resizing to use.
*/
    get columnResizingMode() {
        return this.i.bg;
    }
    set columnResizingMode(v) {
        this.i.bg = ensureEnum(ColumnResizingMode_$type, v);
    }
    /**
     * Gets or sets the type column moving to use.
    */
    get columnMovingMode() {
        return this.i.a7;
    }
    set columnMovingMode(v) {
        this.i.a7 = ensureEnum(ColumnMovingMode_$type, v);
    }
    /**
     * Gets or sets the header type used for sectioning off groups of rows.
    */
    get sectionHeader() {
        if (this.i.dv == null) {
            return null;
        }
        if (!this.i.dv.externalObject) {
            let e = IgxSectionHeaderComponent._createFromInternal(this.i.dv);
            if (e) {
                e._implementation = this.i.dv;
            }
            this.i.dv.externalObject = e;
        }
        return this.i.dv.externalObject;
    }
    set sectionHeader(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.dv = null : this.i.dv = v.i;
    }
    /**
     * Gets or sets the cell definition used for summary rows at the root level.
    */
    get summaryRowRoot() {
        if (this.i.d5 == null) {
            return null;
        }
        if (!this.i.d5.externalObject) {
            let e = IgxSummaryRowRootComponent._createFromInternal(this.i.d5);
            if (e) {
                e._implementation = this.i.d5;
            }
            this.i.d5.externalObject = e;
        }
        return this.i.d5.externalObject;
    }
    set summaryRowRoot(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.d5 = null : this.i.d5 = v.i;
    }
    /**
     * Gets or sets the cell definition used for summary rows at the section level.
    */
    get summaryRowSection() {
        if (this.i.d7 == null) {
            return null;
        }
        if (!this.i.d7.externalObject) {
            let e = IgxSummaryRowSectionComponent._createFromInternal(this.i.d7);
            if (e) {
                e._implementation = this.i.d7;
            }
            this.i.d7.externalObject = e;
        }
        return this.i.d7.externalObject;
    }
    set summaryRowSection(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.d7 = null : this.i.d7 = v.i;
    }
    /**
     * Gets or sets the row seperator settings.
    */
    get rowSeparator() {
        if (this.i.dr == null) {
            return null;
        }
        if (!this.i.dr.externalObject) {
            let e = IgxRowSeparatorComponent._createFromInternal(this.i.dr);
            if (e) {
                e._implementation = this.i.dr;
            }
            this.i.dr.externalObject = e;
        }
        return this.i.dr.externalObject;
    }
    set rowSeparator(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.dr = null : this.i.dr = v.i;
    }
    /**
     * Gets or sets the header seperator settings.
    */
    get headerSeparator() {
        if (this.i.c6 == null) {
            return null;
        }
        if (!this.i.c6.externalObject) {
            let e = IgxHeaderSeparatorComponent._createFromInternal(this.i.c6);
            if (e) {
                e._implementation = this.i.c6;
            }
            this.i.c6.externalObject = e;
        }
        return this.i.c6.externalObject;
    }
    set headerSeparator(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.c6 = null : this.i.c6 = v.i;
    }
    /**
     * Gets or sets the column resizing seperator settings.
    */
    get columnResizingSeparator() {
        if (this.i.bi == null) {
            return null;
        }
        if (!this.i.bi.externalObject) {
            let e = IgxColumnResizingSeparatorComponent._createFromInternal(this.i.bi);
            if (e) {
                e._implementation = this.i.bi;
            }
            this.i.bi.externalObject = e;
        }
        return this.i.bi.externalObject;
    }
    set columnResizingSeparator(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.bi = null : this.i.bi = v.i;
    }
    /**
     * Gets or sets the column resizing seperator settings.
    */
    get columnMovingSeparator() {
        if (this.i.a9 == null) {
            return null;
        }
        if (!this.i.a9.externalObject) {
            let e = IgxColumnMovingSeparatorComponent._createFromInternal(this.i.a9);
            if (e) {
                e._implementation = this.i.a9;
            }
            this.i.a9.externalObject = e;
        }
        return this.i.a9.externalObject;
    }
    set columnMovingSeparator(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.a9 = null : this.i.a9 = v.i;
    }
    /**
     * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
    */
    get dataSourceDesiredProperties() {
        return this.i.e;
    }
    set dataSourceDesiredProperties(v) {
        this.i.e = v;
    }
    /**
     * Gets or sets the height to use for the rows in the grid.
    */
    get rowHeight() {
        return this.i.ir;
    }
    set rowHeight(v) {
        this.i.ir = +v;
    }
    /**
     * Gets or sets the default minimum width to use on all columns. Ignored if NaN.
    */
    get defaultColumnMinWidth() {
        return this.i.g9;
    }
    set defaultColumnMinWidth(v) {
        this.i.g9 = +v;
    }
    /**
     * Gets or sets the height to use for the header row.
    */
    get headerHeight() {
        return this.i.ik;
    }
    set headerHeight(v) {
        this.i.ik = +v;
    }
    /**
     * Returns/sets the action to take when a column header is clicked.
    */
    get headerClickAction() {
        return this.i.c4;
    }
    set headerClickAction(v) {
        this.i.c4 = ensureEnum(HeaderClickAction_$type, v);
    }
    /**
     * Configures whether or not the grid will autogenerate columns when the data source is set.
    */
    get autoGenerateColumns() {
        return this.i.fd;
    }
    set autoGenerateColumns(v) {
        this.i.fd = ensureBool(v);
    }
    /**
     * Sets or gets the height to use for the row separators.
    */
    get rowSeparatorHeight() {
        return this.i.it;
    }
    set rowSeparatorHeight(v) {
        this.i.it = +v;
    }
    /**
     * Configures whether or not place holders are used for cells who do not have their data yet.
    */
    get isPlaceholderRenderingEnabled() {
        return this.i.fz;
    }
    set isPlaceholderRenderingEnabled(v) {
        this.i.fz = ensureBool(v);
    }
    /**
     * Sets or gets the Column Adding Animation mode to use.
    */
    get columnAddingAnimationMode() {
        return this.i.bl;
    }
    set columnAddingAnimationMode(v) {
        this.i.bl = ensureEnum(ColumnShowingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the Column Property Updating Animation mode to use.
    */
    get columnPropertyUpdatingAnimationMode() {
        return this.i.columnPropertyUpdatingAnimationMode;
    }
    set columnPropertyUpdatingAnimationMode(v) {
        this.i.columnPropertyUpdatingAnimationMode = ensureEnum(ColumnPropertyUpdatingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the cell data loaded animation mode to use.
    */
    get cellDataLoadedAnimationMode() {
        return this.i.ah;
    }
    set cellDataLoadedAnimationMode(v) {
        this.i.ah = ensureEnum(CellDataLoadedAnimationMode_$type, v);
    }
    /**
     * Sets or gets the row selection animation mode to use.
    */
    get rowSelectionAnimationMode() {
        return this.i.dp;
    }
    set rowSelectionAnimationMode(v) {
        this.i.dp = ensureEnum(RowSelectionAnimationMode_$type, v);
    }
    /**
     * Sets or gets the cell selection animation mode to use.
    */
    get cellSelectionAnimationMode() {
        return this.i.ar;
    }
    set cellSelectionAnimationMode(v) {
        this.i.ar = ensureEnum(CellSelectionAnimationMode_$type, v);
    }
    /**
     * Sets or gets the default animation settings for the grid.
    */
    get animationSettings() {
        if (this.i.b3 == null) {
            return null;
        }
        if (!this.i.b3.externalObject) {
            let e = new IgxGridAnimationSettings();
            e._implementation = this.i.b3;
            this.i.b3.externalObject = e;
        }
        return this.i.b3.externalObject;
    }
    set animationSettings(v) {
        v == null ? this.i.b3 = null : this.i.b3 = v.i;
    }
    /**
     * Sets or gets the column resizing animation mode to use. Only applies when resizing in Deferred mode.
    */
    get columnResizingAnimationMode() {
        return this.i.bd;
    }
    set columnResizingAnimationMode(v) {
        this.i.bd = ensureEnum(ColumnResizingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the column showing animation mode to use.
    */
    get columnShowingAnimationMode() {
        return this.i.bm;
    }
    set columnShowingAnimationMode(v) {
        this.i.bm = ensureEnum(ColumnShowingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the column moving animation mode to use.
    */
    get columnMovingAnimationMode() {
        return this.i.a4;
    }
    set columnMovingAnimationMode(v) {
        this.i.a4 = ensureEnum(ColumnMovingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the column hiding animation mode to use.
    */
    get columnHidingAnimationMode() {
        return this.i.a1;
    }
    set columnHidingAnimationMode(v) {
        this.i.a1 = ensureEnum(ColumnHidingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the column exchanging animation mode to use.
    */
    get columnExchangingAnimationMode() {
        return this.i.aw;
    }
    set columnExchangingAnimationMode(v) {
        this.i.aw = ensureEnum(ColumnExchangingAnimationMode_$type, v);
    }
    /**
     * Sets or gets the grid selection mode.
    */
    get selectionMode() {
        return this.i.cz;
    }
    set selectionMode(v) {
        this.i.cz = ensureEnum(GridSelectionMode_$type, v);
    }
    /**
     * Sets or gets the grid selection mode.
    */
    get activationMode() {
        return this.i.by;
    }
    set activationMode(v) {
        this.i.by = ensureEnum(GridActivationMode_$type, v);
    }
    /**
     * Sets or gets how selection behaves in the grid.
    */
    get selectionBehavior() {
        return this.i.cx;
    }
    set selectionBehavior(v) {
        this.i.cx = ensureEnum(GridSelectionBehavior_$type, v);
    }
    /**
     * Gets which items are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedItems() {
        if (this._selectedItems === null) {
            let coll = new IgxGridSelectedItemsCollection();
            let innerColl = this.i.z;
            if (!innerColl) {
                innerColl = new GridSelectedItemsCollection_internal();
            }
            this._selectedItems = coll._fromInner(innerColl);
        }
        return this._selectedItems;
    }
    set selectedItems(v) {
        if (this._selectedItems !== null) {
            this._selectedItems._setSyncTarget(null);
            this._selectedItems = null;
        }
        let coll = new IgxGridSelectedItemsCollection();
        this._selectedItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.z;
        if (!innerColl) {
            innerColl = new GridSelectedItemsCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedItems._setSyncTarget(syncColl);
    }
    /**
     * Gets which primary key values are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedKeys() {
        if (this._selectedKeys === null) {
            let coll = new IgxGridSelectedKeysCollection();
            let innerColl = this.i.ad;
            if (!innerColl) {
                innerColl = new GridSelectedKeysCollection_internal();
            }
            this._selectedKeys = coll._fromInner(innerColl);
        }
        return this._selectedKeys;
    }
    set selectedKeys(v) {
        if (this._selectedKeys !== null) {
            this._selectedKeys._setSyncTarget(null);
            this._selectedKeys = null;
        }
        let coll = new IgxGridSelectedKeysCollection();
        this._selectedKeys = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PrimaryKeyValue.$type);
        let innerColl = this.i.ad;
        if (!innerColl) {
            innerColl = new GridSelectedKeysCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedKeys._setSyncTarget(syncColl);
    }
    /**
     * Gets which cells are currently selected in the grid. Collection can be updated to programatically select cells.
    */
    get selectedCells() {
        if (this._selectedCells === null) {
            let coll = new IgxGridSelectedCellsCollection();
            let innerColl = this.i.ct;
            if (!innerColl) {
                innerColl = new GridSelectedCellsCollection_internal();
            }
            this._selectedCells = coll._fromInner(innerColl);
        }
        return this._selectedCells;
    }
    set selectedCells(v) {
        if (this._selectedCells !== null) {
            this._selectedCells._setSyncTarget(null);
            this._selectedCells = null;
        }
        let coll = new IgxGridSelectedCellsCollection();
        this._selectedCells = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(CellKey.$type);
        let innerColl = this.i.ct;
        if (!innerColl) {
            innerColl = new GridSelectedCellsCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedCells._setSyncTarget(syncColl);
    }
    /**
     * Gets which cell ranges are currently selected in the grid. Collection can be updated to programatically select cells.
    */
    get selectedCellRanges() {
        if (this._selectedCellRanges === null) {
            let coll = new IgxGridSelectedCellRangesCollection();
            let innerColl = this.i.cq;
            if (!innerColl) {
                innerColl = new GridSelectedCellRangesCollection_internal();
            }
            this._selectedCellRanges = coll._fromInner(innerColl);
        }
        return this._selectedCellRanges;
    }
    set selectedCellRanges(v) {
        if (this._selectedCellRanges !== null) {
            this._selectedCellRanges._setSyncTarget(null);
            this._selectedCellRanges = null;
        }
        let coll = new IgxGridSelectedCellRangesCollection();
        this._selectedCellRanges = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(CellRange.$type);
        let innerColl = this.i.cq;
        if (!innerColl) {
            innerColl = new GridSelectedCellRangesCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedCellRanges._setSyncTarget(syncColl);
    }
    /**
     * Gets which items are currently pinned in the grid. Collection can be updated to programatically pin items.
    */
    get pinnedItems() {
        if (this._pinnedItems === null) {
            let coll = new IgxGridSelectedItemsCollection();
            let innerColl = this.i.y;
            if (!innerColl) {
                innerColl = new GridSelectedItemsCollection_internal();
            }
            this._pinnedItems = coll._fromInner(innerColl);
        }
        return this._pinnedItems;
    }
    set pinnedItems(v) {
        if (this._pinnedItems !== null) {
            this._pinnedItems._setSyncTarget(null);
            this._pinnedItems = null;
        }
        let coll = new IgxGridSelectedItemsCollection();
        this._pinnedItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.y;
        if (!innerColl) {
            innerColl = new GridSelectedItemsCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._pinnedItems._setSyncTarget(syncColl);
    }
    /**
     * Gets which primary keys are currently pinned in the grid. Collection can be updated to programatically pin items.
    */
    get pinnedKeys() {
        if (this._pinnedKeys === null) {
            let coll = new IgxGridSelectedKeysCollection();
            let innerColl = this.i.ac;
            if (!innerColl) {
                innerColl = new GridSelectedKeysCollection_internal();
            }
            this._pinnedKeys = coll._fromInner(innerColl);
        }
        return this._pinnedKeys;
    }
    set pinnedKeys(v) {
        if (this._pinnedKeys !== null) {
            this._pinnedKeys._setSyncTarget(null);
            this._pinnedKeys = null;
        }
        let coll = new IgxGridSelectedKeysCollection();
        this._pinnedKeys = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PrimaryKeyValue.$type);
        let innerColl = this.i.ac;
        if (!innerColl) {
            innerColl = new GridSelectedKeysCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._pinnedKeys._setSyncTarget(syncColl);
    }
    /**
     * Gets or sets whether to show the filtering UI in the headers for columns where filtering is enabled.
    */
    get isFilterUIEnabled() {
        return this.i.fs;
    }
    set isFilterUIEnabled(v) {
        this.i.fs = ensureBool(v);
    }
    /**
     * Gets or sets if group rows will stick to the top of the grid.
    */
    get isGroupRowSticky() {
        return this.i.fv;
    }
    set isGroupRowSticky(v) {
        this.i.fv = ensureBool(v);
    }
    /**
     * Gets or sets if header separators are rendered.
    */
    get isHeaderSeparatorVisible() {
        return this.i.fw;
    }
    set isHeaderSeparatorVisible(v) {
        this.i.fw = ensureBool(v);
    }
    /**
     * Gets or sets the default background color to use for content cells when a row is in a selected state
    */
    get cellSelectedBackground() {
        return brushToString(this.i.pw);
    }
    set cellSelectedBackground(v) {
        this.i.pw = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for section header cells when a row is in a selected state
    */
    get sectionHeaderSelectedBackground() {
        return brushToString(this.i.qb);
    }
    set sectionHeaderSelectedBackground(v) {
        this.i.qb = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    get summaryRootBackground() {
        return brushToString(this.i.qe);
    }
    set summaryRootBackground(v) {
        this.i.qe = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    get summarySectionBackground() {
        return brushToString(this.i.qi);
    }
    set summarySectionBackground(v) {
        this.i.qi = stringToBrush(v);
    }
    /**
     * Gets or sets the default opacity to use for pinned rows
    */
    get pinnedRowOpacity() {
        return this.i.ha;
    }
    set pinnedRowOpacity(v) {
        this.i.ha = +v;
    }
    /**
     * Gets or sets the default color to use for sticky rows
    */
    get stickyRowBackground() {
        return brushToString(this.i.qd);
    }
    set stickyRowBackground(v) {
        this.i.qd = stringToBrush(v);
    }
    /**
     * Gets or sets the default color to use for pinned rows
    */
    get pinnedRowBackground() {
        return brushToString(this.i.p5);
    }
    set pinnedRowBackground(v) {
        this.i.p5 = stringToBrush(v);
    }
    /**
     * Gets or sets the default color to use for the last sticky row
    */
    get lastStickyRowBackground() {
        return brushToString(this.i.p4);
    }
    set lastStickyRowBackground(v) {
        this.i.p4 = stringToBrush(v);
    }
    /**
     * Gets or sets the position of the active cell.
    */
    get activeCell() {
        if (this.i.ca == null) {
            return null;
        }
        if (!this.i.ca.externalObject) {
            let e = new IgxGridCellPosition();
            e._implementation = this.i.ca;
            this.i.ca.externalObject = e;
        }
        return this.i.ca.externalObject;
    }
    set activeCell(v) {
        v == null ? this.i.ca = null : this.i.ca = v.i;
    }
    /**
     * Gets or sets the default background color to use for content cells
    */
    get cellBackground() {
        return brushToString(this.i.pv);
    }
    set cellBackground(v) {
        this.i.pv = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for content cells
    */
    get cellTextColor() {
        return brushToString(this.i.px);
    }
    set cellTextColor(v) {
        this.i.px = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for content cells
    */
    get headerSortIndicatorColor() {
        return brushToString(this.i.p2);
    }
    set headerSortIndicatorColor(v) {
        this.i.p2 = stringToBrush(v);
    }
    /**
     * Gets or sets the default render style for sort indicators in header cells.
    */
    get headerSortIndicatorStyle() {
        return this.i.dz;
    }
    set headerSortIndicatorStyle(v) {
        this.i.dz = ensureEnum(SortIndicatorStyle_$type, v);
    }
    /**
     * Gets or sets the font to use for content cells
    */
    get cellTextStyle() {
        if (this.i.eh == null) {
            return null;
        }
        return this.i.eh.fontString;
    }
    set cellTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.eh = fi;
    }
    /**
     * Gets or sets the default background color to use for section header cells
    */
    get sectionHeaderBackground() {
        return brushToString(this.i.qa);
    }
    set sectionHeaderBackground(v) {
        this.i.qa = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for section header cells
    */
    get sectionHeaderTextColor() {
        return brushToString(this.i.qc);
    }
    set sectionHeaderTextColor(v) {
        this.i.qc = stringToBrush(v);
    }
    /**
     * Gets or sets the font to use for section header cells
    */
    get sectionHeaderTextStyle() {
        if (this.i.ej == null) {
            return null;
        }
        return this.i.ej.fontString;
    }
    set sectionHeaderTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.ej = fi;
    }
    /**
     * Gets or sets the default text color to use for summary cells at the root level.
    */
    get summaryRootTextColor() {
        return brushToString(this.i.qh);
    }
    set summaryRootTextColor(v) {
        this.i.qh = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for summary cells at the section level.
    */
    get summarySectionTextColor() {
        return brushToString(this.i.ql);
    }
    set summarySectionTextColor(v) {
        this.i.ql = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for summary names in summary cells at the root level.
    */
    get summaryRootNameTextColor() {
        return brushToString(this.i.qf);
    }
    set summaryRootNameTextColor(v) {
        this.i.qf = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for summary names in summary cells at the section level.
    */
    get summarySectionNameTextColor() {
        return brushToString(this.i.qj);
    }
    set summarySectionNameTextColor(v) {
        this.i.qj = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    get summaryRootSelectedBackground() {
        return brushToString(this.i.qg);
    }
    set summaryRootSelectedBackground(v) {
        this.i.qg = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    get summarySectionSelectedBackground() {
        return brushToString(this.i.qk);
    }
    set summarySectionSelectedBackground(v) {
        this.i.qk = stringToBrush(v);
    }
    /**
     * Gets or sets the font to use for summary cells
    */
    get summaryTextStyle() {
        if (this.i.el == null) {
            return null;
        }
        return this.i.el.fontString;
    }
    set summaryTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.el = fi;
    }
    /**
     * Gets or sets the font to use for header cells
    */
    get summarySectionTextStyle() {
        if (this.i.ek == null) {
            return null;
        }
        return this.i.ek.fontString;
    }
    set summarySectionTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.ek = fi;
    }
    /**
     * Gets or sets the default background color to use for header separators.
    */
    get headerSeparatorWidth() {
        return this.i.ip;
    }
    set headerSeparatorWidth(v) {
        this.i.ip = +v;
    }
    /**
     * Gets or sets the default background color to use for header separators.
    */
    get headerSeparatorBackground() {
        return brushToString(this.i.p1);
    }
    set headerSeparatorBackground(v) {
        this.i.p1 = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for header cells
    */
    get headerBackground() {
        return brushToString(this.i.p0);
    }
    set headerBackground(v) {
        this.i.p0 = stringToBrush(v);
    }
    /**
     * Gets or sets the default text color to use for header cells
    */
    get headerTextColor() {
        return brushToString(this.i.p3);
    }
    set headerTextColor(v) {
        this.i.p3 = stringToBrush(v);
    }
    /**
     * Gets or sets the font to use for header cells
    */
    get headerTextStyle() {
        if (this.i.ei == null) {
            return null;
        }
        return this.i.ei.fontString;
    }
    set headerTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.ei = fi;
    }
    /**
     * Gets or sets the default background color to use for row separators
    */
    get rowSeparatorBackground() {
        return brushToString(this.i.p6);
    }
    set rowSeparatorBackground(v) {
        this.i.p6 = stringToBrush(v);
    }
    /**
     * Gets or sets the default sticky row background color to use for row separators
    */
    get rowSeparatorStickyRowBackground() {
        return brushToString(this.i.p9);
    }
    set rowSeparatorStickyRowBackground(v) {
        this.i.p9 = stringToBrush(v);
    }
    /**
     * Gets or sets the default last sticky row background color to use for row separators
    */
    get rowSeparatorLastStickyRowBackground() {
        return brushToString(this.i.p7);
    }
    set rowSeparatorLastStickyRowBackground(v) {
        this.i.p7 = stringToBrush(v);
    }
    /**
     * Gets or sets the pinned row background color to use for row separators
    */
    get rowSeparatorPinnedRowBackground() {
        return brushToString(this.i.p8);
    }
    set rowSeparatorPinnedRowBackground(v) {
        this.i.p8 = stringToBrush(v);
    }
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    get columnResizingSeparatorWidth() {
        return this.i.h3;
    }
    set columnResizingSeparatorWidth(v) {
        this.i.h3 = +v;
    }
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    get columnMovingSeparatorWidth() {
        return this.i.h1;
    }
    set columnMovingSeparatorWidth(v) {
        this.i.h1 = +v;
    }
    /**
     * Gets or sets the default background color to use for column resizing separator.
    */
    get columnResizingSeparatorBackground() {
        return brushToString(this.i.pz);
    }
    set columnResizingSeparatorBackground(v) {
        this.i.pz = stringToBrush(v);
    }
    /**
     * Gets or sets the default background color to use for column moving separator.
    */
    get columnMovingSeparatorBackground() {
        return brushToString(this.i.py);
    }
    set columnMovingSeparatorBackground(v) {
        this.i.py = stringToBrush(v);
    }
    /**
     * A set of states that can be applied to the columns of the grid based on available space.
    */
    get responsiveStates() {
        if (this._responsiveStates === null) {
            let coll = new IgxResponsiveStatesCollection();
            let innerColl = this.i.dl;
            if (!innerColl) {
                innerColl = new ResponsiveStatesCollection_internal();
            }
            this._responsiveStates = coll._fromInner(innerColl);
        }
        return this._responsiveStates;
    }
    set responsiveStates(v) {
        if (this._responsiveStates !== null) {
            this._responsiveStates._setSyncTarget(null);
            this._responsiveStates = null;
        }
        let coll = new IgxResponsiveStatesCollection();
        this._responsiveStates = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(ResponsiveState.$type);
        let innerColl = this.i.dl;
        if (!innerColl) {
            innerColl = new ResponsiveStatesCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._responsiveStates._setSyncTarget(syncColl);
    }
    /**
     * Gets the region of the grid that is visible.
    */
    get actualVisibleRegion() {
        return fromRect(this.i.qn);
    }
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get sortDescriptions() {
        if (this.i.bq == null) {
            return null;
        }
        if (!this.i.bq.externalObject) {
            let e = new IgxColumnSortDescriptionCollection();
            e._implementation = this.i.bq;
            this.i.bq.externalObject = e;
        }
        return this.i.bq.externalObject;
    }
    /**
     * Gets the current grouping that is applied to the grid. Collection can be updated to modify the grouping for the grid. Once grouping descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get groupDescriptions() {
        if (this.i.az == null) {
            return null;
        }
        if (!this.i.az.externalObject) {
            let e = new IgxColumnGroupDescriptionCollection();
            e._implementation = this.i.az;
            this.i.az.externalObject = e;
        }
        return this.i.az.externalObject;
    }
    /**
     * Gets the current filter that is applied to the grid. Collection can be updated to modify the filter for the grid. Once filter expresisons are in this collection, the grid will no longer listen for changes on their properties.
    */
    get filterExpressions() {
        if (this.i.t == null) {
            return null;
        }
        if (!this.i.t.externalObject) {
            let e = new IgxFilterExpressionCollection();
            e._implementation = this.i.t;
            this.i.t.externalObject = e;
        }
        return this.i.t.externalObject;
    }
    /**
     * Gets the current summaries that are applied to the grid.
    */
    get summaryDescriptions() {
        if (this.i.bt == null) {
            return null;
        }
        if (!this.i.bt.externalObject) {
            let e = new IgxColumnSummaryDescriptionCollection();
            e._implementation = this.i.bt;
            this.i.bt.externalObject = e;
        }
        return this.i.bt.externalObject;
    }
    /**
     * Gets or sets the scope which summaries are calculated for.
    */
    get summaryScope() {
        return this.i.r;
    }
    set summaryScope(v) {
        this.i.r = ensureEnum(DataSourceSummaryScope_$type, v);
    }
    /**
     * Gets or sets whether group headers are collapsable.
    */
    get isGroupCollapsable() {
        return this.i.ft;
    }
    set isGroupCollapsable(v) {
        this.i.ft = ensureBool(v);
    }
    get groupHeaderDisplayMode() {
        return this.i.p;
    }
    set groupHeaderDisplayMode(v) {
        this.i.p = ensureEnum(DataSourceSectionHeaderDisplayMode_$type, v);
    }
    /**
     * Gets or sets whether groups are expanded or collapsed by default.
    */
    get isGroupExpandedDefault() {
        return this.i.fu;
    }
    set isGroupExpandedDefault(v) {
        this.i.fu = ensureBool(v);
    }
    /**
     * Gets or sets the display mode summaries will use inside groups.
    */
    get groupSummaryDisplayMode() {
        return this.i.c2;
    }
    set groupSummaryDisplayMode(v) {
        this.i.c2 = ensureEnum(GroupSummaryDisplayMode_$type, v);
    }
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    get primaryKey() {
        return this.i.j;
    }
    set primaryKey(v) {
        this.i.j = v;
    }
    /**
     * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
    */
    get actualPrimaryKey() {
        return this.i.d;
    }
    set actualPrimaryKey(v) {
        this.i.d = v;
    }
    get actualColumns() {
        if (this._actualColumns === null) {
            let coll = new IgxGridColumnCollection();
            let innerColl = this.i.actualColumns;
            if (!innerColl) {
                innerColl = new GridColumnCollection_internal();
            }
            this._actualColumns = coll._fromInner(innerColl);
        }
        return this._actualColumns;
    }
    set actualColumns(v) {
        if (this._actualColumns !== null) {
            this._actualColumns._setSyncTarget(null);
            this._actualColumns = null;
        }
        let coll = new IgxGridColumnCollection();
        this._actualColumns = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Column.$type);
        let innerColl = this.i.actualColumns;
        if (!innerColl) {
            innerColl = new GridColumnCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._actualColumns._setSyncTarget(syncColl);
    }
    /**
     * Sets or gets whether the grid will react to sort changes.
    */
    get reactsToSortChanges() {
        return this.i.gh;
    }
    set reactsToSortChanges(v) {
        this.i.gh = ensureBool(v);
    }
    /**
     * Sets or gets whether the grid will react to group changes.
    */
    get reactsToGroupChanges() {
        return this.i.gg;
    }
    set reactsToGroupChanges(v) {
        this.i.gg = ensureBool(v);
    }
    /**
     * Sets or gets whether the grid will react to filter changes.
    */
    get reactsToFilterChanges() {
        return this.i.gf;
    }
    set reactsToFilterChanges(v) {
        this.i.gf = ensureBool(v);
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LiveGridComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this.sectionHeader && this.sectionHeader._styling) {
            this.sectionHeader._styling(container, component, this);
        }
        if (this.summaryRowRoot && this.summaryRowRoot._styling) {
            this.summaryRowRoot._styling(container, component, this);
        }
        if (this.summaryRowSection && this.summaryRowSection._styling) {
            this.summaryRowSection._styling(container, component, this);
        }
        if (this.rowSeparator && this.rowSeparator._styling) {
            this.rowSeparator._styling(container, component, this);
        }
        if (this.headerSeparator && this.headerSeparator._styling) {
            this.headerSeparator._styling(container, component, this);
        }
        if (this.columnResizingSeparator && this.columnResizingSeparator._styling) {
            this.columnResizingSeparator._styling(container, component, this);
        }
        if (this.columnMovingSeparator && this.columnMovingSeparator._styling) {
            this.columnMovingSeparator._styling(container, component, this);
        }
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    getHitCell(x, y) {
        let iv = this.i.al(x, y);
        return (iv == null ? null : iv.externalObject);
    }
    /**
     * Forces a refresh of the grid content.
    
    */
    refresh() {
        this.i.n9();
    }
    /**
     * Makes sure pending work has completed if the grid need to be synchronously examined.
    
    */
    flush() {
        this.i.ma();
    }
    exchangeColumn(newColumn, oldColumn) {
        this.i.l9((newColumn == null ? null : newColumn.i), (oldColumn == null ? null : oldColumn.i));
    }
    moveColumn(oldIndex, newIndex) {
        this.i.mk(oldIndex, newIndex);
    }
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel() {
        let iv = this.i.i0();
        return (iv);
    }
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel() {
        let iv = this.i.j0();
        return (iv);
    }
    /**
     * Scrolls the grid to given row, by index
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToRowByIndex(rowNumber) {
        this.i.on(rowNumber);
    }
    /**
     * Scrolls the grid so that a row is the last visible, by index.
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToLastRowByIndex(rowNumber) {
        this.i.om(rowNumber);
    }
    /**
     * Scrolls to an item, if found.
    
    * @param item  * The item to scroll to.
    */
    scrollToItem(item) {
        let iv = this.i.gm(item);
        return (iv);
    }
    scrollToPrimaryKey(key) {
        let iv = this.i.gn(key);
        return (iv);
    }
    /**
     * Scrolls the grid to given column, by index
    
    * @param columnNumber  * The column number to scroll to.
    */
    scrollToColumnByIndex(columnNumber) {
        this.i.ok(columnNumber);
    }
    /**
     * Gets the last visible index in the grid.
    
    */
    getLastVisibleIndex() {
        let iv = this.i.ig();
        return (iv);
    }
    /**
     * Gets the first visible index in the grid.
    
    */
    getFirstVisibleIndex() {
        let iv = this.i.ic();
        return (iv);
    }
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    invalidateVisibleRows() {
        this.i.mj();
    }
    /**
     * Manually set the active responsive state of the grid.
    
    * @param name
    */
    setActiveResponsiveState(name) {
        this.i.ot(name);
    }
    notifySetItem(index, oldItem, newItem) {
        this.i.mq(index, oldItem, newItem);
    }
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems() {
        this.i.mm();
    }
    notifyInsertItem(index, newItem) {
        this.i.mo(index, newItem);
    }
    notifyRemoveItem(index, oldItem) {
        this.i.mp(index, oldItem);
    }
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    dataIndexOfItem(item) {
        let iv = this.i.h5(item);
        return (iv);
    }
    dataIndexOfPrimaryKey(key) {
        let iv = this.i.h6(key);
        return (iv);
    }
    /**
     * Resolves the value of a specific cell.
    
    * @param cellKey  * The cell to resolve.
    */
    resolveCellValue(cellKey) {
        let iv = this.i.i2((cellKey == null ? null : cellKey.i));
        return (iv);
    }
    resolveCellValueFromPosition(row, column) {
        let iv = this.i.i3(row, column);
        return (iv);
    }
    /**
     * Gets the summary results for root level.
    
    */
    getRootSummaryResults() {
        let iv = this.i.h();
        return (iv);
    }
    /**
     * Gets the summary results for a specific section.
    
    */
    getSectionSummaryResults(sectionIndex) {
        let iv = this.i.i(sectionIndex);
        return (iv);
    }
    get filterExpressionsChanging() {
        if (this._filterExpressionsChanging == null) {
            this._filterExpressionsChanging = new EventEmitter();
            this.i.filterExpressionsChanging = delegateCombine(this.i.filterExpressionsChanging, (o, e) => {
                let outerArgs = new IgxGridFilterExpressionsEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeFilterExpressionsChanging) {
                    this.beforeFilterExpressionsChanging(this, outerArgs);
                }
                this._filterExpressionsChanging.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._filterExpressionsChanging;
    }
    get filterExpressionsChanged() {
        if (this._filterExpressionsChanged == null) {
            this._filterExpressionsChanged = new EventEmitter();
            this.i.filterExpressionsChanged = delegateCombine(this.i.filterExpressionsChanged, (o, e) => {
                let outerArgs = new IgxGridFilterExpressionsEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeFilterExpressionsChanged) {
                    this.beforeFilterExpressionsChanged(this, outerArgs);
                }
                this._filterExpressionsChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._filterExpressionsChanged;
    }
    /**
     * Previews that a pointer is down on a cell.
    */
    get cellPreviewPointerDown() {
        if (this._cellPreviewPointerDown == null) {
            this._cellPreviewPointerDown = new EventEmitter();
            this.i.cellPreviewPointerDown = delegateCombine(this.i.cellPreviewPointerDown, (o, e) => {
                let outerArgs = new IgxGridCellEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellPreviewPointerDown) {
                    this.beforeCellPreviewPointerDown(this, outerArgs);
                }
                this._cellPreviewPointerDown.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellPreviewPointerDown;
    }
    /**
     * Previews that a pointer is up on a cell.
    */
    get cellPreviewPointerUp() {
        if (this._cellPreviewPointerUp == null) {
            this._cellPreviewPointerUp = new EventEmitter();
            this.i.cellPreviewPointerUp = delegateCombine(this.i.cellPreviewPointerUp, (o, e) => {
                let outerArgs = new IgxGridCellEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellPreviewPointerUp) {
                    this.beforeCellPreviewPointerUp(this, outerArgs);
                }
                this._cellPreviewPointerUp.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellPreviewPointerUp;
    }
    /**
     * Indicates a pointer is down on a cell.
    */
    get cellPointerDown() {
        if (this._cellPointerDown == null) {
            this._cellPointerDown = new EventEmitter();
            this.i.cellPointerDown = delegateCombine(this.i.cellPointerDown, (o, e) => {
                let outerArgs = new IgxGridCellEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellPointerDown) {
                    this.beforeCellPointerDown(this, outerArgs);
                }
                this._cellPointerDown.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellPointerDown;
    }
    /**
     * Indicates a pointer is up on a cell.
    */
    get cellPointerUp() {
        if (this._cellPointerUp == null) {
            this._cellPointerUp = new EventEmitter();
            this.i.cellPointerUp = delegateCombine(this.i.cellPointerUp, (o, e) => {
                let outerArgs = new IgxGridCellEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellPointerUp) {
                    this.beforeCellPointerUp(this, outerArgs);
                }
                this._cellPointerUp.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellPointerUp;
    }
    /**
     * Called when a cell is clicked.
    */
    get cellClicked() {
        if (this._cellClicked == null) {
            this._cellClicked = new EventEmitter();
            this.i.cellClicked = delegateCombine(this.i.cellClicked, (o, e) => {
                let outerArgs = new IgxGridCellEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellClicked) {
                    this.beforeCellClicked(this, outerArgs);
                }
                this._cellClicked.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellClicked;
    }
    /**
     * Called when sorting has changed.
    */
    get sortDescriptionsChanged() {
        if (this._sortDescriptionsChanged == null) {
            this._sortDescriptionsChanged = new EventEmitter();
            this.i.sortDescriptionsChanged = delegateCombine(this.i.sortDescriptionsChanged, (o, e) => {
                let outerArgs = new IgxGridSortDescriptionsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSortDescriptionsChanged) {
                    this.beforeSortDescriptionsChanged(this, outerArgs);
                }
                this._sortDescriptionsChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._sortDescriptionsChanged;
    }
    /**
     * Called when grouping has changed.
    */
    get groupDescriptionsChanged() {
        if (this._groupDescriptionsChanged == null) {
            this._groupDescriptionsChanged = new EventEmitter();
            this.i.groupDescriptionsChanged = delegateCombine(this.i.groupDescriptionsChanged, (o, e) => {
                let outerArgs = new IgxGridGroupDescriptionsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeGroupDescriptionsChanged) {
                    this.beforeGroupDescriptionsChanged(this, outerArgs);
                }
                this._groupDescriptionsChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._groupDescriptionsChanged;
    }
    /**
     * Called when the columns are autogenerated.
    */
    get columnsAutoGenerated() {
        if (this._columnsAutoGenerated == null) {
            this._columnsAutoGenerated = new EventEmitter();
            this.i.columnsAutoGenerated = delegateCombine(this.i.columnsAutoGenerated, (o, e) => {
                let outerArgs = new IgxGridColumnsAutoGeneratedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeColumnsAutoGenerated) {
                    this.beforeColumnsAutoGenerated(this, outerArgs);
                }
                this._columnsAutoGenerated.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._columnsAutoGenerated;
    }
    /**
     * Called when the selected items change.
    */
    get selectedItemsChanged() {
        if (this._selectedItemsChanged == null) {
            this._selectedItemsChanged = new EventEmitter();
            this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, (o, e) => {
                let outerArgs = new IgxGridSelectedItemsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSelectedItemsChanged) {
                    this.beforeSelectedItemsChanged(this, outerArgs);
                }
                this._selectedItemsChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._selectedItemsChanged;
    }
    /**
     * Called when the selected keys change.
    */
    get selectedKeysChanged() {
        if (this._selectedKeysChanged == null) {
            this._selectedKeysChanged = new EventEmitter();
            this.i.selectedKeysChanged = delegateCombine(this.i.selectedKeysChanged, (o, e) => {
                let outerArgs = new IgxGridSelectedKeysChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSelectedKeysChanged) {
                    this.beforeSelectedKeysChanged(this, outerArgs);
                }
                this._selectedKeysChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._selectedKeysChanged;
    }
    /**
     * Called when the selected cells change.
    */
    get selectedCellsChanged() {
        if (this._selectedCellsChanged == null) {
            this._selectedCellsChanged = new EventEmitter();
            this.i.selectedCellsChanged = delegateCombine(this.i.selectedCellsChanged, (o, e) => {
                let outerArgs = new IgxGridSelectedCellsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSelectedCellsChanged) {
                    this.beforeSelectedCellsChanged(this, outerArgs);
                }
                this._selectedCellsChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._selectedCellsChanged;
    }
    /**
     * Called when the active cell changes.
    */
    get activeCellChanged() {
        if (this._activeCellChanged == null) {
            this._activeCellChanged = new EventEmitter();
            this.i.activeCellChanged = delegateCombine(this.i.activeCellChanged, (o, e) => {
                let outerArgs = new IgxGridActiveCellChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeActiveCellChanged) {
                    this.beforeActiveCellChanged(this, outerArgs);
                }
                this._activeCellChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._activeCellChanged;
    }
    /**
     * Called when the selected cell ranges changed.
    */
    get selectedCellRangesChanged() {
        if (this._selectedCellRangesChanged == null) {
            this._selectedCellRangesChanged = new EventEmitter();
            this.i.selectedCellRangesChanged = delegateCombine(this.i.selectedCellRangesChanged, (o, e) => {
                let outerArgs = new IgxGridSelectedCellRangesChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSelectedCellRangesChanged) {
                    this.beforeSelectedCellRangesChanged(this, outerArgs);
                }
                this._selectedCellRangesChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._selectedCellRangesChanged;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
tslib_1.__decorate([
    ContentChildren(IgxColumnComponent),
    tslib_1.__metadata("design:type", QueryList)
], IgxLiveGridComponent.prototype, "contentColumns", void 0);
tslib_1.__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    tslib_1.__metadata("design:type", ViewContainerRef)
], IgxLiveGridComponent.prototype, "_dynamicContent", void 0);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "height", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "width", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "scrollbarStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Object),
    tslib_1.__metadata("design:paramtypes", [Object])
], IgxLiveGridComponent.prototype, "dataSource", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnResizingMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnMovingMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxSectionHeaderComponent),
    tslib_1.__metadata("design:paramtypes", [IgxSectionHeaderComponent])
], IgxLiveGridComponent.prototype, "sectionHeader", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxSummaryRowRootComponent),
    tslib_1.__metadata("design:paramtypes", [IgxSummaryRowRootComponent])
], IgxLiveGridComponent.prototype, "summaryRowRoot", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxSummaryRowSectionComponent),
    tslib_1.__metadata("design:paramtypes", [IgxSummaryRowSectionComponent])
], IgxLiveGridComponent.prototype, "summaryRowSection", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxRowSeparatorComponent),
    tslib_1.__metadata("design:paramtypes", [IgxRowSeparatorComponent])
], IgxLiveGridComponent.prototype, "rowSeparator", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxHeaderSeparatorComponent),
    tslib_1.__metadata("design:paramtypes", [IgxHeaderSeparatorComponent])
], IgxLiveGridComponent.prototype, "headerSeparator", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxColumnResizingSeparatorComponent),
    tslib_1.__metadata("design:paramtypes", [IgxColumnResizingSeparatorComponent])
], IgxLiveGridComponent.prototype, "columnResizingSeparator", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxColumnMovingSeparatorComponent),
    tslib_1.__metadata("design:paramtypes", [IgxColumnMovingSeparatorComponent])
], IgxLiveGridComponent.prototype, "columnMovingSeparator", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Array),
    tslib_1.__metadata("design:paramtypes", [Array])
], IgxLiveGridComponent.prototype, "dataSourceDesiredProperties", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "rowHeight", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "defaultColumnMinWidth", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "headerHeight", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "headerClickAction", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "autoGenerateColumns", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "rowSeparatorHeight", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isPlaceholderRenderingEnabled", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnAddingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnPropertyUpdatingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "cellDataLoadedAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "rowSelectionAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "cellSelectionAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridAnimationSettings),
    tslib_1.__metadata("design:paramtypes", [IgxGridAnimationSettings])
], IgxLiveGridComponent.prototype, "animationSettings", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnResizingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnShowingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnMovingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnHidingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnExchangingAnimationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "selectionMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "activationMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "selectionBehavior", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedItemsCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedItemsCollection])
], IgxLiveGridComponent.prototype, "selectedItems", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedKeysCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedKeysCollection])
], IgxLiveGridComponent.prototype, "selectedKeys", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedCellsCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedCellsCollection])
], IgxLiveGridComponent.prototype, "selectedCells", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedCellRangesCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedCellRangesCollection])
], IgxLiveGridComponent.prototype, "selectedCellRanges", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedItemsCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedItemsCollection])
], IgxLiveGridComponent.prototype, "pinnedItems", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridSelectedKeysCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridSelectedKeysCollection])
], IgxLiveGridComponent.prototype, "pinnedKeys", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isFilterUIEnabled", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isGroupRowSticky", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isHeaderSeparatorVisible", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "cellSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "sectionHeaderSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summaryRootBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summarySectionBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "pinnedRowOpacity", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "stickyRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "pinnedRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "lastStickyRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridCellPosition),
    tslib_1.__metadata("design:paramtypes", [IgxGridCellPosition])
], IgxLiveGridComponent.prototype, "activeCell", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "cellBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "cellTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "headerSortIndicatorColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "headerSortIndicatorStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "cellTextStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "sectionHeaderBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "sectionHeaderTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "sectionHeaderTextStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summaryRootTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summarySectionTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summaryRootNameTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summarySectionNameTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summaryRootSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summarySectionSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summaryTextStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "summarySectionTextStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "headerSeparatorWidth", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "headerSeparatorBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "headerBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "headerTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "headerTextStyle", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "rowSeparatorBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "rowSeparatorStickyRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "rowSeparatorLastStickyRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "rowSeparatorPinnedRowBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnResizingSeparatorWidth", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "columnMovingSeparatorWidth", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "columnResizingSeparatorBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridComponent.prototype, "columnMovingSeparatorBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxResponsiveStatesCollection),
    tslib_1.__metadata("design:paramtypes", [IgxResponsiveStatesCollection])
], IgxLiveGridComponent.prototype, "responsiveStates", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "summaryScope", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isGroupCollapsable", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "groupHeaderDisplayMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "isGroupExpandedDefault", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridComponent.prototype, "groupSummaryDisplayMode", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Array),
    tslib_1.__metadata("design:paramtypes", [Array])
], IgxLiveGridComponent.prototype, "primaryKey", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Array),
    tslib_1.__metadata("design:paramtypes", [Array])
], IgxLiveGridComponent.prototype, "actualPrimaryKey", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxGridColumnCollection),
    tslib_1.__metadata("design:paramtypes", [IgxGridColumnCollection])
], IgxLiveGridComponent.prototype, "actualColumns", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "reactsToSortChanges", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "reactsToGroupChanges", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridComponent.prototype, "reactsToFilterChanges", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "filterExpressionsChanging", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "filterExpressionsChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "cellPreviewPointerDown", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "cellPreviewPointerUp", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "cellPointerDown", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "cellPointerUp", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "cellClicked", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "sortDescriptionsChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "groupDescriptionsChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "columnsAutoGenerated", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "selectedItemsChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "selectedKeysChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "selectedCellsChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "activeCellChanged", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridComponent.prototype, "selectedCellRangesChanged", null);
IgxLiveGridComponent = tslib_1.__decorate([
    Component({
        selector: 'igx-live-grid',
        styles: [`:host {
		display: block;
	}`],
        template: `
    <ng-container #dynamicContent></ng-container>
  `,
        host: { 'class': 'ig-live-grid igx-live-grid' },
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        ComponentFactoryResolver,
        Injector])
], IgxLiveGridComponent);
export { IgxLiveGridComponent };
//# sourceMappingURL=igx-live-grid-component.js.map