import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { ColumnSortDirection, ColumnSortDirection_$type } from "./ColumnSortDirection";
import { SortIndicatorStyle, SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { IgxSortIndicatorRenderCompletedEventArgs } from "./igx-sort-indicator-render-completed-event-args";
import { GridSortIndicator } from "./GridSortIndicator";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, ensureEnum, brushToString, stringToBrush, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
/**
 * An advanced grid for displaying data.
*/
export const IgxLiveGridSortIndicatorComponent_PROVIDERS = [];
let IgxLiveGridSortIndicatorComponent = class IgxLiveGridSortIndicatorComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._renderCompleted = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new GridSortIndicator();
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    get sortDirection() {
        return this.i.b;
    }
    set sortDirection(v) {
        this.i.b = ensureEnum(ColumnSortDirection_$type, v);
    }
    get iconColor() {
        return brushToString(this.i.ax);
    }
    set iconColor(v) {
        this.i.ax = stringToBrush(v);
    }
    get isAnimationEnabled() {
        return this.i.l;
    }
    set isAnimationEnabled(v) {
        this.i.l = ensureBool(v);
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.v;
    }
    set pixelScalingRatio(v) {
        this.i.v = +v;
    }
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio() {
        return this.i.o;
    }
    set actualPixelScalingRatio(v) {
        this.i.o = +v;
    }
    get sortIndicatorStyle() {
        return this.i.f;
    }
    set sortIndicatorStyle(v) {
        this.i.f = ensureEnum(SortIndicatorStyle_$type, v);
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LiveGridSortIndicatorComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    getDesiredScale() {
        let iv = this.i.u();
        return (iv);
    }
    notifySizeChanged(width, height) {
        this.i.ao(width, height);
    }
    get renderCompleted() {
        if (this._renderCompleted == null) {
            this._renderCompleted = new EventEmitter();
            this.i.renderCompleted = delegateCombine(this.i.renderCompleted, (o, e) => {
                let outerArgs = new IgxSortIndicatorRenderCompletedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeRenderCompleted) {
                    this.beforeRenderCompleted(this, outerArgs);
                }
                this._renderCompleted.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._renderCompleted;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridSortIndicatorComponent.prototype, "sortDirection", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxLiveGridSortIndicatorComponent.prototype, "iconColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxLiveGridSortIndicatorComponent.prototype, "isAnimationEnabled", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridSortIndicatorComponent.prototype, "pixelScalingRatio", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridSortIndicatorComponent.prototype, "actualPixelScalingRatio", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxLiveGridSortIndicatorComponent.prototype, "sortIndicatorStyle", null);
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridSortIndicatorComponent.prototype, "renderCompleted", null);
IgxLiveGridSortIndicatorComponent = tslib_1.__decorate([
    Component({
        selector: 'igx-live-grid-sort-indicator',
        template: ``,
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxLiveGridSortIndicatorComponent);
export { IgxLiveGridSortIndicatorComponent };
//# sourceMappingURL=igx-live-grid-sort-indicator-component.js.map