var IgxNumericColumnComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { NumericColumn } from "./NumericColumn";
import { ensureBool } from "igniteui-angular-core";
/**
 * Represents a Numeric grid column, used to allow the developer to display a formatted number in a cell.
*/
export const IgxNumericColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxNumericColumnComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxNumericColumnComponent) }];
let IgxNumericColumnComponent = IgxNumericColumnComponent_1 = class IgxNumericColumnComponent extends IgxColumnComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the string to prefix a negative value. If FormatString is specificied this value is ignored.
    */
    get negativePrefix() {
        return this.i.hf;
    }
    set negativePrefix(v) {
        this.i.hf = v;
    }
    /**
     * Gets or sets the string to prefix a positive value. If FormatString is specificied this value is ignored.
    */
    get positivePrefix() {
        return this.i.hj;
    }
    set positivePrefix(v) {
        this.i.hj = v;
    }
    /**
     * Gets or sets the string to suffix a negative value. If FormatString is specificied this value is ignored.
    */
    get negativeSuffix() {
        return this.i.hh;
    }
    set negativeSuffix(v) {
        this.i.hh = v;
    }
    /**
     * Gets or sets the string to suffix a positive value. If FormatString is specificied this value is ignored.
    */
    get positiveSuffix() {
        return this.i.hl;
    }
    set positiveSuffix(v) {
        this.i.hl = v;
    }
    /**
     * Gets or sets the maximum fraction digits. If FormatString is specificied this value is ignored.
    */
    get maxFractionDigits() {
        return this.i.gz;
    }
    set maxFractionDigits(v) {
        this.i.gz = +v;
    }
    /**
     * Gets or sets the minimum fraction digits. If FormatString is specificied this value is ignored.
    */
    get minFractionDigits() {
        return this.i.g0;
    }
    set minFractionDigits(v) {
        this.i.g0 = +v;
    }
    /**
     * Gets or sets the minimum integer digits. If FormatString is specificied this value is ignored.
    */
    get minIntegerDigits() {
        return this.i.g1;
    }
    set minIntegerDigits(v) {
        this.i.g1 = +v;
    }
    /**
     * Gets or sets whether to show a grouping separator. If FormatString is specificied this value is ignored.
    */
    get showGroupingSeparator() {
        return this.i.gu;
    }
    set showGroupingSeparator(v) {
        this.i.gu = ensureBool(v);
    }
    /**
     * Gets or sets the INTL NumericFormat object to use for formatting the date values.
    */
    get formatOverride() {
        return this.i.g3;
    }
    set formatOverride(v) {
        this.i.g3 = v;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxNumericColumnComponent.prototype, "negativePrefix", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxNumericColumnComponent.prototype, "positivePrefix", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxNumericColumnComponent.prototype, "negativeSuffix", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxNumericColumnComponent.prototype, "positiveSuffix", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxNumericColumnComponent.prototype, "maxFractionDigits", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxNumericColumnComponent.prototype, "minFractionDigits", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxNumericColumnComponent.prototype, "minIntegerDigits", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxNumericColumnComponent.prototype, "showGroupingSeparator", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Object),
    tslib_1.__metadata("design:paramtypes", [Object])
], IgxNumericColumnComponent.prototype, "formatOverride", null);
IgxNumericColumnComponent = IgxNumericColumnComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-numeric-column',
        template: ``,
        providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxNumericColumnComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxNumericColumnComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxNumericColumnComponent);
export { IgxNumericColumnComponent };
//# sourceMappingURL=igx-numeric-column-component.js.map