import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgxCellInfo } from "./igx-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for a section header cell in the grid.
*/
export class IgxSectionHeaderCellInfo extends IgxCellInfo {
    createImplementation() {
        return new SectionHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resolved text for the section header cell.
    */
    get resolvedText() {
        return this.i.iy;
    }
    set resolvedText(v) {
        this.i.iy = v;
    }
    /**
     * Sets or gets the resolved summary text for the section header cell.
    */
    get resolvedSummaryText() {
        return this.i.iw;
    }
    set resolvedSummaryText(v) {
        this.i.iw = v;
    }
    /**
     * Sets or gets how summaries are displayed in the section header cell.
    */
    get summaryDisplayMode() {
        return this.i.im;
    }
    set summaryDisplayMode(v) {
        this.i.im = ensureEnum(GroupSummaryDisplayMode_$type, v);
    }
}
//# sourceMappingURL=igx-section-header-cell-info.js.map