var IgxSectionHeaderComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { GroupSummaryDisplayMode, GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SectionHeader } from "./SectionHeader";
import { brushToString, stringToBrush, ensureBool, ensureEnum } from "igniteui-angular-core";
/**
 * Used to configure the appearance of the section header cells.
*/
export const IgxSectionHeaderComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxSectionHeaderComponent) }];
let IgxSectionHeaderComponent = IgxSectionHeaderComponent_1 = class IgxSectionHeaderComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SectionHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    get selectedBackground() {
        return brushToString(this.i.es);
    }
    set selectedBackground(v) {
        this.i.es = stringToBrush(v);
    }
    get actualSelectedBackground() {
        return brushToString(this.i.er);
    }
    set actualSelectedBackground(v) {
        this.i.er = stringToBrush(v);
    }
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft() {
        return this.i.eb;
    }
    set paddingLeft(v) {
        this.i.eb = +v;
    }
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop() {
        return this.i.ed;
    }
    set paddingTop(v) {
        this.i.ed = +v;
    }
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight() {
        return this.i.ec;
    }
    set paddingRight(v) {
        this.i.ec = +v;
    }
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom() {
        return this.i.ea;
    }
    set paddingBottom(v) {
        this.i.ea = +v;
    }
    get isCollapsable() {
        return this.i.d5;
    }
    set isCollapsable(v) {
        this.i.d5 = ensureBool(v);
    }
    get summaryDisplayMode() {
        return this.i.d2;
    }
    set summaryDisplayMode(v) {
        this.i.d2 = ensureEnum(GroupSummaryDisplayMode_$type, v);
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSectionHeaderComponent.prototype, "selectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSectionHeaderComponent.prototype, "actualSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSectionHeaderComponent.prototype, "paddingLeft", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSectionHeaderComponent.prototype, "paddingTop", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSectionHeaderComponent.prototype, "paddingRight", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSectionHeaderComponent.prototype, "paddingBottom", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Boolean),
    tslib_1.__metadata("design:paramtypes", [Boolean])
], IgxSectionHeaderComponent.prototype, "isCollapsable", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSectionHeaderComponent.prototype, "summaryDisplayMode", null);
IgxSectionHeaderComponent = IgxSectionHeaderComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-section-header',
        template: ``,
        providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxSectionHeaderComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxSectionHeaderComponent);
export { IgxSectionHeaderComponent };
//# sourceMappingURL=igx-section-header-component.js.map