import { IgxCellInfo } from "./igx-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
import { brushToString, stringToBrush } from "igniteui-angular-core";
/**
 * Backing information for a section header cell in the grid.
*/
export class IgxSummaryCellInfo extends IgxCellInfo {
    createImplementation() {
        return new SummaryCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resolved summary text for the summary cell.
    */
    get resolvedSummaryText() {
        return this.i.im;
    }
    set resolvedSummaryText(v) {
        this.i.im = v;
    }
    /**
     * Sets or gets the resolved summary value for the sumamry cell.
    */
    get resolvedSummaryValue() {
        return this.i.ip;
    }
    set resolvedSummaryValue(v) {
        this.i.ip = v;
    }
    /**
     * Gets or sets the color of the text for the summary name in the cell.
    */
    get summaryNameTextColor() {
        return brushToString(this.i.it);
    }
    set summaryNameTextColor(v) {
        this.i.it = stringToBrush(v);
    }
}
//# sourceMappingURL=igx-summary-cell-info.js.map