import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { brushToString, stringToBrush } from "igniteui-angular-core";
export const IgxSummaryRowComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxSummaryRowComponent) }];
export class IgxSummaryRowComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    get selectedBackground() {
        return brushToString(this.i.eq);
    }
    set selectedBackground(v) {
        this.i.eq = stringToBrush(v);
    }
    get actualSelectedBackground() {
        return brushToString(this.i.en);
    }
    set actualSelectedBackground(v) {
        this.i.en = stringToBrush(v);
    }
    get summaryNameTextColor() {
        return brushToString(this.i.er);
    }
    set summaryNameTextColor(v) {
        this.i.er = stringToBrush(v);
    }
    get actualSummaryNameTextColor() {
        return brushToString(this.i.eo);
    }
    set actualSummaryNameTextColor(v) {
        this.i.eo = stringToBrush(v);
    }
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft() {
        return this.i.d5;
    }
    set paddingLeft(v) {
        this.i.d5 = +v;
    }
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop() {
        return this.i.d7;
    }
    set paddingTop(v) {
        this.i.d7 = +v;
    }
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight() {
        return this.i.d6;
    }
    set paddingRight(v) {
        this.i.d6 = +v;
    }
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom() {
        return this.i.d4;
    }
    set paddingBottom(v) {
        this.i.d4 = +v;
    }
}
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSummaryRowComponent.prototype, "selectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSummaryRowComponent.prototype, "actualSelectedBackground", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSummaryRowComponent.prototype, "summaryNameTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxSummaryRowComponent.prototype, "actualSummaryNameTextColor", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSummaryRowComponent.prototype, "paddingLeft", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSummaryRowComponent.prototype, "paddingTop", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSummaryRowComponent.prototype, "paddingRight", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxSummaryRowComponent.prototype, "paddingBottom", null);
//# sourceMappingURL=igx-summary-row-component.js.map