var IgxTemplateColumnComponent_1;
import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateCellUpdatingEventArgs } from "./igx-template-cell-updating-event-args";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateColumn } from "./TemplateColumn";
/**
 * A column with customizable content.
*/
export const IgxTemplateColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxTemplateColumnComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateColumnComponent) }];
let IgxTemplateColumnComponent = IgxTemplateColumnComponent_1 = class IgxTemplateColumnComponent extends IgxColumnComponent {
    constructor() {
        super();
        this._cellUpdating = null;
    }
    createImplementation() {
        return new TemplateColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Called when the cell content is being created or updated.
    */
    get cellUpdating() {
        if (this._cellUpdating == null) {
            this._cellUpdating = new EventEmitter();
            this.i.cellUpdating = delegateCombine(this.i.cellUpdating, (o, e) => {
                let outerArgs = new IgxTemplateCellUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellUpdating) {
                    this.beforeCellUpdating(this, outerArgs);
                }
                this._cellUpdating.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellUpdating;
    }
};
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateColumnComponent.prototype, "cellUpdating", null);
IgxTemplateColumnComponent = IgxTemplateColumnComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-template-column',
        template: ``,
        providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxTemplateColumnComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateColumnComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateColumnComponent);
export { IgxTemplateColumnComponent };
//# sourceMappingURL=igx-template-column-component.js.map