var IgxTemplateHeaderComponent_1;
import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateHeaderCellUpdatingEventArgs } from "./igx-template-header-cell-updating-event-args";
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateHeader } from "./TemplateHeader";
/**
 * A type of header with customizable content.
*/
export const IgxTemplateHeaderComponent_PROVIDERS = [{ provide: IgxHeaderComponent, useExisting: forwardRef(() => IgxTemplateHeaderComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateHeaderComponent) }];
let IgxTemplateHeaderComponent = IgxTemplateHeaderComponent_1 = class IgxTemplateHeaderComponent extends IgxHeaderComponent {
    constructor() {
        super();
        this._cellUpdating = null;
    }
    createImplementation() {
        return new TemplateHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Called when the header cell content is being created or updated.
    */
    get cellUpdating() {
        if (this._cellUpdating == null) {
            this._cellUpdating = new EventEmitter();
            this.i.cellUpdating = delegateCombine(this.i.cellUpdating, (o, e) => {
                let outerArgs = new IgxTemplateHeaderCellUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellUpdating) {
                    this.beforeCellUpdating(this, outerArgs);
                }
                this._cellUpdating.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellUpdating;
    }
};
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateHeaderComponent.prototype, "cellUpdating", null);
IgxTemplateHeaderComponent = IgxTemplateHeaderComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-template-header',
        template: ``,
        providers: [{ provide: IgxHeaderComponent, useExisting: forwardRef(() => IgxTemplateHeaderComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateHeaderComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateHeaderComponent);
export { IgxTemplateHeaderComponent };
//# sourceMappingURL=igx-template-header-component.js.map