var IgxTemplateSectionHeaderComponent_1;
import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateSectionHeaderCellUpdatingEventArgs } from "./igx-template-section-header-cell-updating-event-args";
import { IgxSectionHeaderComponent } from "./igx-section-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export const IgxTemplateSectionHeaderComponent_PROVIDERS = [{ provide: IgxSectionHeaderComponent, useExisting: forwardRef(() => IgxTemplateSectionHeaderComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateSectionHeaderComponent) }];
let IgxTemplateSectionHeaderComponent = IgxTemplateSectionHeaderComponent_1 = class IgxTemplateSectionHeaderComponent extends IgxSectionHeaderComponent {
    constructor() {
        super();
        this._cellUpdating = null;
    }
    createImplementation() {
        return new TemplateSectionHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Called when the cell content is being created or updated.
    */
    get cellUpdating() {
        if (this._cellUpdating == null) {
            this._cellUpdating = new EventEmitter();
            this.i.cellUpdating = delegateCombine(this.i.cellUpdating, (o, e) => {
                let outerArgs = new IgxTemplateSectionHeaderCellUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCellUpdating) {
                    this.beforeCellUpdating(this, outerArgs);
                }
                this._cellUpdating.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._cellUpdating;
    }
};
tslib_1.__decorate([
    Output(),
    tslib_1.__metadata("design:type", EventEmitter),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateSectionHeaderComponent.prototype, "cellUpdating", null);
IgxTemplateSectionHeaderComponent = IgxTemplateSectionHeaderComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-template-section-header',
        template: ``,
        providers: [{ provide: IgxSectionHeaderComponent, useExisting: forwardRef(() => IgxTemplateSectionHeaderComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTemplateSectionHeaderComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTemplateSectionHeaderComponent);
export { IgxTemplateSectionHeaderComponent };
//# sourceMappingURL=igx-template-section-header-component.js.map