import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
import { ensureBool, ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for a text header cell.
*/
export class IgxTextHeaderCellInfo extends IgxTextCellInfo {
    createImplementation() {
        return new TextHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isFilterUIVisible() {
        return this.i.ip;
    }
    set isFilterUIVisible(v) {
        this.i.ip = ensureBool(v);
    }
    get sortIndicatorStyle() {
        return this.i.im;
    }
    set sortIndicatorStyle(v) {
        this.i.im = ensureEnum(SortIndicatorStyle_$type, v);
    }
}
//# sourceMappingURL=igx-text-header-cell-info.js.map