import { CellStyleRequestedEventArgs as CellStyleRequestedEventArgs_internal } from "./CellStyleRequestedEventArgs";
/**
 * Information about the style request for a cell.
*/
var IgxCellStyleRequestedEventArgs = /** @class */ (function () {
    function IgxCellStyleRequestedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxCellStyleRequestedEventArgs.prototype.createImplementation = function () {
        return new CellStyleRequestedEventArgs_internal();
    };
    Object.defineProperty(IgxCellStyleRequestedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxCellStyleRequestedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxCellStyleRequestedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxCellStyleRequestedEventArgs.prototype, "styleKey", {
        /**
         * The proposed style key for the cell. Used for recycling the cell.
        */
        get: function () {
            return this.i.styleKey;
        },
        set: function (v) {
            this.i.styleKey = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCellStyleRequestedEventArgs.prototype, "resolvedValue", {
        /**
         * The resolved value for the cell.
        */
        get: function () {
            return this.i.resolvedValue;
        },
        set: function (v) {
            this.i.resolvedValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCellStyleRequestedEventArgs.prototype, "rowNumber", {
        /**
         * The row number for the cell.
        */
        get: function () {
            return this.i.rowNumber;
        },
        set: function (v) {
            this.i.rowNumber = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxCellStyleRequestedEventArgs;
}());
export { IgxCellStyleRequestedEventArgs };
//# sourceMappingURL=igx-cell-style-requested-event-args.js.map