import * as tslib_1 from "tslib";
import { EventEmitter, Output } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxFormatGroupTextEventArgs } from "./igx-format-group-text-event-args";
import { IgxColumnSortDescription } from "./igx-column-sort-description";
import { ColumnGroupDescription as ColumnGroupDescription_internal } from "./ColumnGroupDescription";
/**
 * Represents an element in the current grouping applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
var IgxColumnGroupDescription = /** @class */ (function (_super) {
    tslib_1.__extends(IgxColumnGroupDescription, _super);
    function IgxColumnGroupDescription() {
        var _this = _super.call(this) || this;
        _this._formatText = null;
        _this._zoneRunner = null;
        return _this;
    }
    IgxColumnGroupDescription.prototype.createImplementation = function () {
        return new ColumnGroupDescription_internal(0);
    };
    Object.defineProperty(IgxColumnGroupDescription.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnGroupDescription.prototype, "formatOverride", {
        /**
         * Gets or sets an INTL.DateTimeFormat or INTL.NumericFormat to use to format the value.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnGroupDescription.prototype, "displayName", {
        /**
         * Gets or sets the display text for the group name.
        */
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnGroupDescription.prototype, "formatText", {
        /**
         * Called when the value is being formatted.
        */
        get: function () {
            var _this = this;
            if (this._formatText == null) {
                this._formatText = new EventEmitter();
                this.i.formatText = delegateCombine(this.i.formatText, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxFormatGroupTextEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeFormatText) {
                            _this.beforeFormatText(_this, outerArgs);
                        }
                        _this._formatText.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._formatText;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnGroupDescription.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxColumnGroupDescription.prototype, "formatText", null);
    return IgxColumnGroupDescription;
}(IgxColumnSortDescription));
export { IgxColumnGroupDescription };
//# sourceMappingURL=igx-column-group-description.js.map