import { ColumnPropertySetter as ColumnPropertySetter_internal } from "./ColumnPropertySetter";
/**
 * Indicates that a specified column should have a specified property set to a value.
*/
var IgxColumnPropertySetter = /** @class */ (function () {
    function IgxColumnPropertySetter() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxColumnPropertySetter.prototype.createImplementation = function () {
        return new ColumnPropertySetter_internal(0);
    };
    Object.defineProperty(IgxColumnPropertySetter.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnPropertySetter.prototype.onImplementationCreated = function () {
    };
    IgxColumnPropertySetter.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxColumnPropertySetter.prototype, "columnName", {
        /**
         * The name or key of the column to change the property of
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnPropertySetter.prototype, "propertyName", {
        /**
         * The name of the property to change
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnPropertySetter.prototype, "value", {
        /**
         * The new value of the property
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxColumnPropertySetter;
}());
export { IgxColumnPropertySetter };
//# sourceMappingURL=igx-column-property-setter.js.map