import { ColumnSortDescription as ColumnSortDescription_internal } from "./ColumnSortDescription";
/**
 * Represents an element in the current sort applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
var IgxColumnSortDescription = /** @class */ (function () {
    function IgxColumnSortDescription() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxColumnSortDescription.prototype.createImplementation = function () {
        return new ColumnSortDescription_internal(0);
    };
    Object.defineProperty(IgxColumnSortDescription.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnSortDescription.prototype.onImplementationCreated = function () {
    };
    IgxColumnSortDescription.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxColumnSortDescription.prototype, "propertyPath", {
        /**
         * Gets or sets the property being sorted.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSortDescription.prototype, "sortDirection", {
        /**
         * Gets or sets the direction to sort based on the property.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Returns if the SortDescription is equal to another.
    
    * @param other  * The SortDescription to compare to.
    */
    IgxColumnSortDescription.prototype.equals = function (other) {
        var iv = this.i.equals(other);
        return (iv);
    };
    /**
     * Returns the hash code for the SortDescription.
    
    */
    IgxColumnSortDescription.prototype.getHashCode = function () {
        var iv = this.i.getHashCode();
        return (iv);
    };
    return IgxColumnSortDescription;
}());
export { IgxColumnSortDescription };
//# sourceMappingURL=igx-column-sort-description.js.map