import * as tslib_1 from "tslib";
import { EventEmitter, Output } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxFormatSummaryTextEventArgs } from "./igx-format-summary-text-event-args";
import { ColumnSummaryDescription as ColumnSummaryDescription_internal } from "./ColumnSummaryDescription";
/**
 * Represents a summary that is applied to a datasource. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
var IgxColumnSummaryDescription = /** @class */ (function () {
    function IgxColumnSummaryDescription() {
        this._formatText = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxColumnSummaryDescription.prototype.createImplementation = function () {
        return new ColumnSummaryDescription_internal(0);
    };
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnSummaryDescription.prototype.onImplementationCreated = function () {
    };
    IgxColumnSummaryDescription.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "propertyPath", {
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "operand", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "calculator", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "calculatorDisplayName", {
        /**
         * Gets or sets the name to use when displaying the calculator name.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "displayName", {
        /**
         * Gets or sets the display name for the summary.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "formatOverride", {
        /**
         * Gets or sets an INTL.DateTimeFormat or INTL.NumericFormat to use to format the value.
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "maxFractionDigits", {
        /**
         * Gets or sets the minimum fraction digits. If FormatOverride is specificied this value is ignored.
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnSummaryDescription.prototype.equals = function (other) {
        var iv = this.i.equals(other);
        return (iv);
    };
    IgxColumnSummaryDescription.prototype.getHashCode = function () {
        var iv = this.i.getHashCode();
        return (iv);
    };
    Object.defineProperty(IgxColumnSummaryDescription.prototype, "formatText", {
        /**
         * Called when the value is being formatted.
        */
        get: function () {
            var _this = this;
            if (this._formatText == null) {
                this._formatText = new EventEmitter();
                this.i.formatText = delegateCombine(this.i.formatText, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxFormatSummaryTextEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeFormatText) {
                            _this.beforeFormatText(_this, outerArgs);
                        }
                        _this._formatText.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._formatText;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnSummaryDescription.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxColumnSummaryDescription.prototype, "formatText", null);
    return IgxColumnSummaryDescription;
}());
export { IgxColumnSummaryDescription };
//# sourceMappingURL=igx-column-summary-description.js.map