import { DataBindingEventArgs as DataBindingEventArgs_internal } from "./DataBindingEventArgs";
import { IgxDateTimeCellInfo } from "./igx-date-time-cell-info";
import { IgxImageCellInfo } from "./igx-image-cell-info";
import { IgxNumericCellInfo } from "./igx-numeric-cell-info";
import { IgxRowSeparatorInfo } from "./igx-row-separator-info";
import { IgxSectionHeaderCellInfo } from "./igx-section-header-cell-info";
import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { IgxTemplateHeaderCellInfo } from "./igx-template-header-cell-info";
import { IgxTemplateSectionHeaderCellInfo } from "./igx-template-section-header-cell-info";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { IgxTextHeaderCellInfo } from "./igx-text-header-cell-info";
/**
 * Information about the data binding taking place.
*/
var IgxDataBindingEventArgs = /** @class */ (function () {
    function IgxDataBindingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxDataBindingEventArgs.prototype.createImplementation = function () {
        return new DataBindingEventArgs_internal();
    };
    Object.defineProperty(IgxDataBindingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxDataBindingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxDataBindingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxDataBindingEventArgs.prototype, "cellInfo", {
        /**
         * The backing information for the current cell.
        */
        get: function () {
            if (this.i.cellInfo == null) {
                return null;
            }
            if (!this.i.cellInfo.externalObject) {
                var ext = null;
                switch (this.i.cellInfo.$type.name) {
                    case "DateTimeCellModel":
                        ext = new IgxDateTimeCellInfo();
                        break;
                    case "ImageCellModel":
                        ext = new IgxImageCellInfo();
                        break;
                    case "NumericCellModel":
                        ext = new IgxNumericCellInfo();
                        break;
                    case "RowSeparatorModel":
                        ext = new IgxRowSeparatorInfo();
                        break;
                    case "SectionHeaderCellModel":
                        ext = new IgxSectionHeaderCellInfo();
                        break;
                    case "TemplateCellModel":
                        ext = new IgxTemplateCellInfo();
                        break;
                    case "TemplateHeaderCellModel":
                        ext = new IgxTemplateHeaderCellInfo();
                        break;
                    case "TemplateSectionHeaderCellModel":
                        ext = new IgxTemplateSectionHeaderCellInfo();
                        break;
                    case "TextCellModel":
                        ext = new IgxTextCellInfo();
                        break;
                    case "TextHeaderCellModel":
                        ext = new IgxTextHeaderCellInfo();
                        break;
                }
                ext._implementation = this.i.cellInfo;
                this.i.cellInfo.externalObject = ext;
            }
            return this.i.cellInfo.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDataBindingEventArgs.prototype, "resolvedValue", {
        /**
     * The resolved value for the cell.
    */
        get: function () {
            return this.i.resolvedValue;
        },
        set: function (v) {
            this.i.resolvedValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDataBindingEventArgs.prototype, "rowObject", {
        /**
         * The data for the row in which the cell is contained.
        */
        get: function () {
            return this.i.rowObject;
        },
        set: function (v) {
            this.i.rowObject = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxDataBindingEventArgs;
}());
export { IgxDataBindingEventArgs };
//# sourceMappingURL=igx-data-binding-event-args.js.map