import * as tslib_1 from "tslib";
import { DateTimeFormats_$type } from "./DateTimeFormats";
import { IgxCellInfo } from "./igx-cell-info";
import { DateTimeCellModel as DateTimeCellModel_internal } from "./DateTimeCellModel";
import { ensureEnum, ensureBool } from "igniteui-angular-core";
/**
 * Backing information about a date time cell for the grid.
*/
var IgxDateTimeCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxDateTimeCellInfo, _super);
    function IgxDateTimeCellInfo() {
        return _super.call(this) || this;
    }
    IgxDateTimeCellInfo.prototype.createImplementation = function () {
        return new DateTimeCellModel_internal();
    };
    Object.defineProperty(IgxDateTimeCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeCellInfo.prototype, "dateTimeValue", {
        /**
         * Sets or gets the DateTime value for the cell.
        */
        get: function () {
            return this.i.ip;
        },
        set: function (v) {
            this.i.ip = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeCellInfo.prototype, "formatOverride", {
        /**
         * The format options to apply to the value
        */
        get: function () {
            return this.i.ix;
        },
        set: function (v) {
            this.i.ix = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeCellInfo.prototype, "dateTimeFormat", {
        /**
         * Sets or gets the simple DateTimeFormat to use for the cell.
        */
        get: function () {
            return this.i.ik;
        },
        set: function (v) {
            this.i.ik = ensureEnum(DateTimeFormats_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeCellInfo.prototype, "isOffsetValue", {
        /**
         * Sets or gets whether the value to use is a DateTimeOffset value.
        */
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxDateTimeCellInfo;
}(IgxCellInfo));
export { IgxDateTimeCellInfo };
//# sourceMappingURL=igx-date-time-cell-info.js.map