import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { DateTimeFormats, DateTimeFormats_$type } from "./DateTimeFormats";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { DateTimeColumn } from "./DateTimeColumn";
import { ensureEnum } from "igniteui-angular-core";
/**
 * A column for displaying date/time values.
*/
export var IgxDateTimeColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxDateTimeColumnComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxDateTimeColumnComponent; }) }];
var IgxDateTimeColumnComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxDateTimeColumnComponent, _super);
    function IgxDateTimeColumnComponent() {
        return _super.call(this) || this;
    }
    IgxDateTimeColumnComponent_1 = IgxDateTimeColumnComponent;
    IgxDateTimeColumnComponent.prototype.createImplementation = function () {
        return new DateTimeColumn();
    };
    Object.defineProperty(IgxDateTimeColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeColumnComponent.prototype, "dateTimeFormat", {
        /**
         * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.gv;
        },
        set: function (v) {
            this.i.gv = ensureEnum(DateTimeFormats_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDateTimeColumnComponent.prototype, "formatOverride", {
        /**
         * Gets or sets the INTL DateTimeFormat object to use for formatting the date values.
        */
        get: function () {
            return this.i.gy;
        },
        set: function (v) {
            this.i.gy = v;
        },
        enumerable: true,
        configurable: true
    });
    var IgxDateTimeColumnComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxDateTimeColumnComponent.prototype, "dateTimeFormat", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], IgxDateTimeColumnComponent.prototype, "formatOverride", null);
    IgxDateTimeColumnComponent = IgxDateTimeColumnComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-date-time-column',
            template: "",
            providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxDateTimeColumnComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxDateTimeColumnComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxDateTimeColumnComponent);
    return IgxDateTimeColumnComponent;
}(IgxColumnComponent));
export { IgxDateTimeColumnComponent };
//# sourceMappingURL=igx-date-time-column-component.js.map