import { IgxGridCellPosition } from "./igx-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
var IgxGridActiveCellChangedEventArgs = /** @class */ (function () {
    function IgxGridActiveCellChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridActiveCellChangedEventArgs.prototype.createImplementation = function () {
        return new GridActiveCellChangedEventArgs_internal();
    };
    Object.defineProperty(IgxGridActiveCellChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridActiveCellChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxGridActiveCellChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridActiveCellChangedEventArgs.prototype, "newActiveCell", {
        /**
         * The new active cell.
        */
        get: function () {
            if (this.i.newActiveCell == null) {
                return null;
            }
            if (!this.i.newActiveCell.externalObject) {
                var e = new IgxGridCellPosition();
                e._implementation = this.i.newActiveCell;
                this.i.newActiveCell.externalObject = e;
            }
            return this.i.newActiveCell.externalObject;
        },
        set: function (v) {
            v == null ? this.i.newActiveCell = null : this.i.newActiveCell = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridActiveCellChangedEventArgs.prototype, "oldActiveCell", {
        /**
         * The old active cell.
        */
        get: function () {
            if (this.i.oldActiveCell == null) {
                return null;
            }
            if (!this.i.oldActiveCell.externalObject) {
                var e = new IgxGridCellPosition();
                e._implementation = this.i.oldActiveCell;
                this.i.oldActiveCell.externalObject = e;
            }
            return this.i.oldActiveCell.externalObject;
        },
        set: function (v) {
            v == null ? this.i.oldActiveCell = null : this.i.oldActiveCell = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridActiveCellChangedEventArgs;
}());
export { IgxGridActiveCellChangedEventArgs };
//# sourceMappingURL=igx-grid-active-cell-changed-event-args.js.map