import { GridEasingFunctionType_$type } from "./GridEasingFunctionType";
import { GridAnimationPhaseSettings as GridAnimationPhaseSettings_internal } from "./GridAnimationPhaseSettings";
import { ensureBool, ensureEnum } from "igniteui-angular-core";
/**
 * This class is used to group the settings to define an animation phase.
*/
var IgxGridAnimationPhaseSettings = /** @class */ (function () {
    function IgxGridAnimationPhaseSettings() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridAnimationPhaseSettings.prototype.createImplementation = function () {
        return new GridAnimationPhaseSettings_internal();
    };
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridAnimationPhaseSettings.prototype.onImplementationCreated = function () {
    };
    IgxGridAnimationPhaseSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "durationMilliseconds", {
        /**
         * The duration of an animation, in milliseconds
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "holdInitialMilliseconds", {
        /**
         * The amount of time to delay an animation, in milliseconds.
        */
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "perItemDelayMilliseconds", {
        /**
         * The amount of time to delay each item animating, in milliseconds
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "subItemDurationMilliseconds", {
        /**
         * The amount of time each item animating should take, in milliseconds
        */
        get: function () {
            return this.i.o;
        },
        set: function (v) {
            this.i.o = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "desiredSubItemDurationMilliseconds", {
        /**
         * The desired amount of time each item animating should take, in milliseconds
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "shouldItemsFinishSimultaneously", {
        /**
         * Configures whether all items animating should finish simultaneously
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridAnimationPhaseSettings.prototype, "easingFunctionType", {
        /**
         * Configures the Easing function used to animate the individual items
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureEnum(GridEasingFunctionType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxGridAnimationPhaseSettings.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    return IgxGridAnimationPhaseSettings;
}());
export { IgxGridAnimationPhaseSettings };
//# sourceMappingURL=igx-grid-animation-phase-settings.js.map