import { GridAnimationSettings as GridAnimationSettings_internal } from "./GridAnimationSettings";
/**
 * Animation settings for the grid.
*/
var IgxGridAnimationSettings = /** @class */ (function () {
    function IgxGridAnimationSettings() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridAnimationSettings.prototype.createImplementation = function () {
        return new GridAnimationSettings_internal();
    };
    Object.defineProperty(IgxGridAnimationSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridAnimationSettings.prototype.onImplementationCreated = function () {
    };
    IgxGridAnimationSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    IgxGridAnimationSettings.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    return IgxGridAnimationSettings;
}());
export { IgxGridAnimationSettings };
//# sourceMappingURL=igx-grid-animation-settings.js.map