import { GridCellEventArgs as GridCellEventArgs_internal } from "./GridCellEventArgs";
import { IgxDateTimeCellInfo } from "./igx-date-time-cell-info";
import { IgxImageCellInfo } from "./igx-image-cell-info";
import { IgxNumericCellInfo } from "./igx-numeric-cell-info";
import { IgxRowSeparatorInfo } from "./igx-row-separator-info";
import { IgxSectionHeaderCellInfo } from "./igx-section-header-cell-info";
import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { IgxTemplateHeaderCellInfo } from "./igx-template-header-cell-info";
import { IgxTemplateSectionHeaderCellInfo } from "./igx-template-section-header-cell-info";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { IgxTextHeaderCellInfo } from "./igx-text-header-cell-info";
/**
 * Information about the cell in context.
*/
var IgxGridCellEventArgs = /** @class */ (function () {
    function IgxGridCellEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridCellEventArgs.prototype.createImplementation = function () {
        return new GridCellEventArgs_internal();
    };
    Object.defineProperty(IgxGridCellEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridCellEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxGridCellEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridCellEventArgs.prototype, "cellInfo", {
        /**
         * The backing information for the current cell.
        */
        get: function () {
            if (this.i.cellInfo == null) {
                return null;
            }
            if (!this.i.cellInfo.externalObject) {
                var ext = null;
                switch (this.i.cellInfo.$type.name) {
                    case "DateTimeCellModel":
                        ext = new IgxDateTimeCellInfo();
                        break;
                    case "ImageCellModel":
                        ext = new IgxImageCellInfo();
                        break;
                    case "NumericCellModel":
                        ext = new IgxNumericCellInfo();
                        break;
                    case "RowSeparatorModel":
                        ext = new IgxRowSeparatorInfo();
                        break;
                    case "SectionHeaderCellModel":
                        ext = new IgxSectionHeaderCellInfo();
                        break;
                    case "TemplateCellModel":
                        ext = new IgxTemplateCellInfo();
                        break;
                    case "TemplateHeaderCellModel":
                        ext = new IgxTemplateHeaderCellInfo();
                        break;
                    case "TemplateSectionHeaderCellModel":
                        ext = new IgxTemplateSectionHeaderCellInfo();
                        break;
                    case "TextCellModel":
                        ext = new IgxTextCellInfo();
                        break;
                    case "TextHeaderCellModel":
                        ext = new IgxTextHeaderCellInfo();
                        break;
                }
                ext._implementation = this.i.cellInfo;
                this.i.cellInfo.externalObject = ext;
            }
            return this.i.cellInfo.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellEventArgs.prototype, "grid", {
        /**
     * Gets the grid owning the cell.
    */
        get: function () {
            if (this.i.grid == null) {
                return null;
            }
            return this.i.grid.externalObject;
        },
        set: function (v) {
            v == null ? this.i.grid = null : this.i.grid = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridCellEventArgs;
}());
export { IgxGridCellEventArgs };
//# sourceMappingURL=igx-grid-cell-event-args.js.map