import { DataSourceSchemaPropertyType_$type } from "igniteui-angular-core";
import { IgxGridFilterDialogViewModelGroupingLevelCollection } from "./igx-grid-filter-dialog-view-model-grouping-level-collection";
import { IgxGridFilterDialogViewModelRowCollection } from "./igx-grid-filter-dialog-view-model-row-collection";
import { GridFilterDialogViewModel as GridFilterDialogViewModel_internal } from "./GridFilterDialogViewModel";
import { ensureEnum, ensureBool } from "igniteui-angular-core";
import { GridFilterDialogViewModelGroupingLevelCollection as GridFilterDialogViewModelGroupingLevelCollection_internal } from "./GridFilterDialogViewModelGroupingLevelCollection";
import { GridFilterDialogViewModelGroupingLevel } from "./GridFilterDialogViewModelGroupingLevel";
import { SyncableObservableCollection$1 } from "igniteui-angular-core";
import { GridFilterDialogViewModelRowCollection as GridFilterDialogViewModelRowCollection_internal } from "./GridFilterDialogViewModelRowCollection";
import { GridFilterDialogViewModelRow } from "./GridFilterDialogViewModelRow";
var IgxGridFilterDialogViewModel = /** @class */ (function () {
    function IgxGridFilterDialogViewModel() {
        this._groupingLevels = null;
        this._rows = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridFilterDialogViewModel.prototype.createImplementation = function () {
        return new GridFilterDialogViewModel_internal();
    };
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridFilterDialogViewModel.prototype.onImplementationCreated = function () {
    };
    IgxGridFilterDialogViewModel.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "propertyType", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(DataSourceSchemaPropertyType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "groupingLevels", {
        get: function () {
            if (this._groupingLevels === null) {
                var coll = new IgxGridFilterDialogViewModelGroupingLevelCollection();
                var innerColl = this.i.e;
                if (!innerColl) {
                    innerColl = new GridFilterDialogViewModelGroupingLevelCollection_internal();
                }
                this._groupingLevels = coll._fromInner(innerColl);
                this.i.e = innerColl;
            }
            return this._groupingLevels;
        },
        set: function (v) {
            if (this._groupingLevels !== null) {
                this._groupingLevels._setSyncTarget(null);
                this._groupingLevels = null;
            }
            var coll = new IgxGridFilterDialogViewModelGroupingLevelCollection();
            this._groupingLevels = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(GridFilterDialogViewModelGroupingLevel.$type);
            var innerColl = this.i.e;
            if (!innerColl) {
                innerColl = new GridFilterDialogViewModelGroupingLevelCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._groupingLevels._setSyncTarget(syncColl);
            this.i.e = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "isTopLevelOr", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "maxGroupingLevels", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModel.prototype, "rows", {
        get: function () {
            if (this._rows === null) {
                var coll = new IgxGridFilterDialogViewModelRowCollection();
                var innerColl = this.i.f;
                if (!innerColl) {
                    innerColl = new GridFilterDialogViewModelRowCollection_internal();
                }
                this._rows = coll._fromInner(innerColl);
                this.i.f = innerColl;
            }
            return this._rows;
        },
        set: function (v) {
            if (this._rows !== null) {
                this._rows._setSyncTarget(null);
                this._rows = null;
            }
            var coll = new IgxGridFilterDialogViewModelRowCollection();
            this._rows = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(GridFilterDialogViewModelRow.$type);
            var innerColl = this.i.f;
            if (!innerColl) {
                innerColl = new GridFilterDialogViewModelRowCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._rows._setSyncTarget(syncColl);
            this.i.f = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridFilterDialogViewModel.prototype.addNewRow = function () {
        this.i.n();
    };
    IgxGridFilterDialogViewModel.prototype.canGroupRange = function (startIndex, endIndex) {
        var iv = this.i.h(startIndex, endIndex);
        return (iv);
    };
    IgxGridFilterDialogViewModel.prototype.ungroupRange = function (startIndex, endIndex) {
        this.i.aa(startIndex, endIndex);
    };
    IgxGridFilterDialogViewModel.prototype.targetingRange = function (startIndex, endIndex) {
        var iv = this.i.l(startIndex, endIndex);
        return (iv);
    };
    IgxGridFilterDialogViewModel.prototype.toggleRange = function (startIndex, endIndex) {
        this.i.z(startIndex, endIndex);
    };
    IgxGridFilterDialogViewModel.prototype.groupRange = function (startIndex, endIndex, isOrGrouping) {
        this.i.o(startIndex, endIndex, isOrGrouping);
    };
    return IgxGridFilterDialogViewModel;
}());
export { IgxGridFilterDialogViewModel };
//# sourceMappingURL=igx-grid-filter-dialog-view-model.js.map