import { IgxGridSelectedCellsCollection } from "./igx-grid-selected-cells-collection";
import { GridSelectedCellsChangedEventArgs as GridSelectedCellsChangedEventArgs_internal } from "./GridSelectedCellsChangedEventArgs";
import { GridSelectedCellsCollection as GridSelectedCellsCollection_internal } from "./GridSelectedCellsCollection";
import { CellKey } from "./CellKey";
import { SyncableObservableCollection$1 } from "igniteui-angular-core";
/**
 * Information about the change to the selected cells in the grid.
*/
var IgxGridSelectedCellsChangedEventArgs = /** @class */ (function () {
    function IgxGridSelectedCellsChangedEventArgs() {
        this._addedCells = null;
        this._removedCells = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridSelectedCellsChangedEventArgs.prototype.createImplementation = function () {
        return new GridSelectedCellsChangedEventArgs_internal();
    };
    Object.defineProperty(IgxGridSelectedCellsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridSelectedCellsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxGridSelectedCellsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridSelectedCellsChangedEventArgs.prototype, "addedCells", {
        /**
         * The cells added to the selection.
        */
        get: function () {
            if (this._addedCells === null) {
                var coll = new IgxGridSelectedCellsCollection();
                var innerColl = this.i.addedCells;
                if (!innerColl) {
                    innerColl = new GridSelectedCellsCollection_internal();
                }
                this._addedCells = coll._fromInner(innerColl);
                this.i.addedCells = innerColl;
            }
            return this._addedCells;
        },
        set: function (v) {
            if (this._addedCells !== null) {
                this._addedCells._setSyncTarget(null);
                this._addedCells = null;
            }
            var coll = new IgxGridSelectedCellsCollection();
            this._addedCells = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(CellKey.$type);
            var innerColl = this.i.addedCells;
            if (!innerColl) {
                innerColl = new GridSelectedCellsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._addedCells._setSyncTarget(syncColl);
            this.i.addedCells = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridSelectedCellsChangedEventArgs.prototype, "removedCells", {
        /**
         * The cells removed from the selection.
        */
        get: function () {
            if (this._removedCells === null) {
                var coll = new IgxGridSelectedCellsCollection();
                var innerColl = this.i.removedCells;
                if (!innerColl) {
                    innerColl = new GridSelectedCellsCollection_internal();
                }
                this._removedCells = coll._fromInner(innerColl);
                this.i.removedCells = innerColl;
            }
            return this._removedCells;
        },
        set: function (v) {
            if (this._removedCells !== null) {
                this._removedCells._setSyncTarget(null);
                this._removedCells = null;
            }
            var coll = new IgxGridSelectedCellsCollection();
            this._removedCells = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(CellKey.$type);
            var innerColl = this.i.removedCells;
            if (!innerColl) {
                innerColl = new GridSelectedCellsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._removedCells._setSyncTarget(syncColl);
            this.i.removedCells = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridSelectedCellsChangedEventArgs;
}());
export { IgxGridSelectedCellsChangedEventArgs };
//# sourceMappingURL=igx-grid-selected-cells-changed-event-args.js.map