import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { SortIndicatorStyle, SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { brushToString, stringToBrush, ensureEnum } from "igniteui-angular-core";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export var IgxHeaderComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxHeaderComponent; }) }];
var IgxHeaderComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxHeaderComponent, _super);
    function IgxHeaderComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "sortIndicatorColor", {
        /**
         * Gets or sets the color to use for the sort indicator icon
        */
        get: function () {
            return brushToString(this.i.er);
        },
        set: function (v) {
            this.i.er = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "actualSortIndicatorColor", {
        /**
         * Gets the actual background color that is used for the cells when they are selected
        */
        get: function () {
            return brushToString(this.i.ep);
        },
        set: function (v) {
            this.i.ep = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "sortIndicatorStyle", {
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "actualSortIndicatorStyle", {
        get: function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content.
        */
        get: function () {
            return this.i.d9;
        },
        set: function (v) {
            this.i.d9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content.
        */
        get: function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHeaderComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content.
        */
        get: function () {
            return this.i.d8;
        },
        set: function (v) {
            this.i.d8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxHeaderComponent.prototype, "sortIndicatorColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxHeaderComponent.prototype, "actualSortIndicatorColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "sortIndicatorStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "actualSortIndicatorStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "paddingLeft", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "paddingTop", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "paddingRight", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxHeaderComponent.prototype, "paddingBottom", null);
    return IgxHeaderComponent;
}(IgxDefinitionBaseComponent));
export { IgxHeaderComponent };
//# sourceMappingURL=igx-header-component.js.map