import * as tslib_1 from "tslib";
import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { ImageResourceType_$type } from "./ImageResourceType";
import { IgxCellInfo } from "./igx-cell-info";
import { ImageCellModel as ImageCellModel_internal } from "./ImageCellModel";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for an image cell in the grid.
*/
var IgxImageCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxImageCellInfo, _super);
    function IgxImageCellInfo() {
        return _super.call(this) || this;
    }
    IgxImageCellInfo.prototype.createImplementation = function () {
        return new ImageCellModel_internal();
    };
    Object.defineProperty(IgxImageCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxImageCellInfo.prototype, "imagePath", {
        /**
         * Sets or gets the resource path to use to get the image for the cell.
        */
        get: function () {
            return this.i.iq;
        },
        set: function (v) {
            this.i.iq = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxImageCellInfo.prototype, "imageStretchOption", {
        /**
         * Sets or gets the image stretching behavior for the image.
        */
        get: function () {
            return this.i.ik;
        },
        set: function (v) {
            this.i.ik = ensureEnum(ImageStretchOptions_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxImageCellInfo.prototype, "imageResourceType", {
        /**
         * Sets or gets the image resource type. Indicates which type of resource should be fetched and how ImagePath should be interpreted.
        */
        get: function () {
            return this.i.ii;
        },
        set: function (v) {
            this.i.ii = ensureEnum(ImageResourceType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxImageCellInfo;
}(IgxCellInfo));
export { IgxImageCellInfo };
//# sourceMappingURL=igx-image-cell-info.js.map