import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { ImageStretchOptions, ImageStretchOptions_$type } from "./ImageStretchOptions";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ImageColumn } from "./ImageColumn";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
export var IgxImageColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxImageColumnComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxImageColumnComponent; }) }];
var IgxImageColumnComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxImageColumnComponent, _super);
    function IgxImageColumnComponent() {
        return _super.call(this) || this;
    }
    IgxImageColumnComponent_1 = IgxImageColumnComponent;
    IgxImageColumnComponent.prototype.createImplementation = function () {
        return new ImageColumn();
    };
    Object.defineProperty(IgxImageColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxImageColumnComponent.prototype, "imageStretchOption", {
        /**
         * Gets or sets the stretch option to use when rendering images
        */
        get: function () {
            return this.i.gw;
        },
        set: function (v) {
            this.i.gw = ensureEnum(ImageStretchOptions_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    var IgxImageColumnComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxImageColumnComponent.prototype, "imageStretchOption", null);
    IgxImageColumnComponent = IgxImageColumnComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-image-column',
            template: "",
            providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxImageColumnComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxImageColumnComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxImageColumnComponent);
    return IgxImageColumnComponent;
}(IgxColumnComponent));
export { IgxImageColumnComponent };
//# sourceMappingURL=igx-image-column-component.js.map