import * as tslib_1 from "tslib";
import { Component, EventEmitter, Output, ViewContainerRef, ComponentFactoryResolver, Injector, NgZone, Renderer2, ViewChild, Input, ChangeDetectionStrategy, ContentChildren, QueryList } from '@angular/core';
import { IgxSectionHeaderComponent } from './igx-section-header-component';
import { IgxSummaryRowRootComponent } from './igx-summary-row-root-component';
import { IgxSummaryRowSectionComponent } from './igx-summary-row-section-component';
import { IgxColumnWidth } from './igx-column-width';
import { ColumnWidth as ColumnWidth_internal } from './ColumnWidth';
import { HeaderClickAction, HeaderClickAction_$type } from './HeaderClickAction';
import { ColumnShowingAnimationMode, ColumnShowingAnimationMode_$type } from './ColumnShowingAnimationMode';
import { ColumnPropertyUpdatingAnimationMode, ColumnPropertyUpdatingAnimationMode_$type } from './ColumnPropertyUpdatingAnimationMode';
import { CellDataLoadedAnimationMode, CellDataLoadedAnimationMode_$type } from './CellDataLoadedAnimationMode';
import { RowSelectionAnimationMode, RowSelectionAnimationMode_$type } from './RowSelectionAnimationMode';
import { ColumnMovingAnimationMode, ColumnMovingAnimationMode_$type } from './ColumnMovingAnimationMode';
import { ColumnHidingAnimationMode, ColumnHidingAnimationMode_$type } from './ColumnHidingAnimationMode';
import { CellSelectionAnimationMode, CellSelectionAnimationMode_$type } from './CellSelectionAnimationMode';
import { ColumnExchangingAnimationMode, ColumnExchangingAnimationMode_$type } from './ColumnExchangingAnimationMode';
import { GridSelectionMode, GridSelectionMode_$type } from './GridSelectionMode';
import { GridActivationMode, GridActivationMode_$type } from './GridActivationMode';
import { GridSelectionBehavior, GridSelectionBehavior_$type } from './GridSelectionBehavior';
import { IgxGridCellEventArgs } from './igx-grid-cell-event-args';
import { IgxGridColumnsAutoGeneratedEventArgs } from './igx-grid-columns-auto-generated-event-args';
import { IgxGridSelectedItemsChangedEventArgs } from './igx-grid-selected-items-changed-event-args';
import { IgxGridSelectedKeysChangedEventArgs } from './igx-grid-selected-keys-changed-event-args';
import { IgxGridSelectedCellsChangedEventArgs } from './igx-grid-selected-cells-changed-event-args';
import { IgxGridSelectedCellRangesChangedEventArgs } from './igx-grid-selected-cell-ranges-changed-event-args';
import { IgxGridSortDescriptionsChangedEventArgs } from './igx-grid-sort-descriptions-changed-event-args';
import { IgxGridGroupDescriptionsChangedEventArgs } from './igx-grid-group-descriptions-changed-event-args';
import { Grid } from "./Grid";
import { ensureEnum, ensureBool, CollectionAdapter, initializePropertiesFromCss, NamePatcher, stringToBrush, brushToString, toSpinal } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AngularRenderer, AngularWrapper } from "igniteui-angular-core";
import { Column } from './Column';
import { IgxColumnComponent } from './igx-column-component';
import { DataGridCellLayoutPanel } from './DataGridCellLayoutPanel';
import { Base } from "igniteui-angular-core";
import { GridExternalWrapper } from './GridExternalWrapper';
import { BrowserTickProvider } from './BrowserTickProvider';
import { BrowserPixelConverter } from './BrowserPixelConverter';
import { DataGridPresenterManager } from './DataGridPresenterManager';
import { DataGridViewportManager } from './DataGridViewportManager';
import { DataGridDelayedExecutionManager } from './DataGridDelayedExecutionManager';
import { DataGridPropertySetter } from './DataGridPropertySetter';
import { IgxGridColumnCollection } from './igx-grid-column-collection';
import { SyncableObservableCollection$1 } from "igniteui-angular-core";
import { NotifyCollectionChangedAction } from "igniteui-angular-core";
import { Scroller } from "igniteui-angular-core";
import { Dragger } from "./Dragger";
import { LiveGridStylingDefaults } from './LiveGridStylingDefaults';
import { delegateCombine } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { IgxColumnSortDescriptionCollection } from './igx-column-sort-description-collection';
import { IgxColumnGroupDescriptionCollection } from './igx-column-group-description-collection';
import { IgxFilterExpressionCollection } from "igniteui-angular-core";
import { IgxColumnSummaryDescriptionCollection } from './igx-column-summary-description-collection';
import { IgxGridSelectedItemsCollection } from "./igx-grid-selected-items-collection";
import { IgxGridSelectedKeysCollection } from "./igx-grid-selected-keys-collection";
import { IgxGridSelectedCellsCollection } from "./igx-grid-selected-cells-collection";
import { IgxGridSelectedCellRangesCollection } from "./igx-grid-selected-cell-ranges-collection";
import { GridSelectedItemsCollection as GridSelectedItemsCollection_internal } from "./GridSelectedItemsCollection";
import { GridSelectedKeysCollection as GridSelectedKeysCollection_internal } from "./GridSelectedKeysCollection";
import { GridSelectedCellsCollection as GridSelectedCellsCollection_internal } from "./GridSelectedCellsCollection";
import { GridSelectedCellRangesCollection as GridSelectedCellRangesCollection_internal } from "./GridSelectedCellRangesCollection";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { CellKey } from "./CellKey";
import { CellRange } from "./CellRange";
import { IgxGridFilterExpressionsEventArgs } from './igx-grid-filter-expressions-event-args';
import { GridColumnCollection as GridColumnCollection_internal } from './GridColumnCollection';
import { ResponsiveStatesCollection as ResponsiveStatesCollection_internal } from './ResponsiveStatesCollection';
import { IgxResponsiveStatesCollection } from './igx-responsive-states-collection';
import { ResponsiveState } from './ResponsiveState';
import { IgxGridAnimationSettings } from './igx-grid-animation-settings';
import { IgxRowSeparatorComponent } from './igx-row-separator-component';
import { IgxGridCellPosition } from "./igx-grid-cell-position";
import { IgxGridActiveCellChangedEventArgs } from "./igx-grid-active-cell-changed-event-args";
import { DataGridScrollerKeyboardListener } from "./DataGridScrollerKeyboardListener";
import { IgxHeaderSeparatorComponent } from "./igx-header-separator-component";
import { IgxColumnResizingSeparatorComponent } from './igx-column-resizing-separator-component';
import { ColumnResizingMode, ColumnResizingMode_$type } from "./ColumnResizingMode";
import { ColumnResizingAnimationMode, ColumnResizingAnimationMode_$type } from "./ColumnResizingAnimationMode";
import { ColumnMovingMode, ColumnMovingMode_$type } from "./ColumnMovingMode";
import { IgxColumnMovingSeparatorComponent } from './igx-column-moving-separator-component';
import { SortIndicatorStyle, SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { DataSourceSectionHeaderDisplayMode, DataSourceSectionHeaderDisplayMode_$type } from "igniteui-angular-core";
import { DataSourceSummaryScope, DataSourceSummaryScope_$type } from "igniteui-angular-core";
import { GroupSummaryDisplayMode, GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { fromRect } from "igniteui-angular-core";
export var IgxGridComponent_PROVIDERS = [];
var GridStylingDefaults = {};
var IgxLiveGridComponent = /** @class */ (function () {
    function IgxLiveGridComponent(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
        var _this = this;
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._ngZone = _ngZone;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._injector = _injector;
        /**
         * The columns actually present in the grid. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing columns from the manual columns collection on the columns property.
         */
        this.combinedColumns = [];
        this._columns = null;
        this._disableManualColumnSync = false;
        this._scrollerStyle = 1 /* Fading */;
        this._columnsAdapter = null;
        this._scroller = null;
        this._dragger = null;
        this._wrapper = null;
        this._grid = null;
        this.containerResized = function () {
            var width = this._container.clientWidth;
            var height = this._container.clientHeight;
            this._scroller.viewportWidth = width;
            this._scroller.viewportHeight = height;
            this._grid.dragger.viewportWidth = width;
            this._grid.dragger.viewportHeight = height;
            this._grid.sizeChanged(width, height);
            if (this._grid.model.actualVisibleRegion.isEmpty &&
                width > 0 && height > 0) {
                this._grid.setViewport(0, 0, width, height);
            }
            else {
                this.onScroll();
            }
        };
        this._dataSource = null;
        this._insetLeft = 0;
        this._insetTop = 0;
        this._insetRight = 0;
        this._insetBottom = 0;
        this._selectedItems = null;
        this._selectedKeys = null;
        this._selectedCells = null;
        this._selectedCellRanges = null;
        this._pinnedItems = null;
        this._pinnedKeys = null;
        this._responsiveStates = null;
        this._actualColumns = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._filterExpressionsChanging = null;
        this._filterExpressionsChanged = null;
        this._cellPreviewPointerDown = null;
        this._cellPreviewPointerUp = null;
        this._cellPointerDown = null;
        this._cellPointerUp = null;
        this._cellClicked = null;
        this._sortDescriptionsChanged = null;
        this._groupDescriptionsChanged = null;
        this._columnsAutoGenerated = null;
        this._selectedItemsChanged = null;
        this._selectedKeysChanged = null;
        this._selectedCellsChanged = null;
        this._activeCellChanged = null;
        this._selectedCellRangesChanged = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        var useCanvas = false;
        this._zoneRunner = function (act) { return _this._ngZone.run(act); };
        this._container = _renderer.createElement("div");
        _renderer.appendChild(_elRef.element.nativeElement, this._container);
        _renderer.setStyle(this._container, "display", "block");
        _renderer.setStyle(this._container, "width", "100%");
        _renderer.setStyle(this._container, "height", "100%");
        _renderer.setStyle(this._container, "box-sizing", "border-box");
        var root;
        root = this._container;
        if (this._container.nativeElement != null) {
            root = this._container.nativeElement;
        }
        var ren = new AngularRenderer(root, this._renderer, window.document, this._ngZone, true, LiveGridStylingDefaults);
        this._wrapper = ren;
        this._implementation = new Grid();
        var grid = this.i;
        this._grid = grid;
        this._columnsAdapter = new CollectionAdapter([], this.i.columns, this.combinedColumns, function (c) { return c.i; }, function (i) {
            i._provideRenderer(_this._wrapper);
            if (_this._elRef && _this._elRef.element.nativeElement.parentElement) {
                i._styling(_this._elRef.element.nativeElement, _this, _this);
            }
        }, function (i) { i._provideRenderer(null); });
        grid.externalGrid = new GridExternalWrapper(this);
        grid.tickProvider = new BrowserTickProvider(ren);
        grid.platformPixelConverter = new BrowserPixelConverter();
        this._contentLayout = new DataGridCellLayoutPanel(ren, new DataGridPresenterManager(this._grid, useCanvas), window.devicePixelRatio);
        grid.renderingEngine = this._contentLayout;
        grid.viewportManager = new DataGridViewportManager(this);
        grid.delayedExecutionManager = new DataGridDelayedExecutionManager(ren);
        grid.propertySetter = new DataGridPropertySetter();
        //grid.provideContainer(ren);
        var scroller = new Scroller();
        this._scroller = scroller;
        scroller.scrollbarStyle = this.scrollbarStyle;
        scroller.provideContainer(ren);
        this._content = (this._contentLayout.element.getNativeElement());
        scroller.keyboardListener = new DataGridScrollerKeyboardListener(grid);
        scroller.provideContent(new AngularWrapper(this._content, this._renderer, this._ngZone));
        scroller.onScrolling = function () { return _this.onScroll(); };
        scroller.viewportWidth = this._container.clientWidth;
        scroller.viewportHeight = this._container.clientHeight;
        scroller.verticalTrackStartInset = this.headerHeight;
        grid.dragger = new Dragger();
        grid.dragger.provideContainer(ren);
        grid.dragger.viewportWidth = this._container.clientWidth;
        grid.dragger.viewportHeight = this._container.clientHeight;
        ren.addSizeWatcher(function () {
            _this.containerResized();
        });
        // supports angular themes or custom properties set in CSS 
        //this._styling(_elRef.element.nativeElement, this);
    }
    IgxLiveGridComponent.prototype._ensureColumnsAreManual = function () {
        this._disableManualColumnSync = true;
        this._columnsAdapter.shiftContentToManual(this.columns, function (i) { return i.isFromMarkup = false; });
        this._disableManualColumnSync = false;
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "columns", {
        /**
         * A collection or manually added columns for the grid.
        */
        get: function () {
            var _this = this;
            if (this._columns === null) {
                var coll = new IgxGridColumnCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    if (_this._disableManualColumnSync) {
                        return;
                    }
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._columnsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._columnsAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._columnsAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._columnsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._columnsAdapter.clearManualItems();
                            break;
                    }
                });
                this._columns = coll;
            }
            return this._columns;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
            this.containerResized();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
            this.containerResized();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "scrollbarStyle", {
        get: function () {
            return this._scrollerStyle;
        },
        set: function (style) {
            this._scrollerStyle = style;
            if (this._scroller) {
                this._scroller.scrollbarStyle = this._scrollerStyle;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype.createImplementation = function () {
        var test = Grid;
        return new Grid();
    };
    IgxLiveGridComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype.onImplementationCreated = function () {
    };
    IgxLiveGridComponent.prototype._focusScroller = function () {
        this._scroller.focus();
    };
    IgxLiveGridComponent.prototype._setDefaultCursor = function () {
        if (this._elRef.element.nativeElement.style.cursor !== "") {
            this._elRef.element.nativeElement.style.cursor = "";
        }
    };
    IgxLiveGridComponent.prototype._setResizeCursor = function () {
        if (this._elRef.element.nativeElement.style.cursor !== "col-resize") {
            this._elRef.element.nativeElement.style.cursor = "col-resize";
        }
    };
    IgxLiveGridComponent.prototype._setHandCursor = function () {
        if (this._elRef.element.nativeElement.style.cursor !== "grabbing") {
            this._elRef.element.nativeElement.style.cursor = "grabbing";
        }
    };
    IgxLiveGridComponent.prototype._insertExternalColumnAtIndex = function (index, column) {
        //let contentCount = this.contentColumns.length;
        var contentCount = this._columnsAdapter.actualContent.length;
        this.columns.insert(index - contentCount, column);
    };
    IgxLiveGridComponent.prototype._removeExternalColumn = function (column) {
        var ind = -1;
        for (var i = 0; i < this.columns.count; i++) {
            if (this.columns.item(i) === column) {
                ind = i;
                break;
            }
        }
        if (ind >= 0) {
            this.columns.removeAt(ind);
        }
    };
    IgxLiveGridComponent.prototype.ngAfterContentInit = function () {
        var prev = this._grid.columnPropertyUpdatingAnimationMode;
        this._grid.columnPropertyUpdatingAnimationMode = ColumnPropertyUpdatingAnimationMode.None;
        this._styling(this._elRef.element.nativeElement, this);
        this._grid.columnPropertyUpdatingAnimationMode = prev;
        this._columnsAdapter.updateQuery(this.contentColumns);
        prev = this._grid.columnPropertyUpdatingAnimationMode;
        this._grid.columnPropertyUpdatingAnimationMode = ColumnPropertyUpdatingAnimationMode.None;
        for (var i = 0; i < this.actualColumns.count; i++) {
            var c = this.actualColumns.item(i);
            c._styling(this._elRef.element.nativeElement, this, this);
        }
        this._grid.columnPropertyUpdatingAnimationMode = prev;
        this._grid.itemsSource = this._dataSource;
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "actualDataSource", {
        get: function () {
            return this.i.actualDataSource;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype.refreshContentSize = function () {
        if (this._content != null) {
            var width = this._grid.model.absoluteWidth;
            var height = this._grid.model.absoluteHeight;
            if (this._scroller != null) {
                this._scroller.contentWidth = width;
                this._scroller.contentHeight = height;
            }
        }
    };
    IgxLiveGridComponent.prototype.onScroll = function () {
        var top = this._scroller.scrollTop;
        var left = this._scroller.scrollLeft;
        var width = this._scroller.viewportWidth;
        var height = this._scroller.viewportHeight;
        //console.log("top:" + top);
        this._grid.setViewport(left, top, left + width, top + height);
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            if (this._grid != null) {
                this._grid.itemsSource = this._dataSource;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype.forColumnsWithPropertyPath = function (propertyPath, callback) {
        for (var i = 0; i < this.i.actualColumns.count; i++) {
            var col = this.i.actualColumns.item(i).externalObject;
            if (col.propertyPath == propertyPath) {
                callback(col);
            }
        }
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "defaultColumnWidth", {
        /**
         * Gets or sets the default column width to use if a column as no local width.
         * */
        get: function () {
            var ext = this.i.defaultColumnWidth.externalObject;
            if (!ext) {
                ext = new IgxColumnWidth();
                ext._implementation = this.i.defaultColumnWidth;
            }
            return ext;
        },
        set: function (value) {
            if (typeof value == "string") {
                var int = ColumnWidth_internal.parse(value);
                var ext = new IgxColumnWidth();
                ext._implementation = int;
                value = ext;
            }
            this.i.defaultColumnWidth = value.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "insetLeft", {
        /**
         * Gets or sets the amount of left inset space to use around the grid content.
        */
        get: function () {
            return this._insetLeft;
        },
        set: function (v) {
            this._insetLeft = +v;
            var inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
            this.i.inset = inset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "insetTop", {
        /**
         * Gets or sets the amount of top inset space to use around the grid content.
        */
        get: function () {
            return this._insetTop;
        },
        set: function (v) {
            this._insetTop = +v;
            var inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
            this.i.inset = inset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "insetRight", {
        /**
         * Gets or sets the amount of right inset space to use around the grid content.
        */
        get: function () {
            return this._insetLeft;
        },
        set: function (v) {
            this._insetRight = +v;
            var inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
            this.i.inset = inset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "insetBottom", {
        /**
         * Gets or sets the amount of bottom inset space to use around the grid content.
        */
        get: function () {
            return this._insetBottom;
        },
        set: function (v) {
            this._insetBottom = +v;
            var inset = new Thickness(1, this._insetLeft, this._insetTop, this._insetRight, this._insetBottom);
            this.i.inset = inset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnResizingMode", {
        /**
     * Gets or sets the type of column resizing to use.
    */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = ensureEnum(ColumnResizingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnMovingMode", {
        /**
         * Gets or sets the type column moving to use.
        */
        get: function () {
            return this.i.a7;
        },
        set: function (v) {
            this.i.a7 = ensureEnum(ColumnMovingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sectionHeader", {
        /**
         * Gets or sets the header type used for sectioning off groups of rows.
        */
        get: function () {
            if (this.i.dv == null) {
                return null;
            }
            if (!this.i.dv.externalObject) {
                var e = IgxSectionHeaderComponent._createFromInternal(this.i.dv);
                if (e) {
                    e._implementation = this.i.dv;
                }
                this.i.dv.externalObject = e;
            }
            return this.i.dv.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.dv = null : this.i.dv = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRowRoot", {
        /**
         * Gets or sets the cell definition used for summary rows at the root level.
        */
        get: function () {
            if (this.i.d5 == null) {
                return null;
            }
            if (!this.i.d5.externalObject) {
                var e = IgxSummaryRowRootComponent._createFromInternal(this.i.d5);
                if (e) {
                    e._implementation = this.i.d5;
                }
                this.i.d5.externalObject = e;
            }
            return this.i.d5.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.d5 = null : this.i.d5 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRowSection", {
        /**
         * Gets or sets the cell definition used for summary rows at the section level.
        */
        get: function () {
            if (this.i.d7 == null) {
                return null;
            }
            if (!this.i.d7.externalObject) {
                var e = IgxSummaryRowSectionComponent._createFromInternal(this.i.d7);
                if (e) {
                    e._implementation = this.i.d7;
                }
                this.i.d7.externalObject = e;
            }
            return this.i.d7.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.d7 = null : this.i.d7 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparator", {
        /**
         * Gets or sets the row seperator settings.
        */
        get: function () {
            if (this.i.dr == null) {
                return null;
            }
            if (!this.i.dr.externalObject) {
                var e = IgxRowSeparatorComponent._createFromInternal(this.i.dr);
                if (e) {
                    e._implementation = this.i.dr;
                }
                this.i.dr.externalObject = e;
            }
            return this.i.dr.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.dr = null : this.i.dr = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerSeparator", {
        /**
         * Gets or sets the header seperator settings.
        */
        get: function () {
            if (this.i.c6 == null) {
                return null;
            }
            if (!this.i.c6.externalObject) {
                var e = IgxHeaderSeparatorComponent._createFromInternal(this.i.c6);
                if (e) {
                    e._implementation = this.i.c6;
                }
                this.i.c6.externalObject = e;
            }
            return this.i.c6.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.c6 = null : this.i.c6 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnResizingSeparator", {
        /**
         * Gets or sets the column resizing seperator settings.
        */
        get: function () {
            if (this.i.bi == null) {
                return null;
            }
            if (!this.i.bi.externalObject) {
                var e = IgxColumnResizingSeparatorComponent._createFromInternal(this.i.bi);
                if (e) {
                    e._implementation = this.i.bi;
                }
                this.i.bi.externalObject = e;
            }
            return this.i.bi.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.bi = null : this.i.bi = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnMovingSeparator", {
        /**
         * Gets or sets the column resizing seperator settings.
        */
        get: function () {
            if (this.i.a9 == null) {
                return null;
            }
            if (!this.i.a9.externalObject) {
                var e = IgxColumnMovingSeparatorComponent._createFromInternal(this.i.a9);
                if (e) {
                    e._implementation = this.i.a9;
                }
                this.i.a9.externalObject = e;
            }
            return this.i.a9.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.a9 = null : this.i.a9 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "dataSourceDesiredProperties", {
        /**
         * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowHeight", {
        /**
         * Gets or sets the height to use for the rows in the grid.
        */
        get: function () {
            return this.i.ir;
        },
        set: function (v) {
            this.i.ir = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "defaultColumnMinWidth", {
        /**
         * Gets or sets the default minimum width to use on all columns. Ignored if NaN.
        */
        get: function () {
            return this.i.g9;
        },
        set: function (v) {
            this.i.g9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerHeight", {
        /**
         * Gets or sets the height to use for the header row.
        */
        get: function () {
            return this.i.ik;
        },
        set: function (v) {
            this.i.ik = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerClickAction", {
        /**
         * Returns/sets the action to take when a column header is clicked.
        */
        get: function () {
            return this.i.c4;
        },
        set: function (v) {
            this.i.c4 = ensureEnum(HeaderClickAction_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "autoGenerateColumns", {
        /**
         * Configures whether or not the grid will autogenerate columns when the data source is set.
        */
        get: function () {
            return this.i.fd;
        },
        set: function (v) {
            this.i.fd = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparatorHeight", {
        /**
         * Sets or gets the height to use for the row separators.
        */
        get: function () {
            return this.i.it;
        },
        set: function (v) {
            this.i.it = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isPlaceholderRenderingEnabled", {
        /**
         * Configures whether or not place holders are used for cells who do not have their data yet.
        */
        get: function () {
            return this.i.fz;
        },
        set: function (v) {
            this.i.fz = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnAddingAnimationMode", {
        /**
         * Sets or gets the Column Adding Animation mode to use.
        */
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = ensureEnum(ColumnShowingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnPropertyUpdatingAnimationMode", {
        /**
         * Sets or gets the Column Property Updating Animation mode to use.
        */
        get: function () {
            return this.i.columnPropertyUpdatingAnimationMode;
        },
        set: function (v) {
            this.i.columnPropertyUpdatingAnimationMode = ensureEnum(ColumnPropertyUpdatingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellDataLoadedAnimationMode", {
        /**
         * Sets or gets the cell data loaded animation mode to use.
        */
        get: function () {
            return this.i.ah;
        },
        set: function (v) {
            this.i.ah = ensureEnum(CellDataLoadedAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSelectionAnimationMode", {
        /**
         * Sets or gets the row selection animation mode to use.
        */
        get: function () {
            return this.i.dp;
        },
        set: function (v) {
            this.i.dp = ensureEnum(RowSelectionAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellSelectionAnimationMode", {
        /**
         * Sets or gets the cell selection animation mode to use.
        */
        get: function () {
            return this.i.ar;
        },
        set: function (v) {
            this.i.ar = ensureEnum(CellSelectionAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "animationSettings", {
        /**
         * Sets or gets the default animation settings for the grid.
        */
        get: function () {
            if (this.i.b3 == null) {
                return null;
            }
            if (!this.i.b3.externalObject) {
                var e = new IgxGridAnimationSettings();
                e._implementation = this.i.b3;
                this.i.b3.externalObject = e;
            }
            return this.i.b3.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b3 = null : this.i.b3 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnResizingAnimationMode", {
        /**
         * Sets or gets the column resizing animation mode to use. Only applies when resizing in Deferred mode.
        */
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = ensureEnum(ColumnResizingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnShowingAnimationMode", {
        /**
         * Sets or gets the column showing animation mode to use.
        */
        get: function () {
            return this.i.bm;
        },
        set: function (v) {
            this.i.bm = ensureEnum(ColumnShowingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnMovingAnimationMode", {
        /**
         * Sets or gets the column moving animation mode to use.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = ensureEnum(ColumnMovingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnHidingAnimationMode", {
        /**
         * Sets or gets the column hiding animation mode to use.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = ensureEnum(ColumnHidingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnExchangingAnimationMode", {
        /**
         * Sets or gets the column exchanging animation mode to use.
        */
        get: function () {
            return this.i.aw;
        },
        set: function (v) {
            this.i.aw = ensureEnum(ColumnExchangingAnimationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectionMode", {
        /**
         * Sets or gets the grid selection mode.
        */
        get: function () {
            return this.i.cz;
        },
        set: function (v) {
            this.i.cz = ensureEnum(GridSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "activationMode", {
        /**
         * Sets or gets the grid selection mode.
        */
        get: function () {
            return this.i.by;
        },
        set: function (v) {
            this.i.by = ensureEnum(GridActivationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectionBehavior", {
        /**
         * Sets or gets how selection behaves in the grid.
        */
        get: function () {
            return this.i.cx;
        },
        set: function (v) {
            this.i.cx = ensureEnum(GridSelectionBehavior_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedItems", {
        /**
         * Gets which items are currently selected in the grid. Collection can be updated to programatically select items.
        */
        get: function () {
            if (this._selectedItems === null) {
                var coll = new IgxGridSelectedItemsCollection();
                var innerColl = this.i.z;
                if (!innerColl) {
                    innerColl = new GridSelectedItemsCollection_internal();
                }
                this._selectedItems = coll._fromInner(innerColl);
            }
            return this._selectedItems;
        },
        set: function (v) {
            if (this._selectedItems !== null) {
                this._selectedItems._setSyncTarget(null);
                this._selectedItems = null;
            }
            var coll = new IgxGridSelectedItemsCollection();
            this._selectedItems = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Base.$type);
            var innerColl = this.i.z;
            if (!innerColl) {
                innerColl = new GridSelectedItemsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedItems._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedKeys", {
        /**
         * Gets which primary key values are currently selected in the grid. Collection can be updated to programatically select items.
        */
        get: function () {
            if (this._selectedKeys === null) {
                var coll = new IgxGridSelectedKeysCollection();
                var innerColl = this.i.ad;
                if (!innerColl) {
                    innerColl = new GridSelectedKeysCollection_internal();
                }
                this._selectedKeys = coll._fromInner(innerColl);
            }
            return this._selectedKeys;
        },
        set: function (v) {
            if (this._selectedKeys !== null) {
                this._selectedKeys._setSyncTarget(null);
                this._selectedKeys = null;
            }
            var coll = new IgxGridSelectedKeysCollection();
            this._selectedKeys = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PrimaryKeyValue.$type);
            var innerColl = this.i.ad;
            if (!innerColl) {
                innerColl = new GridSelectedKeysCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedKeys._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedCells", {
        /**
         * Gets which cells are currently selected in the grid. Collection can be updated to programatically select cells.
        */
        get: function () {
            if (this._selectedCells === null) {
                var coll = new IgxGridSelectedCellsCollection();
                var innerColl = this.i.ct;
                if (!innerColl) {
                    innerColl = new GridSelectedCellsCollection_internal();
                }
                this._selectedCells = coll._fromInner(innerColl);
            }
            return this._selectedCells;
        },
        set: function (v) {
            if (this._selectedCells !== null) {
                this._selectedCells._setSyncTarget(null);
                this._selectedCells = null;
            }
            var coll = new IgxGridSelectedCellsCollection();
            this._selectedCells = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(CellKey.$type);
            var innerColl = this.i.ct;
            if (!innerColl) {
                innerColl = new GridSelectedCellsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedCells._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedCellRanges", {
        /**
         * Gets which cell ranges are currently selected in the grid. Collection can be updated to programatically select cells.
        */
        get: function () {
            if (this._selectedCellRanges === null) {
                var coll = new IgxGridSelectedCellRangesCollection();
                var innerColl = this.i.cq;
                if (!innerColl) {
                    innerColl = new GridSelectedCellRangesCollection_internal();
                }
                this._selectedCellRanges = coll._fromInner(innerColl);
            }
            return this._selectedCellRanges;
        },
        set: function (v) {
            if (this._selectedCellRanges !== null) {
                this._selectedCellRanges._setSyncTarget(null);
                this._selectedCellRanges = null;
            }
            var coll = new IgxGridSelectedCellRangesCollection();
            this._selectedCellRanges = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(CellRange.$type);
            var innerColl = this.i.cq;
            if (!innerColl) {
                innerColl = new GridSelectedCellRangesCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedCellRanges._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "pinnedItems", {
        /**
         * Gets which items are currently pinned in the grid. Collection can be updated to programatically pin items.
        */
        get: function () {
            if (this._pinnedItems === null) {
                var coll = new IgxGridSelectedItemsCollection();
                var innerColl = this.i.y;
                if (!innerColl) {
                    innerColl = new GridSelectedItemsCollection_internal();
                }
                this._pinnedItems = coll._fromInner(innerColl);
            }
            return this._pinnedItems;
        },
        set: function (v) {
            if (this._pinnedItems !== null) {
                this._pinnedItems._setSyncTarget(null);
                this._pinnedItems = null;
            }
            var coll = new IgxGridSelectedItemsCollection();
            this._pinnedItems = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Base.$type);
            var innerColl = this.i.y;
            if (!innerColl) {
                innerColl = new GridSelectedItemsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._pinnedItems._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "pinnedKeys", {
        /**
         * Gets which primary keys are currently pinned in the grid. Collection can be updated to programatically pin items.
        */
        get: function () {
            if (this._pinnedKeys === null) {
                var coll = new IgxGridSelectedKeysCollection();
                var innerColl = this.i.ac;
                if (!innerColl) {
                    innerColl = new GridSelectedKeysCollection_internal();
                }
                this._pinnedKeys = coll._fromInner(innerColl);
            }
            return this._pinnedKeys;
        },
        set: function (v) {
            if (this._pinnedKeys !== null) {
                this._pinnedKeys._setSyncTarget(null);
                this._pinnedKeys = null;
            }
            var coll = new IgxGridSelectedKeysCollection();
            this._pinnedKeys = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PrimaryKeyValue.$type);
            var innerColl = this.i.ac;
            if (!innerColl) {
                innerColl = new GridSelectedKeysCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._pinnedKeys._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isFilterUIEnabled", {
        /**
         * Gets or sets whether to show the filtering UI in the headers for columns where filtering is enabled.
        */
        get: function () {
            return this.i.fs;
        },
        set: function (v) {
            this.i.fs = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isGroupRowSticky", {
        /**
         * Gets or sets if group rows will stick to the top of the grid.
        */
        get: function () {
            return this.i.fv;
        },
        set: function (v) {
            this.i.fv = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isHeaderSeparatorVisible", {
        /**
         * Gets or sets if header separators are rendered.
        */
        get: function () {
            return this.i.fw;
        },
        set: function (v) {
            this.i.fw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellSelectedBackground", {
        /**
         * Gets or sets the default background color to use for content cells when a row is in a selected state
        */
        get: function () {
            return brushToString(this.i.pw);
        },
        set: function (v) {
            this.i.pw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sectionHeaderSelectedBackground", {
        /**
         * Gets or sets the default background color to use for section header cells when a row is in a selected state
        */
        get: function () {
            return brushToString(this.i.qb);
        },
        set: function (v) {
            this.i.qb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRootBackground", {
        /**
         * Gets or sets the default background color to use for summary cells at the root level.
        */
        get: function () {
            return brushToString(this.i.qe);
        },
        set: function (v) {
            this.i.qe = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summarySectionBackground", {
        /**
         * Gets or sets the default background color to use for summary cells at the section level.
        */
        get: function () {
            return brushToString(this.i.qi);
        },
        set: function (v) {
            this.i.qi = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "pinnedRowOpacity", {
        /**
         * Gets or sets the default opacity to use for pinned rows
        */
        get: function () {
            return this.i.ha;
        },
        set: function (v) {
            this.i.ha = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "stickyRowBackground", {
        /**
         * Gets or sets the default color to use for sticky rows
        */
        get: function () {
            return brushToString(this.i.qd);
        },
        set: function (v) {
            this.i.qd = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "pinnedRowBackground", {
        /**
         * Gets or sets the default color to use for pinned rows
        */
        get: function () {
            return brushToString(this.i.p5);
        },
        set: function (v) {
            this.i.p5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "lastStickyRowBackground", {
        /**
         * Gets or sets the default color to use for the last sticky row
        */
        get: function () {
            return brushToString(this.i.p4);
        },
        set: function (v) {
            this.i.p4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "activeCell", {
        /**
         * Gets or sets the position of the active cell.
        */
        get: function () {
            if (this.i.ca == null) {
                return null;
            }
            if (!this.i.ca.externalObject) {
                var e = new IgxGridCellPosition();
                e._implementation = this.i.ca;
                this.i.ca.externalObject = e;
            }
            return this.i.ca.externalObject;
        },
        set: function (v) {
            v == null ? this.i.ca = null : this.i.ca = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellBackground", {
        /**
         * Gets or sets the default background color to use for content cells
        */
        get: function () {
            return brushToString(this.i.pv);
        },
        set: function (v) {
            this.i.pv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellTextColor", {
        /**
         * Gets or sets the default text color to use for content cells
        */
        get: function () {
            return brushToString(this.i.px);
        },
        set: function (v) {
            this.i.px = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerSortIndicatorColor", {
        /**
         * Gets or sets the default text color to use for content cells
        */
        get: function () {
            return brushToString(this.i.p2);
        },
        set: function (v) {
            this.i.p2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerSortIndicatorStyle", {
        /**
         * Gets or sets the default render style for sort indicators in header cells.
        */
        get: function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellTextStyle", {
        /**
         * Gets or sets the font to use for content cells
        */
        get: function () {
            if (this.i.eh == null) {
                return null;
            }
            return this.i.eh.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.eh = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sectionHeaderBackground", {
        /**
         * Gets or sets the default background color to use for section header cells
        */
        get: function () {
            return brushToString(this.i.qa);
        },
        set: function (v) {
            this.i.qa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sectionHeaderTextColor", {
        /**
         * Gets or sets the default text color to use for section header cells
        */
        get: function () {
            return brushToString(this.i.qc);
        },
        set: function (v) {
            this.i.qc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sectionHeaderTextStyle", {
        /**
         * Gets or sets the font to use for section header cells
        */
        get: function () {
            if (this.i.ej == null) {
                return null;
            }
            return this.i.ej.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ej = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRootTextColor", {
        /**
         * Gets or sets the default text color to use for summary cells at the root level.
        */
        get: function () {
            return brushToString(this.i.qh);
        },
        set: function (v) {
            this.i.qh = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summarySectionTextColor", {
        /**
         * Gets or sets the default text color to use for summary cells at the section level.
        */
        get: function () {
            return brushToString(this.i.ql);
        },
        set: function (v) {
            this.i.ql = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRootNameTextColor", {
        /**
         * Gets or sets the default text color to use for summary names in summary cells at the root level.
        */
        get: function () {
            return brushToString(this.i.qf);
        },
        set: function (v) {
            this.i.qf = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summarySectionNameTextColor", {
        /**
         * Gets or sets the default text color to use for summary names in summary cells at the section level.
        */
        get: function () {
            return brushToString(this.i.qj);
        },
        set: function (v) {
            this.i.qj = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryRootSelectedBackground", {
        /**
         * Gets or sets the default background color to use for summary cells at the root level.
        */
        get: function () {
            return brushToString(this.i.qg);
        },
        set: function (v) {
            this.i.qg = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summarySectionSelectedBackground", {
        /**
         * Gets or sets the default background color to use for summary cells at the section level.
        */
        get: function () {
            return brushToString(this.i.qk);
        },
        set: function (v) {
            this.i.qk = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryTextStyle", {
        /**
         * Gets or sets the font to use for summary cells
        */
        get: function () {
            if (this.i.el == null) {
                return null;
            }
            return this.i.el.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.el = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summarySectionTextStyle", {
        /**
         * Gets or sets the font to use for header cells
        */
        get: function () {
            if (this.i.ek == null) {
                return null;
            }
            return this.i.ek.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ek = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerSeparatorWidth", {
        /**
         * Gets or sets the default background color to use for header separators.
        */
        get: function () {
            return this.i.ip;
        },
        set: function (v) {
            this.i.ip = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerSeparatorBackground", {
        /**
         * Gets or sets the default background color to use for header separators.
        */
        get: function () {
            return brushToString(this.i.p1);
        },
        set: function (v) {
            this.i.p1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerBackground", {
        /**
         * Gets or sets the default background color to use for header cells
        */
        get: function () {
            return brushToString(this.i.p0);
        },
        set: function (v) {
            this.i.p0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerTextColor", {
        /**
         * Gets or sets the default text color to use for header cells
        */
        get: function () {
            return brushToString(this.i.p3);
        },
        set: function (v) {
            this.i.p3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "headerTextStyle", {
        /**
         * Gets or sets the font to use for header cells
        */
        get: function () {
            if (this.i.ei == null) {
                return null;
            }
            return this.i.ei.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.ei = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparatorBackground", {
        /**
         * Gets or sets the default background color to use for row separators
        */
        get: function () {
            return brushToString(this.i.p6);
        },
        set: function (v) {
            this.i.p6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparatorStickyRowBackground", {
        /**
         * Gets or sets the default sticky row background color to use for row separators
        */
        get: function () {
            return brushToString(this.i.p9);
        },
        set: function (v) {
            this.i.p9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparatorLastStickyRowBackground", {
        /**
         * Gets or sets the default last sticky row background color to use for row separators
        */
        get: function () {
            return brushToString(this.i.p7);
        },
        set: function (v) {
            this.i.p7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "rowSeparatorPinnedRowBackground", {
        /**
         * Gets or sets the pinned row background color to use for row separators
        */
        get: function () {
            return brushToString(this.i.p8);
        },
        set: function (v) {
            this.i.p8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnResizingSeparatorWidth", {
        /**
         * Sets or gets the width to use for the column resizing separator.
        */
        get: function () {
            return this.i.h3;
        },
        set: function (v) {
            this.i.h3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnMovingSeparatorWidth", {
        /**
         * Sets or gets the width to use for the column resizing separator.
        */
        get: function () {
            return this.i.h1;
        },
        set: function (v) {
            this.i.h1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnResizingSeparatorBackground", {
        /**
         * Gets or sets the default background color to use for column resizing separator.
        */
        get: function () {
            return brushToString(this.i.pz);
        },
        set: function (v) {
            this.i.pz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnMovingSeparatorBackground", {
        /**
         * Gets or sets the default background color to use for column moving separator.
        */
        get: function () {
            return brushToString(this.i.py);
        },
        set: function (v) {
            this.i.py = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "responsiveStates", {
        /**
         * A set of states that can be applied to the columns of the grid based on available space.
        */
        get: function () {
            if (this._responsiveStates === null) {
                var coll = new IgxResponsiveStatesCollection();
                var innerColl = this.i.dl;
                if (!innerColl) {
                    innerColl = new ResponsiveStatesCollection_internal();
                }
                this._responsiveStates = coll._fromInner(innerColl);
            }
            return this._responsiveStates;
        },
        set: function (v) {
            if (this._responsiveStates !== null) {
                this._responsiveStates._setSyncTarget(null);
                this._responsiveStates = null;
            }
            var coll = new IgxResponsiveStatesCollection();
            this._responsiveStates = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(ResponsiveState.$type);
            var innerColl = this.i.dl;
            if (!innerColl) {
                innerColl = new ResponsiveStatesCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._responsiveStates._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "actualVisibleRegion", {
        /**
         * Gets the region of the grid that is visible.
        */
        get: function () {
            return fromRect(this.i.qn);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sortDescriptions", {
        /**
         * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
        */
        get: function () {
            if (this.i.bq == null) {
                return null;
            }
            if (!this.i.bq.externalObject) {
                var e = new IgxColumnSortDescriptionCollection();
                e._implementation = this.i.bq;
                this.i.bq.externalObject = e;
            }
            return this.i.bq.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "groupDescriptions", {
        /**
         * Gets the current grouping that is applied to the grid. Collection can be updated to modify the grouping for the grid. Once grouping descriptions are in this collection, the grid will no longer listen for changes on their properties.
        */
        get: function () {
            if (this.i.az == null) {
                return null;
            }
            if (!this.i.az.externalObject) {
                var e = new IgxColumnGroupDescriptionCollection();
                e._implementation = this.i.az;
                this.i.az.externalObject = e;
            }
            return this.i.az.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "filterExpressions", {
        /**
         * Gets the current filter that is applied to the grid. Collection can be updated to modify the filter for the grid. Once filter expresisons are in this collection, the grid will no longer listen for changes on their properties.
        */
        get: function () {
            if (this.i.t == null) {
                return null;
            }
            if (!this.i.t.externalObject) {
                var e = new IgxFilterExpressionCollection();
                e._implementation = this.i.t;
                this.i.t.externalObject = e;
            }
            return this.i.t.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryDescriptions", {
        /**
         * Gets the current summaries that are applied to the grid.
        */
        get: function () {
            if (this.i.bt == null) {
                return null;
            }
            if (!this.i.bt.externalObject) {
                var e = new IgxColumnSummaryDescriptionCollection();
                e._implementation = this.i.bt;
                this.i.bt.externalObject = e;
            }
            return this.i.bt.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "summaryScope", {
        /**
         * Gets or sets the scope which summaries are calculated for.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = ensureEnum(DataSourceSummaryScope_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isGroupCollapsable", {
        /**
         * Gets or sets whether group headers are collapsable.
        */
        get: function () {
            return this.i.ft;
        },
        set: function (v) {
            this.i.ft = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "groupHeaderDisplayMode", {
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = ensureEnum(DataSourceSectionHeaderDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "isGroupExpandedDefault", {
        /**
         * Gets or sets whether groups are expanded or collapsed by default.
        */
        get: function () {
            return this.i.fu;
        },
        set: function (v) {
            this.i.fu = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "groupSummaryDisplayMode", {
        /**
         * Gets or sets the display mode summaries will use inside groups.
        */
        get: function () {
            return this.i.c2;
        },
        set: function (v) {
            this.i.c2 = ensureEnum(GroupSummaryDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "primaryKey", {
        /**
         * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
         * If a primary key cannot be inferred from the data source, you may need to provide one here.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "actualPrimaryKey", {
        /**
         * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "actualColumns", {
        get: function () {
            if (this._actualColumns === null) {
                var coll = new IgxGridColumnCollection();
                var innerColl = this.i.actualColumns;
                if (!innerColl) {
                    innerColl = new GridColumnCollection_internal();
                }
                this._actualColumns = coll._fromInner(innerColl);
            }
            return this._actualColumns;
        },
        set: function (v) {
            if (this._actualColumns !== null) {
                this._actualColumns._setSyncTarget(null);
                this._actualColumns = null;
            }
            var coll = new IgxGridColumnCollection();
            this._actualColumns = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Column.$type);
            var innerColl = this.i.actualColumns;
            if (!innerColl) {
                innerColl = new GridColumnCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._actualColumns._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "reactsToSortChanges", {
        /**
         * Sets or gets whether the grid will react to sort changes.
        */
        get: function () {
            return this.i.gh;
        },
        set: function (v) {
            this.i.gh = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "reactsToGroupChanges", {
        /**
         * Sets or gets whether the grid will react to group changes.
        */
        get: function () {
            return this.i.gg;
        },
        set: function (v) {
            this.i.gg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "reactsToFilterChanges", {
        /**
         * Sets or gets whether the grid will react to filter changes.
        */
        get: function () {
            return this.i.gf;
        },
        set: function (v) {
            this.i.gf = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgxLiveGridComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LiveGridComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this.sectionHeader && this.sectionHeader._styling) {
            this.sectionHeader._styling(container, component, this);
        }
        if (this.summaryRowRoot && this.summaryRowRoot._styling) {
            this.summaryRowRoot._styling(container, component, this);
        }
        if (this.summaryRowSection && this.summaryRowSection._styling) {
            this.summaryRowSection._styling(container, component, this);
        }
        if (this.rowSeparator && this.rowSeparator._styling) {
            this.rowSeparator._styling(container, component, this);
        }
        if (this.headerSeparator && this.headerSeparator._styling) {
            this.headerSeparator._styling(container, component, this);
        }
        if (this.columnResizingSeparator && this.columnResizingSeparator._styling) {
            this.columnResizingSeparator._styling(container, component, this);
        }
        if (this.columnMovingSeparator && this.columnMovingSeparator._styling) {
            this.columnMovingSeparator._styling(container, component, this);
        }
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgxLiveGridComponent.prototype.getHitCell = function (x, y) {
        var iv = this.i.al(x, y);
        return (iv == null ? null : iv.externalObject);
    };
    /**
     * Forces a refresh of the grid content.
    
    */
    IgxLiveGridComponent.prototype.refresh = function () {
        this.i.n9();
    };
    /**
     * Makes sure pending work has completed if the grid need to be synchronously examined.
    
    */
    IgxLiveGridComponent.prototype.flush = function () {
        this.i.ma();
    };
    IgxLiveGridComponent.prototype.exchangeColumn = function (newColumn, oldColumn) {
        this.i.l9((newColumn == null ? null : newColumn.i), (oldColumn == null ? null : oldColumn.i));
    };
    IgxLiveGridComponent.prototype.moveColumn = function (oldIndex, newIndex) {
        this.i.mk(oldIndex, newIndex);
    };
    /**
     * Exports visual information about the current state of the grid.
    
    */
    IgxLiveGridComponent.prototype.exportVisualModel = function () {
        var iv = this.i.i0();
        return (iv);
    };
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    IgxLiveGridComponent.prototype.exportSerializedVisualModel = function () {
        var iv = this.i.j0();
        return (iv);
    };
    /**
     * Scrolls the grid to given row, by index
    
    * @param rowNumber  * The row index to scroll to.
    */
    IgxLiveGridComponent.prototype.scrollToRowByIndex = function (rowNumber) {
        this.i.on(rowNumber);
    };
    /**
     * Scrolls the grid so that a row is the last visible, by index.
    
    * @param rowNumber  * The row index to scroll to.
    */
    IgxLiveGridComponent.prototype.scrollToLastRowByIndex = function (rowNumber) {
        this.i.om(rowNumber);
    };
    /**
     * Scrolls to an item, if found.
    
    * @param item  * The item to scroll to.
    */
    IgxLiveGridComponent.prototype.scrollToItem = function (item) {
        var iv = this.i.gm(item);
        return (iv);
    };
    IgxLiveGridComponent.prototype.scrollToPrimaryKey = function (key) {
        var iv = this.i.gn(key);
        return (iv);
    };
    /**
     * Scrolls the grid to given column, by index
    
    * @param columnNumber  * The column number to scroll to.
    */
    IgxLiveGridComponent.prototype.scrollToColumnByIndex = function (columnNumber) {
        this.i.ok(columnNumber);
    };
    /**
     * Gets the last visible index in the grid.
    
    */
    IgxLiveGridComponent.prototype.getLastVisibleIndex = function () {
        var iv = this.i.ig();
        return (iv);
    };
    /**
     * Gets the first visible index in the grid.
    
    */
    IgxLiveGridComponent.prototype.getFirstVisibleIndex = function () {
        var iv = this.i.ic();
        return (iv);
    };
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    IgxLiveGridComponent.prototype.invalidateVisibleRows = function () {
        this.i.mj();
    };
    /**
     * Manually set the active responsive state of the grid.
    
    * @param name
    */
    IgxLiveGridComponent.prototype.setActiveResponsiveState = function (name) {
        this.i.ot(name);
    };
    IgxLiveGridComponent.prototype.notifySetItem = function (index, oldItem, newItem) {
        this.i.mq(index, oldItem, newItem);
    };
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    IgxLiveGridComponent.prototype.notifyClearItems = function () {
        this.i.mm();
    };
    IgxLiveGridComponent.prototype.notifyInsertItem = function (index, newItem) {
        this.i.mo(index, newItem);
    };
    IgxLiveGridComponent.prototype.notifyRemoveItem = function (index, oldItem) {
        this.i.mp(index, oldItem);
    };
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    IgxLiveGridComponent.prototype.dataIndexOfItem = function (item) {
        var iv = this.i.h5(item);
        return (iv);
    };
    IgxLiveGridComponent.prototype.dataIndexOfPrimaryKey = function (key) {
        var iv = this.i.h6(key);
        return (iv);
    };
    /**
     * Resolves the value of a specific cell.
    
    * @param cellKey  * The cell to resolve.
    */
    IgxLiveGridComponent.prototype.resolveCellValue = function (cellKey) {
        var iv = this.i.i2((cellKey == null ? null : cellKey.i));
        return (iv);
    };
    IgxLiveGridComponent.prototype.resolveCellValueFromPosition = function (row, column) {
        var iv = this.i.i3(row, column);
        return (iv);
    };
    /**
     * Gets the summary results for root level.
    
    */
    IgxLiveGridComponent.prototype.getRootSummaryResults = function () {
        var iv = this.i.h();
        return (iv);
    };
    /**
     * Gets the summary results for a specific section.
    
    */
    IgxLiveGridComponent.prototype.getSectionSummaryResults = function (sectionIndex) {
        var iv = this.i.i(sectionIndex);
        return (iv);
    };
    Object.defineProperty(IgxLiveGridComponent.prototype, "filterExpressionsChanging", {
        get: function () {
            var _this = this;
            if (this._filterExpressionsChanging == null) {
                this._filterExpressionsChanging = new EventEmitter();
                this.i.filterExpressionsChanging = delegateCombine(this.i.filterExpressionsChanging, function (o, e) {
                    var outerArgs = new IgxGridFilterExpressionsEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeFilterExpressionsChanging) {
                        _this.beforeFilterExpressionsChanging(_this, outerArgs);
                    }
                    _this._filterExpressionsChanging.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._filterExpressionsChanging;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "filterExpressionsChanged", {
        get: function () {
            var _this = this;
            if (this._filterExpressionsChanged == null) {
                this._filterExpressionsChanged = new EventEmitter();
                this.i.filterExpressionsChanged = delegateCombine(this.i.filterExpressionsChanged, function (o, e) {
                    var outerArgs = new IgxGridFilterExpressionsEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeFilterExpressionsChanged) {
                        _this.beforeFilterExpressionsChanged(_this, outerArgs);
                    }
                    _this._filterExpressionsChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._filterExpressionsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellPreviewPointerDown", {
        /**
         * Previews that a pointer is down on a cell.
        */
        get: function () {
            var _this = this;
            if (this._cellPreviewPointerDown == null) {
                this._cellPreviewPointerDown = new EventEmitter();
                this.i.cellPreviewPointerDown = delegateCombine(this.i.cellPreviewPointerDown, function (o, e) {
                    var outerArgs = new IgxGridCellEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellPreviewPointerDown) {
                        _this.beforeCellPreviewPointerDown(_this, outerArgs);
                    }
                    _this._cellPreviewPointerDown.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellPreviewPointerDown;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellPreviewPointerUp", {
        /**
         * Previews that a pointer is up on a cell.
        */
        get: function () {
            var _this = this;
            if (this._cellPreviewPointerUp == null) {
                this._cellPreviewPointerUp = new EventEmitter();
                this.i.cellPreviewPointerUp = delegateCombine(this.i.cellPreviewPointerUp, function (o, e) {
                    var outerArgs = new IgxGridCellEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellPreviewPointerUp) {
                        _this.beforeCellPreviewPointerUp(_this, outerArgs);
                    }
                    _this._cellPreviewPointerUp.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellPreviewPointerUp;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellPointerDown", {
        /**
         * Indicates a pointer is down on a cell.
        */
        get: function () {
            var _this = this;
            if (this._cellPointerDown == null) {
                this._cellPointerDown = new EventEmitter();
                this.i.cellPointerDown = delegateCombine(this.i.cellPointerDown, function (o, e) {
                    var outerArgs = new IgxGridCellEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellPointerDown) {
                        _this.beforeCellPointerDown(_this, outerArgs);
                    }
                    _this._cellPointerDown.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellPointerDown;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellPointerUp", {
        /**
         * Indicates a pointer is up on a cell.
        */
        get: function () {
            var _this = this;
            if (this._cellPointerUp == null) {
                this._cellPointerUp = new EventEmitter();
                this.i.cellPointerUp = delegateCombine(this.i.cellPointerUp, function (o, e) {
                    var outerArgs = new IgxGridCellEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellPointerUp) {
                        _this.beforeCellPointerUp(_this, outerArgs);
                    }
                    _this._cellPointerUp.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellPointerUp;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "cellClicked", {
        /**
         * Called when a cell is clicked.
        */
        get: function () {
            var _this = this;
            if (this._cellClicked == null) {
                this._cellClicked = new EventEmitter();
                this.i.cellClicked = delegateCombine(this.i.cellClicked, function (o, e) {
                    var outerArgs = new IgxGridCellEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellClicked) {
                        _this.beforeCellClicked(_this, outerArgs);
                    }
                    _this._cellClicked.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellClicked;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "sortDescriptionsChanged", {
        /**
         * Called when sorting has changed.
        */
        get: function () {
            var _this = this;
            if (this._sortDescriptionsChanged == null) {
                this._sortDescriptionsChanged = new EventEmitter();
                this.i.sortDescriptionsChanged = delegateCombine(this.i.sortDescriptionsChanged, function (o, e) {
                    var outerArgs = new IgxGridSortDescriptionsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSortDescriptionsChanged) {
                        _this.beforeSortDescriptionsChanged(_this, outerArgs);
                    }
                    _this._sortDescriptionsChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._sortDescriptionsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "groupDescriptionsChanged", {
        /**
         * Called when grouping has changed.
        */
        get: function () {
            var _this = this;
            if (this._groupDescriptionsChanged == null) {
                this._groupDescriptionsChanged = new EventEmitter();
                this.i.groupDescriptionsChanged = delegateCombine(this.i.groupDescriptionsChanged, function (o, e) {
                    var outerArgs = new IgxGridGroupDescriptionsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeGroupDescriptionsChanged) {
                        _this.beforeGroupDescriptionsChanged(_this, outerArgs);
                    }
                    _this._groupDescriptionsChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._groupDescriptionsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "columnsAutoGenerated", {
        /**
         * Called when the columns are autogenerated.
        */
        get: function () {
            var _this = this;
            if (this._columnsAutoGenerated == null) {
                this._columnsAutoGenerated = new EventEmitter();
                this.i.columnsAutoGenerated = delegateCombine(this.i.columnsAutoGenerated, function (o, e) {
                    var outerArgs = new IgxGridColumnsAutoGeneratedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeColumnsAutoGenerated) {
                        _this.beforeColumnsAutoGenerated(_this, outerArgs);
                    }
                    _this._columnsAutoGenerated.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._columnsAutoGenerated;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedItemsChanged", {
        /**
         * Called when the selected items change.
        */
        get: function () {
            var _this = this;
            if (this._selectedItemsChanged == null) {
                this._selectedItemsChanged = new EventEmitter();
                this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, function (o, e) {
                    var outerArgs = new IgxGridSelectedItemsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSelectedItemsChanged) {
                        _this.beforeSelectedItemsChanged(_this, outerArgs);
                    }
                    _this._selectedItemsChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._selectedItemsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedKeysChanged", {
        /**
         * Called when the selected keys change.
        */
        get: function () {
            var _this = this;
            if (this._selectedKeysChanged == null) {
                this._selectedKeysChanged = new EventEmitter();
                this.i.selectedKeysChanged = delegateCombine(this.i.selectedKeysChanged, function (o, e) {
                    var outerArgs = new IgxGridSelectedKeysChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSelectedKeysChanged) {
                        _this.beforeSelectedKeysChanged(_this, outerArgs);
                    }
                    _this._selectedKeysChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._selectedKeysChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedCellsChanged", {
        /**
         * Called when the selected cells change.
        */
        get: function () {
            var _this = this;
            if (this._selectedCellsChanged == null) {
                this._selectedCellsChanged = new EventEmitter();
                this.i.selectedCellsChanged = delegateCombine(this.i.selectedCellsChanged, function (o, e) {
                    var outerArgs = new IgxGridSelectedCellsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSelectedCellsChanged) {
                        _this.beforeSelectedCellsChanged(_this, outerArgs);
                    }
                    _this._selectedCellsChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._selectedCellsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "activeCellChanged", {
        /**
         * Called when the active cell changes.
        */
        get: function () {
            var _this = this;
            if (this._activeCellChanged == null) {
                this._activeCellChanged = new EventEmitter();
                this.i.activeCellChanged = delegateCombine(this.i.activeCellChanged, function (o, e) {
                    var outerArgs = new IgxGridActiveCellChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeActiveCellChanged) {
                        _this.beforeActiveCellChanged(_this, outerArgs);
                    }
                    _this._activeCellChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._activeCellChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridComponent.prototype, "selectedCellRangesChanged", {
        /**
         * Called when the selected cell ranges changed.
        */
        get: function () {
            var _this = this;
            if (this._selectedCellRangesChanged == null) {
                this._selectedCellRangesChanged = new EventEmitter();
                this.i.selectedCellRangesChanged = delegateCombine(this.i.selectedCellRangesChanged, function (o, e) {
                    var outerArgs = new IgxGridSelectedCellRangesChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSelectedCellRangesChanged) {
                        _this.beforeSelectedCellRangesChanged(_this, outerArgs);
                    }
                    _this._selectedCellRangesChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._selectedCellRangesChanged;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    tslib_1.__decorate([
        ContentChildren(IgxColumnComponent),
        tslib_1.__metadata("design:type", QueryList)
    ], IgxLiveGridComponent.prototype, "contentColumns", void 0);
    tslib_1.__decorate([
        ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
        tslib_1.__metadata("design:type", ViewContainerRef)
    ], IgxLiveGridComponent.prototype, "_dynamicContent", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "height", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "width", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "scrollbarStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], IgxLiveGridComponent.prototype, "dataSource", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnResizingMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnMovingMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxSectionHeaderComponent),
        tslib_1.__metadata("design:paramtypes", [IgxSectionHeaderComponent])
    ], IgxLiveGridComponent.prototype, "sectionHeader", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxSummaryRowRootComponent),
        tslib_1.__metadata("design:paramtypes", [IgxSummaryRowRootComponent])
    ], IgxLiveGridComponent.prototype, "summaryRowRoot", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxSummaryRowSectionComponent),
        tslib_1.__metadata("design:paramtypes", [IgxSummaryRowSectionComponent])
    ], IgxLiveGridComponent.prototype, "summaryRowSection", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxRowSeparatorComponent),
        tslib_1.__metadata("design:paramtypes", [IgxRowSeparatorComponent])
    ], IgxLiveGridComponent.prototype, "rowSeparator", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxHeaderSeparatorComponent),
        tslib_1.__metadata("design:paramtypes", [IgxHeaderSeparatorComponent])
    ], IgxLiveGridComponent.prototype, "headerSeparator", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxColumnResizingSeparatorComponent),
        tslib_1.__metadata("design:paramtypes", [IgxColumnResizingSeparatorComponent])
    ], IgxLiveGridComponent.prototype, "columnResizingSeparator", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxColumnMovingSeparatorComponent),
        tslib_1.__metadata("design:paramtypes", [IgxColumnMovingSeparatorComponent])
    ], IgxLiveGridComponent.prototype, "columnMovingSeparator", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Array),
        tslib_1.__metadata("design:paramtypes", [Array])
    ], IgxLiveGridComponent.prototype, "dataSourceDesiredProperties", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "rowHeight", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "defaultColumnMinWidth", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "headerHeight", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "headerClickAction", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "autoGenerateColumns", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "rowSeparatorHeight", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isPlaceholderRenderingEnabled", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnAddingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnPropertyUpdatingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "cellDataLoadedAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "rowSelectionAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "cellSelectionAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridAnimationSettings),
        tslib_1.__metadata("design:paramtypes", [IgxGridAnimationSettings])
    ], IgxLiveGridComponent.prototype, "animationSettings", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnResizingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnShowingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnMovingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnHidingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnExchangingAnimationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "selectionMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "activationMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "selectionBehavior", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedItemsCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedItemsCollection])
    ], IgxLiveGridComponent.prototype, "selectedItems", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedKeysCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedKeysCollection])
    ], IgxLiveGridComponent.prototype, "selectedKeys", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedCellsCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedCellsCollection])
    ], IgxLiveGridComponent.prototype, "selectedCells", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedCellRangesCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedCellRangesCollection])
    ], IgxLiveGridComponent.prototype, "selectedCellRanges", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedItemsCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedItemsCollection])
    ], IgxLiveGridComponent.prototype, "pinnedItems", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridSelectedKeysCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridSelectedKeysCollection])
    ], IgxLiveGridComponent.prototype, "pinnedKeys", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isFilterUIEnabled", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isGroupRowSticky", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isHeaderSeparatorVisible", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "cellSelectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "sectionHeaderSelectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summaryRootBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summarySectionBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "pinnedRowOpacity", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "stickyRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "pinnedRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "lastStickyRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridCellPosition),
        tslib_1.__metadata("design:paramtypes", [IgxGridCellPosition])
    ], IgxLiveGridComponent.prototype, "activeCell", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "cellBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "cellTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "headerSortIndicatorColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "headerSortIndicatorStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "cellTextStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "sectionHeaderBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "sectionHeaderTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "sectionHeaderTextStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summaryRootTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summarySectionTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summaryRootNameTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summarySectionNameTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summaryRootSelectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summarySectionSelectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summaryTextStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "summarySectionTextStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "headerSeparatorWidth", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "headerSeparatorBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "headerBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "headerTextColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "headerTextStyle", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "rowSeparatorBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "rowSeparatorStickyRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "rowSeparatorLastStickyRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "rowSeparatorPinnedRowBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnResizingSeparatorWidth", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "columnMovingSeparatorWidth", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "columnResizingSeparatorBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridComponent.prototype, "columnMovingSeparatorBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxResponsiveStatesCollection),
        tslib_1.__metadata("design:paramtypes", [IgxResponsiveStatesCollection])
    ], IgxLiveGridComponent.prototype, "responsiveStates", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "summaryScope", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isGroupCollapsable", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "groupHeaderDisplayMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "isGroupExpandedDefault", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridComponent.prototype, "groupSummaryDisplayMode", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Array),
        tslib_1.__metadata("design:paramtypes", [Array])
    ], IgxLiveGridComponent.prototype, "primaryKey", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Array),
        tslib_1.__metadata("design:paramtypes", [Array])
    ], IgxLiveGridComponent.prototype, "actualPrimaryKey", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", IgxGridColumnCollection),
        tslib_1.__metadata("design:paramtypes", [IgxGridColumnCollection])
    ], IgxLiveGridComponent.prototype, "actualColumns", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "reactsToSortChanges", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "reactsToGroupChanges", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridComponent.prototype, "reactsToFilterChanges", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "filterExpressionsChanging", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "filterExpressionsChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "cellPreviewPointerDown", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "cellPreviewPointerUp", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "cellPointerDown", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "cellPointerUp", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "cellClicked", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "sortDescriptionsChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "groupDescriptionsChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "columnsAutoGenerated", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "selectedItemsChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "selectedKeysChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "selectedCellsChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "activeCellChanged", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridComponent.prototype, "selectedCellRangesChanged", null);
    IgxLiveGridComponent = tslib_1.__decorate([
        Component({
            selector: 'igx-live-grid',
            styles: [":host {\n\t\tdisplay: block;\n\t}"],
            template: "\n    <ng-container #dynamicContent></ng-container>\n  ",
            host: { 'class': 'ig-live-grid igx-live-grid' },
            providers: [],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [Renderer2,
            ViewContainerRef,
            NgZone,
            ComponentFactoryResolver,
            Injector])
    ], IgxLiveGridComponent);
    return IgxLiveGridComponent;
}());
export { IgxLiveGridComponent };
//# sourceMappingURL=igx-live-grid-component.js.map