import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxGridFilterDialogOpeningEventArgs } from "./igx-grid-filter-dialog-opening-event-args";
import { IgxGridFilterDialogFilterChangeEventArgs } from "./igx-grid-filter-dialog-filter-change-event-args";
import { GridFilterDialog } from "./GridFilterDialog";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
/**
 * An advanced grid for displaying data.
*/
export var IgxLiveGridFilterDialogComponent_PROVIDERS = [];
var IgxLiveGridFilterDialogComponent = /** @class */ (function () {
    function IgxLiveGridFilterDialogComponent() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._dialogOpening = null;
        this._filterChanging = null;
        this._filterChanged = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxLiveGridFilterDialogComponent.prototype.createImplementation = function () {
        return new GridFilterDialog();
    };
    IgxLiveGridFilterDialogComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgxLiveGridFilterDialogComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgxLiveGridFilterDialogComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "isAnimationEnabled", {
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridFilterDialogComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgxLiveGridFilterDialogComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LiveGridFilterDialogComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgxLiveGridFilterDialogComponent.prototype.notifySizeChanged = function (width, height) {
        this.i.ai(width, height);
    };
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "dialogOpening", {
        get: function () {
            var _this = this;
            if (this._dialogOpening == null) {
                this._dialogOpening = new EventEmitter();
                this.i.dialogOpening = delegateCombine(this.i.dialogOpening, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxGridFilterDialogOpeningEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeDialogOpening) {
                            _this.beforeDialogOpening(_this, outerArgs);
                        }
                        _this._dialogOpening.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._dialogOpening;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "filterChanging", {
        get: function () {
            var _this = this;
            if (this._filterChanging == null) {
                this._filterChanging = new EventEmitter();
                this.i.filterChanging = delegateCombine(this.i.filterChanging, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxGridFilterDialogFilterChangeEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeFilterChanging) {
                            _this.beforeFilterChanging(_this, outerArgs);
                        }
                        _this._filterChanging.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._filterChanging;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridFilterDialogComponent.prototype, "filterChanged", {
        get: function () {
            var _this = this;
            if (this._filterChanged == null) {
                this._filterChanged = new EventEmitter();
                this.i.filterChanged = delegateCombine(this.i.filterChanged, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxGridFilterDialogFilterChangeEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeFilterChanged) {
                            _this.beforeFilterChanged(_this, outerArgs);
                        }
                        _this._filterChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._filterChanged;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridFilterDialogComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridFilterDialogComponent.prototype, "isAnimationEnabled", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridFilterDialogComponent.prototype, "pixelScalingRatio", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridFilterDialogComponent.prototype, "actualPixelScalingRatio", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridFilterDialogComponent.prototype, "dialogOpening", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridFilterDialogComponent.prototype, "filterChanging", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridFilterDialogComponent.prototype, "filterChanged", null);
    IgxLiveGridFilterDialogComponent = tslib_1.__decorate([
        Component({
            selector: 'igx-live-grid-filter-dialog',
            template: "",
            providers: [],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridFilterDialogComponent);
    return IgxLiveGridFilterDialogComponent;
}());
export { IgxLiveGridFilterDialogComponent };
//# sourceMappingURL=igx-live-grid-filter-dialog-component.js.map