import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { ColumnSortDirection, ColumnSortDirection_$type } from "./ColumnSortDirection";
import { SortIndicatorStyle, SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { IgxSortIndicatorRenderCompletedEventArgs } from "./igx-sort-indicator-render-completed-event-args";
import { GridSortIndicator } from "./GridSortIndicator";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, ensureEnum, brushToString, stringToBrush, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
/**
 * An advanced grid for displaying data.
*/
export var IgxLiveGridSortIndicatorComponent_PROVIDERS = [];
var IgxLiveGridSortIndicatorComponent = /** @class */ (function () {
    function IgxLiveGridSortIndicatorComponent() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._renderCompleted = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxLiveGridSortIndicatorComponent.prototype.createImplementation = function () {
        return new GridSortIndicator();
    };
    IgxLiveGridSortIndicatorComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgxLiveGridSortIndicatorComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgxLiveGridSortIndicatorComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "sortDirection", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(ColumnSortDirection_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "iconColor", {
        get: function () {
            return brushToString(this.i.ax);
        },
        set: function (v) {
            this.i.ax = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "isAnimationEnabled", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.v;
        },
        set: function (v) {
            this.i.v = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.o;
        },
        set: function (v) {
            this.i.o = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "sortIndicatorStyle", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridSortIndicatorComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgxLiveGridSortIndicatorComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LiveGridSortIndicatorComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgxLiveGridSortIndicatorComponent.prototype.getDesiredScale = function () {
        var iv = this.i.u();
        return (iv);
    };
    IgxLiveGridSortIndicatorComponent.prototype.notifySizeChanged = function (width, height) {
        this.i.ao(width, height);
    };
    Object.defineProperty(IgxLiveGridSortIndicatorComponent.prototype, "renderCompleted", {
        get: function () {
            var _this = this;
            if (this._renderCompleted == null) {
                this._renderCompleted = new EventEmitter();
                this.i.renderCompleted = delegateCombine(this.i.renderCompleted, function (o, e) {
                    var outerArgs = new IgxSortIndicatorRenderCompletedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeRenderCompleted) {
                        _this.beforeRenderCompleted(_this, outerArgs);
                    }
                    _this._renderCompleted.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._renderCompleted;
        },
        enumerable: true,
        configurable: true
    });
    IgxLiveGridSortIndicatorComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridSortIndicatorComponent.prototype, "sortDirection", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxLiveGridSortIndicatorComponent.prototype, "iconColor", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxLiveGridSortIndicatorComponent.prototype, "isAnimationEnabled", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridSortIndicatorComponent.prototype, "pixelScalingRatio", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridSortIndicatorComponent.prototype, "actualPixelScalingRatio", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLiveGridSortIndicatorComponent.prototype, "sortIndicatorStyle", null);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridSortIndicatorComponent.prototype, "renderCompleted", null);
    IgxLiveGridSortIndicatorComponent = tslib_1.__decorate([
        Component({
            selector: 'igx-live-grid-sort-indicator',
            template: "",
            providers: [],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridSortIndicatorComponent);
    return IgxLiveGridSortIndicatorComponent;
}());
export { IgxLiveGridSortIndicatorComponent };
//# sourceMappingURL=igx-live-grid-sort-indicator-component.js.map