import * as tslib_1 from "tslib";
import { IgxCellInfo } from "./igx-cell-info";
import { NumericCellModel as NumericCellModel_internal } from "./NumericCellModel";
import { ensureBool } from "igniteui-angular-core";
/**
 * Backing information for a numeric cell in the grid.
*/
var IgxNumericCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxNumericCellInfo, _super);
    function IgxNumericCellInfo() {
        return _super.call(this) || this;
    }
    IgxNumericCellInfo.prototype.createImplementation = function () {
        return new NumericCellModel_internal();
    };
    Object.defineProperty(IgxNumericCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "numericValue", {
        /**
         * Sets or gets the numeric value to use for the cell.
        */
        get: function () {
            return this.i.io;
        },
        set: function (v) {
            this.i.io = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "hasDecimalValue", {
        /**
         * Sets or gets whether there is a decimal numeric value to use for the cell.
        */
        get: function () {
            return this.i.ij;
        },
        set: function (v) {
            this.i.ij = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "formatOverride", {
        /**
         * The format options to apply to the value
        */
        get: function () {
            return this.i.i8;
        },
        set: function (v) {
            this.i.i8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "negativePrefix", {
        /**
         * Sets or gets the text prepended to a negative numeric value
        */
        get: function () {
            return this.i.ji;
        },
        set: function (v) {
            this.i.ji = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "positivePrefix", {
        /**
         * Sets or gets the text prepended to a positive numeric value
        */
        get: function () {
            return this.i.jn;
        },
        set: function (v) {
            this.i.jn = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "negativeSuffix", {
        /**
         * Sets or gets the text appended to a negative numeric value
        */
        get: function () {
            return this.i.jk;
        },
        set: function (v) {
            this.i.jk = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "positiveSuffix", {
        /**
         * Sets or gets the text appended to a positive numeric value
        */
        get: function () {
            return this.i.jp;
        },
        set: function (v) {
            this.i.jp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "maxFractionDigits", {
        /**
         * The maximum number of decimal places to display when formatting
        */
        get: function () {
            return this.i.iu;
        },
        set: function (v) {
            this.i.iu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "minFractionDigits", {
        /**
         * The minimum number of decimal places to display when formatting
        */
        get: function () {
            return this.i.iw;
        },
        set: function (v) {
            this.i.iw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "minIntegerDigits", {
        /**
         * The minimum number of integer digits to display when formatting
        */
        get: function () {
            return this.i.iy;
        },
        set: function (v) {
            this.i.iy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericCellInfo.prototype, "showGroupingSeparator", {
        /**
         * Sets or gets if the grouping separator is shown
        */
        get: function () {
            return this.i.il;
        },
        set: function (v) {
            this.i.il = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxNumericCellInfo;
}(IgxCellInfo));
export { IgxNumericCellInfo };
//# sourceMappingURL=igx-numeric-cell-info.js.map