import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { NumericColumn } from "./NumericColumn";
import { ensureBool } from "igniteui-angular-core";
/**
 * Represents a Numeric grid column, used to allow the developer to display a formatted number in a cell.
*/
export var IgxNumericColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxNumericColumnComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxNumericColumnComponent; }) }];
var IgxNumericColumnComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxNumericColumnComponent, _super);
    function IgxNumericColumnComponent() {
        return _super.call(this) || this;
    }
    IgxNumericColumnComponent_1 = IgxNumericColumnComponent;
    IgxNumericColumnComponent.prototype.createImplementation = function () {
        return new NumericColumn();
    };
    Object.defineProperty(IgxNumericColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "negativePrefix", {
        /**
         * Gets or sets the string to prefix a negative value. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.hf;
        },
        set: function (v) {
            this.i.hf = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "positivePrefix", {
        /**
         * Gets or sets the string to prefix a positive value. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.hj;
        },
        set: function (v) {
            this.i.hj = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "negativeSuffix", {
        /**
         * Gets or sets the string to suffix a negative value. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.hh;
        },
        set: function (v) {
            this.i.hh = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "positiveSuffix", {
        /**
         * Gets or sets the string to suffix a positive value. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.hl;
        },
        set: function (v) {
            this.i.hl = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "maxFractionDigits", {
        /**
         * Gets or sets the maximum fraction digits. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.gz;
        },
        set: function (v) {
            this.i.gz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "minFractionDigits", {
        /**
         * Gets or sets the minimum fraction digits. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.g0;
        },
        set: function (v) {
            this.i.g0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "minIntegerDigits", {
        /**
         * Gets or sets the minimum integer digits. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.g1;
        },
        set: function (v) {
            this.i.g1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "showGroupingSeparator", {
        /**
         * Gets or sets whether to show a grouping separator. If FormatString is specificied this value is ignored.
        */
        get: function () {
            return this.i.gu;
        },
        set: function (v) {
            this.i.gu = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericColumnComponent.prototype, "formatOverride", {
        /**
         * Gets or sets the INTL NumericFormat object to use for formatting the date values.
        */
        get: function () {
            return this.i.g3;
        },
        set: function (v) {
            this.i.g3 = v;
        },
        enumerable: true,
        configurable: true
    });
    var IgxNumericColumnComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxNumericColumnComponent.prototype, "negativePrefix", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxNumericColumnComponent.prototype, "positivePrefix", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxNumericColumnComponent.prototype, "negativeSuffix", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxNumericColumnComponent.prototype, "positiveSuffix", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxNumericColumnComponent.prototype, "maxFractionDigits", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxNumericColumnComponent.prototype, "minFractionDigits", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxNumericColumnComponent.prototype, "minIntegerDigits", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxNumericColumnComponent.prototype, "showGroupingSeparator", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], IgxNumericColumnComponent.prototype, "formatOverride", null);
    IgxNumericColumnComponent = IgxNumericColumnComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-numeric-column',
            template: "",
            providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxNumericColumnComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxNumericColumnComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxNumericColumnComponent);
    return IgxNumericColumnComponent;
}(IgxColumnComponent));
export { IgxNumericColumnComponent };
//# sourceMappingURL=igx-numeric-column-component.js.map