import { PrimaryKeyValue as PrimaryKeyValue_internal } from "./PrimaryKeyValue";
/**
 * A primary key value.
*/
var IgxPrimaryKeyValue = /** @class */ (function () {
    function IgxPrimaryKeyValue(primaryKey, primaryKeyValue) {
        if (primaryKey === void 0) { primaryKey = null; }
        if (primaryKeyValue === void 0) { primaryKeyValue = null; }
        this._implementation = new PrimaryKeyValue_internal(primaryKey, primaryKeyValue);
        this._implementation.externalObject = this;
    }
    Object.defineProperty(IgxPrimaryKeyValue.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPrimaryKeyValue.prototype.onImplementationCreated = function () {
    };
    IgxPrimaryKeyValue.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    IgxPrimaryKeyValue.createIdentityKey = function (item) {
        var int = PrimaryKeyValue_internal.createIdentityKey(item);
        var ext = new IgxPrimaryKeyValue(null, null);
        ext._provideImplementation(int);
        return ext;
    };
    Object.defineProperty(IgxPrimaryKeyValue.prototype, "key", {
        /**
     * The primary key associated with this value.
    */
        get: function () {
            return this.i.key;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPrimaryKeyValue.prototype, "value", {
        /**
         * The value of the keys for this primary key value.
        */
        get: function () {
            return this.i.value;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Determines if two primary key values are equal.

* @param other  * The other key value to check against.
*/
    IgxPrimaryKeyValue.prototype.equals = function (other) {
        var iv = this.i.equals(other);
        return (iv);
    };
    return IgxPrimaryKeyValue;
}());
export { IgxPrimaryKeyValue };
//# sourceMappingURL=igx-primary-key-value.js.map