import * as tslib_1 from "tslib";
import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgxCellInfo } from "./igx-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for a section header cell in the grid.
*/
var IgxSectionHeaderCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSectionHeaderCellInfo, _super);
    function IgxSectionHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgxSectionHeaderCellInfo.prototype.createImplementation = function () {
        return new SectionHeaderCellModel_internal();
    };
    Object.defineProperty(IgxSectionHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderCellInfo.prototype, "resolvedText", {
        /**
         * Sets or gets the resolved text for the section header cell.
        */
        get: function () {
            return this.i.iy;
        },
        set: function (v) {
            this.i.iy = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderCellInfo.prototype, "resolvedSummaryText", {
        /**
         * Sets or gets the resolved summary text for the section header cell.
        */
        get: function () {
            return this.i.iw;
        },
        set: function (v) {
            this.i.iw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderCellInfo.prototype, "summaryDisplayMode", {
        /**
         * Sets or gets how summaries are displayed in the section header cell.
        */
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = ensureEnum(GroupSummaryDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxSectionHeaderCellInfo;
}(IgxCellInfo));
export { IgxSectionHeaderCellInfo };
//# sourceMappingURL=igx-section-header-cell-info.js.map