import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { GroupSummaryDisplayMode, GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SectionHeader } from "./SectionHeader";
import { brushToString, stringToBrush, ensureBool, ensureEnum } from "igniteui-angular-core";
/**
 * Used to configure the appearance of the section header cells.
*/
export var IgxSectionHeaderComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxSectionHeaderComponent; }) }];
var IgxSectionHeaderComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSectionHeaderComponent, _super);
    function IgxSectionHeaderComponent() {
        return _super.call(this) || this;
    }
    IgxSectionHeaderComponent_1 = IgxSectionHeaderComponent;
    IgxSectionHeaderComponent.prototype.createImplementation = function () {
        return new SectionHeader();
    };
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "selectedBackground", {
        get: function () {
            return brushToString(this.i.es);
        },
        set: function (v) {
            this.i.es = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "actualSelectedBackground", {
        get: function () {
            return brushToString(this.i.er);
        },
        set: function (v) {
            this.i.er = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.ed;
        },
        set: function (v) {
            this.i.ed = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ec;
        },
        set: function (v) {
            this.i.ec = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "isCollapsable", {
        get: function () {
            return this.i.d5;
        },
        set: function (v) {
            this.i.d5 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSectionHeaderComponent.prototype, "summaryDisplayMode", {
        get: function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = ensureEnum(GroupSummaryDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    var IgxSectionHeaderComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxSectionHeaderComponent.prototype, "selectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxSectionHeaderComponent.prototype, "actualSelectedBackground", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSectionHeaderComponent.prototype, "paddingLeft", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSectionHeaderComponent.prototype, "paddingTop", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSectionHeaderComponent.prototype, "paddingRight", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSectionHeaderComponent.prototype, "paddingBottom", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], IgxSectionHeaderComponent.prototype, "isCollapsable", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSectionHeaderComponent.prototype, "summaryDisplayMode", null);
    IgxSectionHeaderComponent = IgxSectionHeaderComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-section-header',
            template: "",
            providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxSectionHeaderComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxSectionHeaderComponent);
    return IgxSectionHeaderComponent;
}(IgxDefinitionBaseComponent));
export { IgxSectionHeaderComponent };
//# sourceMappingURL=igx-section-header-component.js.map