import * as tslib_1 from "tslib";
import { IgxCellInfo } from "./igx-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
import { brushToString, stringToBrush } from "igniteui-angular-core";
/**
 * Backing information for a section header cell in the grid.
*/
var IgxSummaryCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSummaryCellInfo, _super);
    function IgxSummaryCellInfo() {
        return _super.call(this) || this;
    }
    IgxSummaryCellInfo.prototype.createImplementation = function () {
        return new SummaryCellModel_internal();
    };
    Object.defineProperty(IgxSummaryCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryCellInfo.prototype, "resolvedSummaryText", {
        /**
         * Sets or gets the resolved summary text for the summary cell.
        */
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryCellInfo.prototype, "resolvedSummaryValue", {
        /**
         * Sets or gets the resolved summary value for the sumamry cell.
        */
        get: function () {
            return this.i.ip;
        },
        set: function (v) {
            this.i.ip = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryCellInfo.prototype, "summaryNameTextColor", {
        /**
         * Gets or sets the color of the text for the summary name in the cell.
        */
        get: function () {
            return brushToString(this.i.it);
        },
        set: function (v) {
            this.i.it = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxSummaryCellInfo;
}(IgxCellInfo));
export { IgxSummaryCellInfo };
//# sourceMappingURL=igx-summary-cell-info.js.map