import { TemplateCellUpdatingEventArgs as TemplateCellUpdatingEventArgs_internal } from "./TemplateCellUpdatingEventArgs";
import { IgxDateTimeCellInfo } from "./igx-date-time-cell-info";
import { IgxImageCellInfo } from "./igx-image-cell-info";
import { IgxNumericCellInfo } from "./igx-numeric-cell-info";
import { IgxRowSeparatorInfo } from "./igx-row-separator-info";
import { IgxSectionHeaderCellInfo } from "./igx-section-header-cell-info";
import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { IgxTemplateHeaderCellInfo } from "./igx-template-header-cell-info";
import { IgxTemplateSectionHeaderCellInfo } from "./igx-template-section-header-cell-info";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { IgxTextHeaderCellInfo } from "./igx-text-header-cell-info";
/**
 * Information about the cell that has content which is being created or updated.
*/
var IgxTemplateCellUpdatingEventArgs = /** @class */ (function () {
    function IgxTemplateCellUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxTemplateCellUpdatingEventArgs.prototype.createImplementation = function () {
        return new TemplateCellUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgxTemplateCellUpdatingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxTemplateCellUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxTemplateCellUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxTemplateCellUpdatingEventArgs.prototype, "isCanvasBased", {
        get: function () {
            return this.i.content.isCanvasBased;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateCellUpdatingEventArgs.prototype, "content", {
        /**
         * The host in which to add or update content if this is a DOM based cell.
        */
        get: function () {
            if (this.isCanvasBased) {
                return null;
            }
            else {
                return this.i.content.element.getNativeElement();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxTemplateCellUpdatingEventArgs.prototype.ensureCorrectSize = function () {
        return this.i.content.ensureCorrectSize();
    };
    Object.defineProperty(IgxTemplateCellUpdatingEventArgs.prototype, "context", {
        get: function () {
            if (this.isCanvasBased) {
                return this.i.content.templateContext;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxTemplateCellUpdatingEventArgs.prototype.renderStandardBackground = function () {
        this.i.content.renderStandardBackground();
    };
    IgxTemplateCellUpdatingEventArgs.prototype.renderStandardContent = function () {
        this.i.content.renderStandardContent();
    };
    Object.defineProperty(IgxTemplateCellUpdatingEventArgs.prototype, "cellInfo", {
        /**
         * The backing information for the current cell.
        */
        get: function () {
            if (this.i.cellInfo == null) {
                return null;
            }
            if (!this.i.cellInfo.externalObject) {
                var ext = null;
                switch (this.i.cellInfo.$type.name) {
                    case "DateTimeCellModel":
                        ext = new IgxDateTimeCellInfo();
                        break;
                    case "ImageCellModel":
                        ext = new IgxImageCellInfo();
                        break;
                    case "NumericCellModel":
                        ext = new IgxNumericCellInfo();
                        break;
                    case "RowSeparatorModel":
                        ext = new IgxRowSeparatorInfo();
                        break;
                    case "SectionHeaderCellModel":
                        ext = new IgxSectionHeaderCellInfo();
                        break;
                    case "TemplateCellModel":
                        ext = new IgxTemplateCellInfo();
                        break;
                    case "TemplateHeaderCellModel":
                        ext = new IgxTemplateHeaderCellInfo();
                        break;
                    case "TemplateSectionHeaderCellModel":
                        ext = new IgxTemplateSectionHeaderCellInfo();
                        break;
                    case "TextCellModel":
                        ext = new IgxTextCellInfo();
                        break;
                    case "TextHeaderCellModel":
                        ext = new IgxTextHeaderCellInfo();
                        break;
                }
                ext._implementation = this.i.cellInfo;
                this.i.cellInfo.externalObject = ext;
            }
            return this.i.cellInfo.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    return IgxTemplateCellUpdatingEventArgs;
}());
export { IgxTemplateCellUpdatingEventArgs };
//# sourceMappingURL=igx-template-cell-updating-event-args.js.map