import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateCellUpdatingEventArgs } from "./igx-template-cell-updating-event-args";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateColumn } from "./TemplateColumn";
/**
 * A column with customizable content.
*/
export var IgxTemplateColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxTemplateColumnComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateColumnComponent; }) }];
var IgxTemplateColumnComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTemplateColumnComponent, _super);
    function IgxTemplateColumnComponent() {
        var _this = _super.call(this) || this;
        _this._cellUpdating = null;
        return _this;
    }
    IgxTemplateColumnComponent_1 = IgxTemplateColumnComponent;
    IgxTemplateColumnComponent.prototype.createImplementation = function () {
        return new TemplateColumn();
    };
    Object.defineProperty(IgxTemplateColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateColumnComponent.prototype, "cellUpdating", {
        /**
         * Called when the cell content is being created or updated.
        */
        get: function () {
            var _this = this;
            if (this._cellUpdating == null) {
                this._cellUpdating = new EventEmitter();
                this.i.cellUpdating = delegateCombine(this.i.cellUpdating, function (o, e) {
                    var outerArgs = new IgxTemplateCellUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellUpdating) {
                        _this.beforeCellUpdating(_this, outerArgs);
                    }
                    _this._cellUpdating.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellUpdating;
        },
        enumerable: true,
        configurable: true
    });
    var IgxTemplateColumnComponent_1;
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateColumnComponent.prototype, "cellUpdating", null);
    IgxTemplateColumnComponent = IgxTemplateColumnComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-template-column',
            template: "",
            providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxTemplateColumnComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateColumnComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateColumnComponent);
    return IgxTemplateColumnComponent;
}(IgxColumnComponent));
export { IgxTemplateColumnComponent };
//# sourceMappingURL=igx-template-column-component.js.map