import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateHeaderCellUpdatingEventArgs } from "./igx-template-header-cell-updating-event-args";
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateHeader } from "./TemplateHeader";
/**
 * A type of header with customizable content.
*/
export var IgxTemplateHeaderComponent_PROVIDERS = [{ provide: IgxHeaderComponent, useExisting: forwardRef(function () { return IgxTemplateHeaderComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateHeaderComponent; }) }];
var IgxTemplateHeaderComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTemplateHeaderComponent, _super);
    function IgxTemplateHeaderComponent() {
        var _this = _super.call(this) || this;
        _this._cellUpdating = null;
        return _this;
    }
    IgxTemplateHeaderComponent_1 = IgxTemplateHeaderComponent;
    IgxTemplateHeaderComponent.prototype.createImplementation = function () {
        return new TemplateHeader();
    };
    Object.defineProperty(IgxTemplateHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateHeaderComponent.prototype, "cellUpdating", {
        /**
         * Called when the header cell content is being created or updated.
        */
        get: function () {
            var _this = this;
            if (this._cellUpdating == null) {
                this._cellUpdating = new EventEmitter();
                this.i.cellUpdating = delegateCombine(this.i.cellUpdating, function (o, e) {
                    var outerArgs = new IgxTemplateHeaderCellUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellUpdating) {
                        _this.beforeCellUpdating(_this, outerArgs);
                    }
                    _this._cellUpdating.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellUpdating;
        },
        enumerable: true,
        configurable: true
    });
    var IgxTemplateHeaderComponent_1;
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateHeaderComponent.prototype, "cellUpdating", null);
    IgxTemplateHeaderComponent = IgxTemplateHeaderComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-template-header',
            template: "",
            providers: [{ provide: IgxHeaderComponent, useExisting: forwardRef(function () { return IgxTemplateHeaderComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateHeaderComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateHeaderComponent);
    return IgxTemplateHeaderComponent;
}(IgxHeaderComponent));
export { IgxTemplateHeaderComponent };
//# sourceMappingURL=igx-template-header-component.js.map