import * as tslib_1 from "tslib";
import { EventEmitter, Output, Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { IgxTemplateSectionHeaderCellUpdatingEventArgs } from "./igx-template-section-header-cell-updating-event-args";
import { IgxSectionHeaderComponent } from "./igx-section-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export var IgxTemplateSectionHeaderComponent_PROVIDERS = [{ provide: IgxSectionHeaderComponent, useExisting: forwardRef(function () { return IgxTemplateSectionHeaderComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateSectionHeaderComponent; }) }];
var IgxTemplateSectionHeaderComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTemplateSectionHeaderComponent, _super);
    function IgxTemplateSectionHeaderComponent() {
        var _this = _super.call(this) || this;
        _this._cellUpdating = null;
        return _this;
    }
    IgxTemplateSectionHeaderComponent_1 = IgxTemplateSectionHeaderComponent;
    IgxTemplateSectionHeaderComponent.prototype.createImplementation = function () {
        return new TemplateSectionHeader();
    };
    Object.defineProperty(IgxTemplateSectionHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateSectionHeaderComponent.prototype, "cellUpdating", {
        /**
         * Called when the cell content is being created or updated.
        */
        get: function () {
            var _this = this;
            if (this._cellUpdating == null) {
                this._cellUpdating = new EventEmitter();
                this.i.cellUpdating = delegateCombine(this.i.cellUpdating, function (o, e) {
                    var outerArgs = new IgxTemplateSectionHeaderCellUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeCellUpdating) {
                        _this.beforeCellUpdating(_this, outerArgs);
                    }
                    _this._cellUpdating.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._cellUpdating;
        },
        enumerable: true,
        configurable: true
    });
    var IgxTemplateSectionHeaderComponent_1;
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", EventEmitter),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateSectionHeaderComponent.prototype, "cellUpdating", null);
    IgxTemplateSectionHeaderComponent = IgxTemplateSectionHeaderComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-template-section-header',
            template: "",
            providers: [{ provide: IgxSectionHeaderComponent, useExisting: forwardRef(function () { return IgxTemplateSectionHeaderComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTemplateSectionHeaderComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTemplateSectionHeaderComponent);
    return IgxTemplateSectionHeaderComponent;
}(IgxSectionHeaderComponent));
export { IgxTemplateSectionHeaderComponent };
//# sourceMappingURL=igx-template-section-header-component.js.map