import * as tslib_1 from "tslib";
import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
import { ensureBool, ensureEnum } from "igniteui-angular-core";
/**
 * Backing information for a text header cell.
*/
var IgxTextHeaderCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTextHeaderCellInfo, _super);
    function IgxTextHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgxTextHeaderCellInfo.prototype.createImplementation = function () {
        return new TextHeaderCellModel_internal();
    };
    Object.defineProperty(IgxTextHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTextHeaderCellInfo.prototype, "isFilterUIVisible", {
        /**
         * Sets or gets whether the filter UI should be visible in the header.
        */
        get: function () {
            return this.i.ip;
        },
        set: function (v) {
            this.i.ip = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTextHeaderCellInfo.prototype, "sortIndicatorStyle", {
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = ensureEnum(SortIndicatorStyle_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxTextHeaderCellInfo;
}(IgxTextCellInfo));
export { IgxTextHeaderCellInfo };
//# sourceMappingURL=igx-text-header-cell-info.js.map