import { Point, Type } from "igniteui-angular-core";
import { ColumnFilterCondition } from "./ColumnFilterCondition";
import { DataSourceSchemaPropertyType } from "igniteui-angular-core";
/**
 * @hidden
 */
export interface ICellActionManager {
    clickExpansionIndicator(): void;
    clickCell(): void;
    dragStarted(): void;
    previewPointerDownCell(): void;
    previewPointerUpCell(): void;
    pointerDownCell(): void;
    pointerUpCell(): void;
    mouseDownCell(a: number, b: number): void;
    mouseUpCell(a: number, b: number): void;
    mouseLeaveCell(a: number, b: number): void;
    mouseIsOver(a: number, b: number): void;
    isLeaveActionDesired: boolean;
    readonly isClickActionDesired: boolean;
    readonly isHoverActionDesired: boolean;
    readonly isPreviewPointerDownActionDesired: boolean;
    readonly isPreviewPointerUpActionDesired: boolean;
    readonly isPointerDownActionDesired: boolean;
    readonly isPointerUpActionDesired: boolean;
    isControlPressed: boolean;
    isShiftPressed: boolean;
    readonly isDrag: boolean;
    readonly isMouseDown: boolean;
    readonly mousePosition: Point;
    isCellDown(): boolean;
    getColumnFilterCondition(): ColumnFilterCondition;
    getColumnPropertyType(): DataSourceSchemaPropertyType;
    columnFilterChanging(a: ColumnFilterCondition): void;
    columnFilterChanged(a: ColumnFilterCondition): void;
}
/**
 * @hidden
 */
export declare let ICellActionManager_$type: Type;
