import { DomRenderer } from "igniteui-angular-core";
import { Base, Type, Point, PropertyChangedEventArgs, INotifyPropertyChanged, IEnumerable, EventArgs, IList$1 } from "igniteui-angular-core";
import { IDataSource } from "igniteui-angular-core";
import { ICellActionManager } from "./ICellActionManager";
import { IDragger } from "./IDragger";
import { ColumnFilterCondition } from "./ColumnFilterCondition";
import { DataSourceSchemaPropertyType } from "igniteui-angular-core";
import { DateTimeFormats } from "./DateTimeFormats";
import { ModelStates } from "./ModelStates";
import { CellPath } from "./CellPath";
import { ModelTypes } from "./ModelTypes";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Brush } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { TextCellLineBreakMode } from "./TextCellLineBreakMode";
import { ColumnSortDirection } from "./ColumnSortDirection";
import { Dictionary$2 } from "igniteui-angular-core";
import { CellModelExport } from "./CellModelExport";
import { DataSourceRowType } from "igniteui-angular-core";
import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { ImageStretchOptions } from "./ImageStretchOptions";
import { ImageResourceType } from "./ImageResourceType";
import { GroupData } from "./GroupData";
import { SummaryData } from "./SummaryData";
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { INativeCell } from "./INativeCell";
import { IDataSourceUpdateNotifier } from "igniteui-angular-core";
import { IDataSourceSchema } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IPropertySetter } from "./IPropertySetter";
import { DragSelectEventArgs } from "./DragSelectEventArgs";
import { ColumnResizingMode } from "./ColumnResizingMode";
import { ColumnMovingMode } from "./ColumnMovingMode";
import { IDelayedExecutionManager } from "./IDelayedExecutionManager";
import { ITickProvider } from "igniteui-angular-core";
import { IViewportManager } from "./IViewportManager";
import { ColumnWidth } from "./ColumnWidth";
import { HeaderClickAction } from "./HeaderClickAction";
import { ColumnShowingAnimationMode } from "./ColumnShowingAnimationMode";
import { ColumnPropertyUpdatingAnimationMode } from "./ColumnPropertyUpdatingAnimationMode";
import { CellDataLoadedAnimationMode } from "./CellDataLoadedAnimationMode";
import { RowSelectionAnimationMode } from "./RowSelectionAnimationMode";
import { CellSelectionAnimationMode } from "./CellSelectionAnimationMode";
import { GridColumnAnimationSettings } from "./GridColumnAnimationSettings";
import { GridAnimationSettings } from "./GridAnimationSettings";
import { ColumnResizingAnimationMode } from "./ColumnResizingAnimationMode";
import { ColumnMovingAnimationMode } from "./ColumnMovingAnimationMode";
import { ColumnHidingAnimationMode } from "./ColumnHidingAnimationMode";
import { ColumnExchangingAnimationMode } from "./ColumnExchangingAnimationMode";
import { Thickness } from "igniteui-angular-core";
import { GridSelectionMode } from "./GridSelectionMode";
import { GridActivationMode } from "./GridActivationMode";
import { GridSelectionBehavior } from "./GridSelectionBehavior";
import { GridSelectedItemsCollection } from "./GridSelectedItemsCollection";
import { GridSelectedKeysCollection } from "./GridSelectedKeysCollection";
import { GridSelectedCellRangesCollection } from "./GridSelectedCellRangesCollection";
import { GridCellPosition } from "./GridCellPosition";
import { IPlatformPixelConverter } from "./IPlatformPixelConverter";
import { Rect } from "igniteui-angular-core";
import { ColumnSortDescriptionCollection } from "./ColumnSortDescriptionCollection";
import { ColumnGroupDescriptionCollection } from "./ColumnGroupDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-angular-core";
import { ColumnSummaryDescriptionCollection } from "./ColumnSummaryDescriptionCollection";
import { DataSourceSummaryScope } from "igniteui-angular-core";
import { DataSourceSectionHeaderDisplayMode } from "igniteui-angular-core";
import { GridFilterExpressionsEventArgs } from "./GridFilterExpressionsEventArgs";
import { RowPath } from "./RowPath";
import { CellRange } from "./CellRange";
import { FastIterationDictionary$2 } from "igniteui-angular-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { ColumnGroupDescription } from "./ColumnGroupDescription";
import { ColumnSummaryDescription } from "./ColumnSummaryDescription";
import { GridGroupDescriptionsChangedEventArgs } from "./GridGroupDescriptionsChangedEventArgs";
import { GridSortDescriptionsChangedEventArgs } from "./GridSortDescriptionsChangedEventArgs";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { DefinitionPropertyUpdatedEventArgs } from "./DefinitionPropertyUpdatedEventArgs";
import { CellPropertyAnimationType } from "./CellPropertyAnimationType";
import { GridColumnsAutoGeneratedEventArgs } from "./GridColumnsAutoGeneratedEventArgs";
import { ColumnStates } from "./ColumnStates";
import { VisualModelExport } from "./VisualModelExport";
import { GridActiveCellChangedEventArgs } from "./GridActiveCellChangedEventArgs";
import { GridSelectedItemsChangedEventArgs } from "./GridSelectedItemsChangedEventArgs";
import { GridSelectedKeysChangedEventArgs } from "./GridSelectedKeysChangedEventArgs";
import { GridSelectedCellRangesChangedEventArgs } from "./GridSelectedCellRangesChangedEventArgs";
import { ISummaryResult } from "igniteui-angular-core";
import { GridAnimationPhaseSettings } from "./GridAnimationPhaseSettings";
import { GridAnimationManagerAnimationCreatedEventArgs } from "./GridAnimationManagerAnimationCreatedEventArgs";
import { GridAnimationManagerAnimationCompletedEventArgs } from "./GridAnimationManagerAnimationCompletedEventArgs";
import { GridAnimationManagerAnimationCanceledEventArgs } from "./GridAnimationManagerAnimationCanceledEventArgs";
import { GridColumnSpacer } from "./GridColumnSpacer";
import { GridColumnSpacerCollection } from "./GridColumnSpacerCollection";
import { GridEffectMainIntent } from "./GridEffectMainIntent";
import { FixedCellPositions } from "./FixedCellPositions";
import { GridEffectSubIntent } from "./GridEffectSubIntent";
import { HashSet$1 } from "igniteui-angular-core";
import { CellStyleRequestedEventArgs } from "./CellStyleRequestedEventArgs";
import { CalculationParameters } from "./CalculationParameters";
import { ColumnPropertySettersCollection } from "./ColumnPropertySettersCollection";
import { ColumnPropertySetter } from "./ColumnPropertySetter";
import { ResponsiveStateEnteringEventArgs } from "./ResponsiveStateEnteringEventArgs";
import { ResponsiveStateEnteredEventArgs } from "./ResponsiveStateEnteredEventArgs";
import { ResponsiveStateExitedEventArgs } from "./ResponsiveStateExitedEventArgs";
/**
 * @hidden
 */
export interface IExternalGrid {
    readonly renderer: DomRenderer;
    insertExternalColumnAtIndex(a: number, b: any): void;
    removeExternalColumn(a: any): void;
    ensureColumnsAreManual(): void;
    onContentSizeChanged(): void;
    createLocalDataSource(a: any): IDataSource;
    createTextColumn(a: string): TextColumn;
    createNumericColumn(a: string): NumericColumn;
    createDateTimeColumn(a: string): DateTimeColumn;
    createImageColumn(a: string): ImageColumn;
    createTemplateColumn(a: string): TemplateColumn;
    focusScroller(): void;
    setHandCursor(): void;
    setResizeCursor(): void;
    setDefaultCursor(): void;
}
/**
 * @hidden
 */
export declare let IExternalGrid_$type: Type;
/**
 * @hidden
 */
export declare class DefaultCellActionManager extends Base implements ICellActionManager {
    static $t: Type;
    private b;
    private a;
    private c;
    private d;
    constructor(a: Grid, b: CellModel);
    clickExpansionIndicator(): void;
    clickCell(): void;
    dragStarted(): void;
    previewPointerDownCell(): void;
    previewPointerUpCell(): void;
    pointerDownCell(): void;
    pointerUpCell(): void;
    mouseDownCell(a: number, b: number): void;
    mouseUpCell(a: number, b: number): void;
    mouseLeaveCell(a: number, b: number): void;
    mouseIsOver(a: number, b: number): void;
    getColumnFilterCondition(): ColumnFilterCondition;
    getColumnPropertyType(): DataSourceSchemaPropertyType;
    columnFilterChanging(a: ColumnFilterCondition): void;
    columnFilterChanged(a: ColumnFilterCondition): void;
    isCellDown(): boolean;
    private _isLeaveActionDesired;
    isLeaveActionDesired: boolean;
    readonly isClickActionDesired: boolean;
    readonly isHoverActionDesired: boolean;
    readonly isPreviewPointerDownActionDesired: boolean;
    readonly isPreviewPointerUpActionDesired: boolean;
    readonly isPointerDownActionDesired: boolean;
    readonly isPointerUpActionDesired: boolean;
    isControlPressed: boolean;
    isShiftPressed: boolean;
    readonly isDrag: boolean;
    readonly isMouseDown: boolean;
    readonly mousePosition: Point;
}
/**
 * @hidden
 */
export declare class DateTimeColumnValueFormatter extends Base {
    static $t: Type;
    private a;
    private b;
    k(): void;
    j(a: DateTimeCellModel): void;
    private f;
    private e;
    private c;
    private d;
    private g;
    private h;
    i(a: Date): string;
}
/**
 * @hidden
 */
export declare abstract class CellModel extends Base {
    static $t: Type;
    private l;
    m: Grid;
    constructor();
    private static cd;
    private static cc;
    private static a0;
    static ds(a: string): number;
    p: ICellPresenter;
    static ev: number;
    private q;
    r: ModelStates;
    g1: string;
    i: CellPath;
    dq: number;
    aq: boolean;
    av: boolean;
    ah: boolean;
    af: boolean;
    ao: boolean;
    aw: boolean;
    aj: boolean;
    ap: boolean;
    c: ICellActionManager;
    private ab;
    static d1: number;
    ar: boolean;
    private ac;
    static d2: number;
    as: boolean;
    private aa;
    static d0: number;
    an: boolean;
    private cb;
    static dx: number;
    dw: number;
    private ax;
    ai(a: string): boolean;
    al(propertyId_: number): boolean;
    ak(a: string): boolean;
    private b9;
    private a;
    hf(propertyId_: number): void;
    hc(): void;
    hg(a: string): void;
    protected hl(a: string, b: number, c: any, d: any): void;
    protected hn(a: string, b: any, c: any): void;
    private hm;
    private hi;
    private hj;
    private hk;
    private h9;
    hp(): void;
    protected hq(): void;
    private az;
    hr(a: string, b: any): void;
    ae(a: string): boolean;
    ho(a: string): void;
    e9(a: string): any;
    private n;
    o: GridLayer;
    static em: number;
    private e8;
    fc: any;
    static readonly e4: number;
    private be;
    br: number;
    static readonly e5: number;
    private bf;
    bs: number;
    static readonly eq: number;
    private ci;
    ep: number;
    static readonly es: number;
    private cj;
    er: number;
    static readonly dp: number;
    private a5;
    bi: number;
    static readonly d9: number;
    private a8;
    bl: number;
    static readonly c5: number;
    private a4;
    bh: number;
    static readonly d5: number;
    hh(): void;
    private a6;
    bj: number;
    static readonly ey: number;
    private bb;
    bo: number;
    static readonly d6: number;
    private a7;
    bk: number;
    static readonly ez: number;
    private bc;
    bp: number;
    static readonly du: number;
    private ca;
    dt: number;
    static readonly e3: number;
    private ck;
    e2: number;
    static readonly d3: number;
    private ad;
    au: boolean;
    static readonly d8: number;
    private s;
    t: ModelTypes;
    static readonly eo: number;
    private ba;
    bn: number;
    static readonly cu: number;
    private a3;
    bg: number;
    static readonly dv: number;
    private d;
    e: CellContentHorizontalAlignment;
    static readonly e0: number;
    private f;
    g: CellContentVerticalAlignment;
    static readonly de: number;
    private hw;
    h7: Brush;
    static readonly dj: number;
    private hx;
    h8: Brush;
    static readonly cv: number;
    private hu;
    h5: Brush;
    static readonly c0: number;
    private hv;
    h6: Brush;
    static readonly cp: number;
    private ht;
    h4: Brush;
    static readonly en: number;
    private h0;
    ic: Brush;
    static readonly eu: number;
    private h1;
    id: Brush;
    static readonly ew: number;
    private h2;
    ie: Brush;
    static readonly ej: number;
    private hz;
    ib: Brush;
    private hy;
    static readonly d4: number;
    ia: Brush;
    static readonly ek: number;
    private a9;
    bm: number;
    static readonly ea: number;
    private e7;
    fb: any;
    static readonly el: number;
    private fd;
    gq: string;
    static readonly ex: number;
    private h3;
    ig: Brush;
    static readonly dr: number;
    private w;
    x: FontInfo;
    static readonly d7: number;
    private u;
    v: TextCellLineBreakMode;
    static readonly e1: number;
    private bd;
    bq: number;
    static readonly ee: number;
    private cf;
    ed: number;
    static readonly ei: number;
    private ch;
    eh: number;
    static readonly eg: number;
    private cg;
    ef: number;
    static readonly ec: number;
    private ce;
    eb: number;
    static readonly c9: number;
    private b2;
    c8: number;
    static readonly dd: number;
    private b4;
    dc: number;
    static readonly db: number;
    private b3;
    da: number;
    static readonly c7: number;
    private b1;
    c6: number;
    static readonly di: number;
    private b6;
    dh: number;
    static readonly dn: number;
    private b8;
    dm: number;
    static readonly dl: number;
    private b7;
    dk: number;
    static readonly dg: number;
    private b5;
    df: number;
    static readonly co: number;
    private bu;
    cn: number;
    static readonly ct: number;
    private bw;
    cs: number;
    static readonly cr: number;
    private bv;
    cq: number;
    static readonly cm: number;
    private bt;
    cl: number;
    static readonly cz: number;
    private by;
    cy: number;
    static readonly c4: number;
    private b0;
    c3: number;
    static readonly c2: number;
    private bz;
    c1: number;
    static readonly cx: number;
    private bx;
    cw: number;
    static readonly et: number;
    private j;
    k: ColumnSortDirection;
    static readonly dz: number;
    private z;
    am: boolean;
    static readonly dy: number;
    private y;
    ag: boolean;
    e6: number;
    ha(): void;
    protected hb(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    b(a: CellModelExport): CellModelExport;
    private static a1;
    protected he(): void;
    private static ay;
    protected hd(): void;
    hs(a: string, b: any): void;
    fa(a: string): any;
    cellReconciling: (model: CellModel) => void;
    at(a: DataSourceRowType): boolean;
}
/**
 * @hidden
 */
export declare class DateTimeCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly ir: number;
    private io;
    ip: Date;
    private iw;
    static readonly is: number;
    private _formatOverride;
    ix: any;
    static readonly iq: number;
    private ij;
    ik: DateTimeFormats;
    i0(a: Date): string;
    static readonly it: number;
    private ih;
    ii: DateTimeColumnValueFormatter;
    static readonly iu: number;
    private il;
    im: boolean;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class SummaryCellModel extends CellModel {
    static $t: Type;
    static readonly ih: number;
    private ik;
    im: string;
    static readonly ii: number;
    private il;
    ip: string;
    static readonly ij: number;
    private is;
    it: Brush;
    b(a: CellModelExport): CellModelExport;
    at(a: DataSourceRowType): boolean;
}
/**
 * @hidden
 */
export declare class VerticalSeparatorCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly ij: number;
    private ih;
    ii: boolean;
}
/**
 * @hidden
 */
export declare class ImageCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly il: number;
    private ip;
    iq: string;
    static readonly io: number;
    private ij;
    ik: ImageStretchOptions;
    static readonly im: number;
    private ih;
    ii: ImageResourceType;
    b(a: CellModelExport): CellModelExport;
    hs(a: string, b: any): void;
    fa(a: string): any;
}
/**
 * @hidden
 */
export declare class NumericCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly i2: number;
    private im;
    io: number;
    static readonly it: number;
    private ih;
    ij: boolean;
    private i7;
    static readonly is: number;
    private _formatOverride;
    i8: any;
    static readonly i0: number;
    private i9;
    ji: string;
    static readonly i3: number;
    private jb;
    jn: string;
    static readonly i1: number;
    private ja;
    jk: string;
    static readonly i4: number;
    private jc;
    jp: string;
    static readonly iv: number;
    private ip;
    iu: number;
    static readonly ix: number;
    private iq;
    iw: number;
    static readonly iz: number;
    private ir;
    iy: number;
    static readonly i5: number;
    private ii;
    il: boolean;
    ik(): boolean;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class RowSeparatorModel extends CellModel {
    static $t: Type;
    constructor();
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class SectionHeaderCellModel extends CellModel {
    static $t: Type;
    static readonly io: number;
    private ih;
    ij: GroupData[];
    static readonly ir: number;
    private ii;
    ik: SummaryData[];
    static readonly iq: number;
    private iu;
    iy: string;
    static readonly ip: number;
    private it;
    iw: string;
    static readonly is: number;
    private il;
    im: GroupSummaryDisplayMode;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
    at(a: DataSourceRowType): boolean;
}
/**
 * @hidden
 */
export declare class TemplateCellModel extends CellModel {
    static $t: Type;
    static readonly ih: number;
    private ii;
    ij: any;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class TextCellModel extends CellModel {
    static $t: Type;
    static readonly ih: number;
    private ii;
    ij: string;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class TextHeaderCellModel extends TextCellModel {
    static $t: Type;
    constructor();
    static readonly iq: number;
    private io;
    ip: boolean;
    static readonly ir: number;
    private il;
    im: SortIndicatorStyle;
    hs(a: string, b: any): void;
    fa(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export interface ICellPresenter {
    modelUpdated(a: CellModel): void;
    readonly isCanvasBased: boolean;
    readonly nativeCell: INativeCell;
}
/**
 * @hidden
 */
export declare let ICellPresenter_$type: Type;
/**
 * @hidden
 */
export declare class DataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: Grid);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
/**
 * @hidden
 */
export declare class ColumnController extends Base {
    static $t: Type;
    private g;
    private l;
    private a;
    n: boolean;
    b: IDataSourceSchema;
    readonly h: GridColumnCollection;
    protected m: boolean;
    private k;
    i: IExternalGrid;
    r(): boolean;
    private j;
    private o;
    private c;
    constructor(a: GridColumnCollection, b: boolean, c: () => void);
    f(a: CellPath): Column;
    d(a: number): Column;
    e(a: string): Column;
    p(a: Column): boolean;
    q(a: Column): boolean;
}
/**
 * @hidden
 */
export declare class Grid extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private iz;
    i1: any;
    private _propertySetter;
    propertySetter: IPropertySetter;
    private de;
    externalGrid: IExternalGrid;
    private dc;
    dragger: IDragger;
    private hr;
    columnExchangingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnExchangingAnimationCanceled: (sender: any, e: EventArgs) => void;
    m5(a: Column): void;
    m4(a: Column): void;
    columnShowingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnShowingAnimationCanceled: (sender: any, e: EventArgs) => void;
    m(a: CellModel): ColumnFilterCondition;
    n(a: CellModel): DataSourceSchemaPropertyType;
    ne(a: Column): void;
    filterExpressionsChanging: (sender: any, args: GridFilterExpressionsEventArgs) => void;
    filterExpressionsChanged: (sender: any, args: GridFilterExpressionsEventArgs) => void;
    l5(a: CellModel, b: ColumnFilterCondition): void;
    l4(a: CellModel, b: ColumnFilterCondition): void;
    nd(a: Column): void;
    columnMovingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnMovingAnimationCanceled: (sender: any, e: EventArgs) => void;
    nb(a: Column): void;
    na(a: Column): void;
    columnHidingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnHidingAnimationCanceled: (sender: any, e: EventArgs) => void;
    m7(a: Column): void;
    m6(a: Column): void;
    cellPreviewPointerDown: (sender: any, args: GridCellEventArgs) => void;
    mz(a: CellModel): void;
    cellPreviewPointerUp: (sender: any, args: GridCellEventArgs) => void;
    m0(a: CellModel): void;
    cellPointerDown: (sender: any, args: GridCellEventArgs) => void;
    mx(a: CellModel): void;
    cellPointerUp: (sender: any, args: GridCellEventArgs) => void;
    my(a: CellModel): void;
    nw(a: number, b: string): void;
    cellClicked: (sender: any, args: GridCellEventArgs) => void;
    no(a: CellModel): void;
    o1(a: number): void;
    ms(a: CellModel, b: boolean, c: boolean): void;
    private n8;
    private bf;
    bg: ColumnResizingMode;
    private a6;
    a7: ColumnMovingMode;
    qm: Point;
    am: CellPath;
    private ev;
    mv(a: CellModel, b: number, c: number): void;
    mw(a: CellModel, b: number, c: number): void;
    mu(a: CellModel, b: number, c: number): void;
    ns(a: CellModel, b: number, c: number): void;
    private hu;
    private e3;
    private e2;
    private g1;
    private g6;
    private g4;
    private g5;
    private gs;
    private gx;
    private gy;
    private gz;
    private g0;
    private an;
    private hy;
    private hx;
    private e8;
    l0(): void;
    nn(a: CellPath, b: number, c: number, d: boolean): void;
    nk(a: any, b: DragSelectEventArgs): void;
    ni(a: any, b: DragSelectEventArgs): void;
    private hq;
    iq: number;
    private hz;
    private nj;
    private aj;
    private gv;
    private g3;
    private nl;
    private nm;
    private qo;
    private ai;
    al(a: number, b: number): CellModel;
    private ap;
    private fe;
    private l8;
    private o3;
    constructor();
    og(a: ColumnGroupDescription): void;
    oh(a: ColumnSummaryDescription): void;
    private ox;
    private mc;
    private fy;
    private ow;
    private o0;
    private br;
    private fa;
    private oq;
    private or;
    private fc;
    private op;
    private oo;
    private e9;
    private n4;
    private n5;
    private b0;
    b1: GridAnimationManager;
    private _delayedExecutionManager;
    delayedExecutionManager: IDelayedExecutionManager;
    private di;
    readonly dj: ResponsiveEngine;
    private c9;
    da: IDataAdapter;
    private at;
    au: ColumnController;
    private cm;
    cn: GridLayerController;
    private d2;
    d3: SpatialEngine;
    private ch;
    ci: GridEffectManager;
    private dw;
    dx: SelectionManager;
    private ae;
    af: ActivationManager;
    private d0;
    d1: SortManager;
    private eo;
    tickProvider: ITickProvider;
    private du;
    dv: SectionHeader;
    private ds;
    dt: SectionFooter;
    private d4;
    d5: SummaryRowRoot;
    private d6;
    d7: SummaryRowSection;
    private dq;
    dr: RowSeparator;
    private c5;
    c6: HeaderSeparator;
    private bh;
    bi: ColumnResizingSeparator;
    private a8;
    a9: ColumnMovingSeparator;
    private b;
    e: string[];
    private d8;
    d9: VisibilityEngine;
    private _viewportManager;
    viewportManager: IViewportManager;
    private gu;
    g8: number;
    private gt;
    g7: number;
    ir: number;
    private bu;
    defaultColumnWidth: ColumnWidth;
    private gw;
    g9: number;
    private hm;
    ik: number;
    private hw;
    ix: number;
    private gq;
    itemsSource: IEnumerable;
    private hv;
    iv: number;
    private ht;
    iu: number;
    private hl;
    h4: number;
    private c3;
    c4: HeaderClickAction;
    private er;
    fd: boolean;
    private hs;
    it: number;
    private e1;
    fz: boolean;
    private fk;
    private bn;
    private bj;
    bl: ColumnShowingAnimationMode;
    readonly fp: boolean;
    private ba;
    columnPropertyUpdatingAnimationMode: ColumnPropertyUpdatingAnimationMode;
    protected readonly fl: boolean;
    readonly fh: boolean;
    private ag;
    ah: CellDataLoadedAnimationMode;
    readonly f4: boolean;
    private dn;
    dp: RowSelectionAnimationMode;
    readonly fi: boolean;
    private aq;
    ar: CellSelectionAnimationMode;
    private cb;
    cc: GridColumnAnimationSettings;
    private b2;
    b3: GridAnimationSettings;
    fq(a: Column): boolean;
    private be;
    private bc;
    bd: ColumnResizingAnimationMode;
    private fr;
    private bo;
    private bk;
    bm: ColumnShowingAnimationMode;
    private fo;
    private a5;
    private a3;
    a4: ColumnMovingAnimationMode;
    private fn;
    private a2;
    private a0;
    a1: ColumnHidingAnimationMode;
    private fm;
    private ax;
    private av;
    aw: ColumnExchangingAnimationMode;
    private qp;
    inset: Thickness;
    private cy;
    cz: GridSelectionMode;
    private bx;
    by: GridActivationMode;
    private cw;
    cx: GridSelectionBehavior;
    private et;
    fg: boolean;
    private x;
    readonly z: GridSelectedItemsCollection;
    private ab;
    readonly ad: GridSelectedKeysCollection;
    private cs;
    readonly ct: GridSelectedCellsCollection;
    private cp;
    readonly cq: GridSelectedCellRangesCollection;
    private es;
    ff: boolean;
    private w;
    readonly y: GridSelectedItemsCollection;
    private aa;
    readonly ac: GridSelectedKeysCollection;
    private oy;
    private ew;
    fs: boolean;
    private ez;
    fv: boolean;
    private e0;
    fw: boolean;
    private o5;
    pw: Brush;
    private pk;
    qb: Brush;
    private pn;
    qe: Brush;
    private pr;
    qi: Brush;
    private g2;
    ha: number;
    private pm;
    qd: Brush;
    private pe;
    p5: Brush;
    private pd;
    p4: Brush;
    private b9;
    ca: GridCellPosition;
    private o4;
    pv: Brush;
    private o6;
    px: Brush;
    private pb;
    p2: Brush;
    private dy;
    dz: SortIndicatorStyle;
    private ec;
    eh: FontInfo;
    private pj;
    qa: Brush;
    private pl;
    qc: Brush;
    private ee;
    ej: FontInfo;
    private pq;
    qh: Brush;
    private pu;
    ql: Brush;
    private po;
    qf: Brush;
    private ps;
    qj: Brush;
    private pp;
    qg: Brush;
    private pt;
    qk: Brush;
    private eg;
    el: FontInfo;
    private ef;
    ek: FontInfo;
    private hn;
    ip: number;
    h0(a: number): number;
    private pa;
    p1: Brush;
    private o9;
    p0: Brush;
    private pc;
    p3: Brush;
    private ed;
    ei: FontInfo;
    private pf;
    p6: Brush;
    private pi;
    p9: Brush;
    private pg;
    p7: Brush;
    private ph;
    p8: Brush;
    private hk;
    h3: number;
    private hj;
    h1: number;
    private o8;
    pz: Brush;
    private o7;
    py: Brush;
    private em;
    platformPixelConverter: IPlatformPixelConverter;
    private c7;
    renderingEngine: ICellRenderingEngine;
    private nv;
    private dk;
    readonly dl: ResponsiveStatesCollection;
    private ea;
    model: VisualModel;
    readonly qn: Rect;
    private bp;
    private ay;
    private s;
    private bs;
    readonly bq: ColumnSortDescriptionCollection;
    readonly az: ColumnGroupDescriptionCollection;
    sortDescriptionsChanged: (sender: any, args: GridSortDescriptionsChangedEventArgs) => void;
    groupDescriptionsChanged: (sender: any, args: GridGroupDescriptionsChangedEventArgs) => void;
    readonly t: FilterExpressionCollection;
    readonly bt: ColumnSummaryDescriptionCollection;
    private q;
    r: DataSourceSummaryScope;
    private ex;
    ft: boolean;
    private o;
    p: DataSourceSectionHeaderDisplayMode;
    private ey;
    fu: boolean;
    private c1;
    c2: GroupSummaryDisplayMode;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected nt(a: string, b: any, c: any): void;
    of(): void;
    oa(): void;
    ob(): void;
    mb(): void;
    private e7;
    gi: boolean;
    n9(): void;
    ma(): void;
    private u;
    actualDataSource: IDataSource;
    private c;
    j: string[];
    private a;
    d: string[];
    protected n6(a: string, b: any, c: any): void;
    private k;
    private l;
    private f;
    private oi;
    private md;
    private oj;
    private me;
    private l7;
    private nh;
    mn(): void;
    sizeChanged(a: number, b: number): void;
    private ho;
    private hp;
    setViewport(a: number, b: number, c: number, d: number): void;
    readonly actualColumns: GridColumnCollection;
    private cd;
    readonly columns: GridColumnCollection;
    nr(a: CellModel, b: any, c: any): void;
    nq(a: CellModel, b: any, c: any, d: string): void;
    as(a: CellPath): Column;
    mf(a: Column): void;
    l9(a: Column, b: Column): void;
    private lv;
    private nf;
    private nc;
    private m8;
    private l3;
    private nz;
    private l6;
    private gp;
    mk(a: number, b: number): void;
    private m9;
    private l2;
    private oz;
    private bw;
    j1(a: CellPath, b: Grid, c: any, d: number): string;
    ak(a: CellPath, b: string): CellModel;
    i0(): any;
    j0(): string;
    dm(a: number): RowPath;
    private eq;
    on(a: number): void;
    om(a: number): void;
    gm(a: any): boolean;
    gn(a: any[]): boolean;
    ok(a: number): void;
    private ol;
    go(a: Column): boolean;
    ng(a: number, b: number): void;
    private l1;
    private h8;
    private gl;
    ig(): number;
    ic(): number;
    ia(): number;
    n2(): void;
    fj: boolean;
    fx: boolean;
    readonly f2: boolean;
    readonly f3: boolean;
    readonly f0: boolean;
    readonly f1: boolean;
    private gj;
    private gk;
    nx(a: any, b: PrimaryKeyValue): void;
    ny(a: any, b: PrimaryKeyValue): void;
    n0(a: number, b: any, c: PrimaryKeyValue): void;
    private fb;
    mr(a: number, b: string): void;
    mt(a: number, b: string): void;
    f5(a: boolean, b: boolean): boolean;
    f6(a: boolean, b: boolean): boolean;
    private id;
    private h9;
    private ii;
    private ih;
    private h7;
    private lz;
    f8(a: boolean, b: boolean): boolean;
    f9(a: boolean, b: boolean): boolean;
    ga(a: boolean, b: boolean): boolean;
    gb(a: boolean, b: boolean): boolean;
    gc(a: boolean, b: boolean): boolean;
    gd(a: boolean, b: boolean): boolean;
    n3(): void;
    ge(a: boolean, b: boolean): boolean;
    f7(a: boolean, b: boolean): boolean;
    m1(a: PrimaryKeyValue, b: number): void;
    m2(a: PrimaryKeyValue, b: number): void;
    columnsAutoGenerated: (sender: any, args: GridColumnsAutoGeneratedEventArgs) => void;
    selectedItemsChanged: (sender: any, args: GridSelectedItemsChangedEventArgs) => void;
    selectedKeysChanged: (sender: any, args: GridSelectedKeysChangedEventArgs) => void;
    selectedCellsChanged: (sender: any, args: GridSelectedCellsChangedEventArgs) => void;
    activeCellChanged: (sender: any, args: GridActiveCellChangedEventArgs) => void;
    selectedCellRangesChanged: (sender: any, args: GridSelectedCellRangesChangedEventArgs) => void;
    ly(a: any, b: PrimaryKeyValue): void;
    o2(a: number, b: any, c: PrimaryKeyValue): void;
    oe(a: any, b: PrimaryKeyValue): void;
    private ao;
    lx(a: number, b: number, c: number, d: number): void;
    lw(a: CellRange): void;
    od(a: CellRange): void;
    oc(): void;
    private ml;
    n1(a: number, b: any, c: any): void;
    private mg;
    m3(): void;
    mj(): void;
    private mh;
    private ib;
    private ie;
    private mi;
    private eu;
    n7(): void;
    np(a: number, b: any): void;
    nu(a: number, b: any): void;
    ot(a: string): void;
    os(a: ResponsiveState): void;
    mq(a: number, b: any, c: any): void;
    mm(): void;
    mo(a: number, b: any): void;
    mp(a: number, b: any): void;
    h5(a: any): number;
    h6(a: any[]): number;
    g(): string[];
    i2(a: CellKey): any;
    i3(a: number, b: number): any;
    h(): ISummaryResult[];
    i(a: number): ISummaryResult[];
    private e6;
    gh: boolean;
    private e5;
    gg: boolean;
    private e4;
    gf: boolean;
}
/**
 * @hidden
 */
export declare class GridSelectedCellsChangedEventArgs extends EventArgs {
    static $t: Type;
    private _addedCells;
    addedCells: GridSelectedCellsCollection;
    private _removedCells;
    removedCells: GridSelectedCellsCollection;
}
/**
 * @hidden
 */
export declare class GridCellEventArgs extends EventArgs {
    static $t: Type;
    private _cellInfo;
    cellInfo: CellModel;
    private _grid;
    grid: Grid;
}
/**
 * @hidden
 */
export declare class GridAnimationManager extends Base {
    static $t: Type;
    constructor();
    readonly h: GridColumnAnimationSettings;
    private static o;
    protected p(): number;
    private l;
    private i;
    aq(): void;
    m(): List$1<number>;
    animationCreated: (sender: any, args: GridAnimationManagerAnimationCreatedEventArgs) => void;
    animationCompleted: (sender: any, args: GridAnimationManagerAnimationCompletedEventArgs) => void;
    animationCanceled: (sender: any, args: GridAnimationManagerAnimationCanceledEventArgs) => void;
    protected x(a: number): void;
    protected v(a: number): void;
    protected w(a: number): void;
    private g;
    private f;
    ap(a: Grid, b: GridColumnAnimationSettings, c: ColumnInfo, d: boolean, e: ColumnStates): void;
    private k;
    aj(a: Grid, b: GridColumnAnimationSettings, c: ColumnInfo, d: ColumnInfo, e: ColumnStates): void;
    private y;
    private u;
    private t;
    private j;
    private q;
    ah(a: Grid, b: GridColumnAnimationSettings, c: ColumnInfo, d: number): void;
    al(a: Grid, b: GridColumnAnimationSettings, c: ColumnInfo, d: ColumnStates): void;
    private r;
    private n;
    ak(a: Grid, b: GridColumnAnimationSettings, c: ColumnInfo, d: boolean, e: ColumnStates): void;
    s(a: Grid, b: ColumnInfo, c: string, d: CellPropertyAnimationType, e: any, f: any, g: boolean, h: boolean, i: boolean, j: boolean): void;
    private e;
    am(a: Grid, b: number, c: number): void;
    private d;
    ai(a: Grid, b: ColumnInfo): void;
    z(a: Grid, b: number, c: number, d: boolean): void;
    ag(a: Grid, b: number, c: number, d: number, e: boolean): void;
    an(a: Grid, b: number): void;
    ao(a: Grid, b: number): void;
    ae(a: Grid, b: number, c: number, d: number): void;
    aa(a: Grid, b: number, c: number, d: number): void;
    af(a: Grid, b: number, c: number, d: number): void;
    ab(a: Grid, b: number, c: number, d: number): void;
    ac(a: Grid, b: number, c: number): void;
    ad(a: Grid, b: number, c: number): void;
}
/**
 * @hidden
 */
export declare class CellKey extends Base {
    static $t: Type;
    private e;
    private g;
    private i;
    private a;
    private c;
    primaryKey: PrimaryKeyValue;
    h: any;
    j: string;
    readonly b: Column;
    d: Grid;
}
/**
 * @hidden
 */
export declare class GridSelectedCellsCollection extends ObservableCollection$1<CellKey> {
    static $t: Type;
    constructor();
    an(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    ao(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    readonly am: IList$1<CellKey>;
    ai(a: PrimaryKeyValue, b: number): CellKey;
    aj(a: PrimaryKeyValue, b: string): CellKey;
    ak(a: any, b: string): CellKey;
    ae(a: PrimaryKeyValue, b: Column): CellKey;
    af(a: PrimaryKeyValue, b: string): CellKey;
    ag(a: any, b: Column): CellKey;
    ah(a: any, b: string): CellKey;
    al(a: PrimaryKeyValue, b: number): CellKey;
}
/**
 * @hidden
 */
export declare abstract class DefinitionBase extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private bd;
    private t;
    externalObject: any;
    private c8;
    dm: Brush;
    private c9;
    dn: Brush;
    private c0;
    de: Brush;
    private c3;
    dh: Brush;
    private a2;
    ba: number;
    private a4;
    bc: number;
    private a3;
    bb: number;
    private a1;
    a9: number;
    private ay;
    a6: number;
    private a0;
    a8: number;
    private az;
    a7: number;
    private ax;
    a5: number;
    private r;
    grid: Grid;
    protected cl(a: Grid, b: Grid): void;
    private c2;
    dg: Brush;
    private c1;
    df: Brush;
    private dc;
    dy: Brush;
    private c6;
    dk: Brush;
    private db;
    dx: Brush;
    private c5;
    dj: Brush;
    private da;
    dw: Brush;
    private c4;
    di: Brush;
    private ar;
    au: number;
    private b;
    e: CellContentHorizontalAlignment;
    private g;
    j: CellContentVerticalAlignment;
    private a;
    c: CellContentHorizontalAlignment;
    private f;
    h: CellContentVerticalAlignment;
    private w;
    y: TextCellLineBreakMode;
    private v;
    x: TextCellLineBreakMode;
    private dd;
    dz: Brush;
    private c7;
    dl: Brush;
    private as;
    aw: number;
    private aq;
    at: number;
    private ac;
    textStyle: FontInfo;
    private ab;
    ad: FontInfo;
    k(a: CellPath, b: string): CellModel;
    protected abstract l(a: CellPath): CellModel;
    b7(a: CellPath, b: Grid, c: any, d: number): string;
    protected abstract b8(a: CellPath, b: Grid, c: any): string;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    cj(a: CellModel, b: Grid, c: any, d: any): void;
    private n;
    dataBinding: (sender: any, args: DataBindingEventArgs) => void;
    dataBound: (sender: any, args: DataBindingEventArgs) => void;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    cp(): void;
    protected aj(a: string): boolean;
    protected ak(a: string): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected cm(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected cs(): void;
    protected cy(): void;
    protected cz(): void;
    protected cw(): void;
    protected cv(): void;
    protected cx(): void;
    protected cu(): void;
    protected cn(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    private ag;
    protected ct(): void;
    private cr;
    private am;
    private ao;
    private al;
    protected readonly an: HashSet$1<string>;
    protected readonly ap: List$1<string>;
    private ch;
    protected d(): CellContentHorizontalAlignment;
    protected i(): CellContentVerticalAlignment;
    protected dv(): Brush;
    protected dp(): Brush;
    protected af(): FontInfo;
    protected dq(): Brush;
    protected du(): Brush;
    protected ds(): Brush;
    protected dr(): Brush;
    protected dt(): Brush;
    protected av(): number;
    definitionPropertyUpdated: (sender: any, args: DefinitionPropertyUpdatedEventArgs) => void;
    private z;
    cq(a: string, b: CellPropertyAnimationType, c: any): void;
    ai(): boolean;
    readonly aa: FastIterationDictionary$2<string, any>;
    ah(a: string): boolean;
    co(a: string): void;
    bf(a: string): any;
    b6(a: any, b: DataSourceSchemaPropertyType, c: any): string;
    u(a: ColumnSummaryDescription, b: ISummaryResult): SummaryData;
    cellStyleKeyRequested: (sender: any, args: CellStyleRequestedEventArgs) => void;
}
/**
 * @hidden
 */
export declare abstract class Column extends DefinitionBase {
    static $t: Type;
    constructor();
    protected gr(): Brush;
    private static fi;
    fj: number;
    private ec;
    ed: ColumnStates;
    private e9;
    ff: number;
    private fb;
    fh: number;
    private fa;
    fg: number;
    private e8;
    fe: number;
    private fn;
    f5: string;
    private e7;
    fd: number;
    private e6;
    fc: number;
    private fo;
    gb: string;
    private fm;
    fw: string;
    private fl;
    fp: string;
    private gp;
    gs: Brush;
    private go;
    gq: Brush;
    private eg;
    eh: GridColumnAnimationSettings;
    private ee;
    width: ColumnWidth;
    private e4;
    e5: number;
    private eq;
    e0: boolean;
    private eo;
    ey: boolean;
    private d0;
    d1: ColumnFilterCondition;
    private ei;
    header: Header;
    private ep;
    ez: boolean;
    private es;
    e2: boolean;
    private er;
    e1: boolean;
    private et;
    e3: boolean;
    private ea;
    eb: ColumnSortDirection;
    private en;
    ex: boolean;
    readonly eu: boolean;
    protected ds(): Brush;
    protected du(): Brush;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    protected cn(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected d3(): CellContentVerticalAlignment;
    protected d2(): CellContentHorizontalAlignment;
    private gm;
    private gi;
    protected cl(a: Grid, b: Grid): void;
    private gh;
    gn(): void;
    protected cs(): void;
    protected cy(): void;
    protected cz(): void;
    protected cw(): void;
    protected cv(): void;
    protected cx(): void;
    protected cu(): void;
    columnCellsPropertyUpdating: (column: Column, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    columnHeaderCellsPropertyUpdating: (column: Column, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    protected gl(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    d7(): ColumnHidingAnimationMode;
    d9(): ColumnShowingAnimationMode;
    d6(): ColumnExchangingAnimationMode;
    d8(): ColumnResizingAnimationMode;
    fu(): string;
    private ek;
    private em;
    gk(a: string, b: CellPropertyAnimationType, c: any): void;
    ew(): boolean;
    readonly el: FastIterationDictionary$2<string, any>;
    ev(a: string): boolean;
    gj(a: string): void;
    fk(a: string): any;
}
/**
 * @hidden
 */
export declare class GridColumnCollection extends ObservableCollection$1<Column> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class GridEffectGroup extends Base {
    static $t: Type;
    private c;
    private f;
    private a;
    private b;
    effectsFinished: (sender: any, e: EventArgs) => void;
    effectsCanceled: (sender: any, e: EventArgs) => void;
    constructor(a: number, b: boolean);
    constructor(a: number);
    constructor(a: number, ..._rest: any[]);
    k(): void;
    g(a: GridEffect): void;
    private h;
    private i;
    protected j(): void;
}
/**
 * @hidden
 */
export declare class RecyclingManager extends Base {
    static $t: Type;
    private b;
    constructor();
    a(a: string): CellModel;
    c(a: CellModel): void;
}
/**
 * @hidden
 */
export declare class ActivationManager extends Base {
    static $t: Type;
    private a;
    private b;
    private c;
    private e;
    private d;
    private f;
    private k;
    private l;
    private q;
    private s;
    private p;
    private readonly g;
    private readonly i;
    private readonly h;
    private readonly j;
    constructor(a: Grid, b: GridAnimationManager);
    ai(a: CellModel): void;
    m(a: CellModel): boolean;
    private n;
    private o;
    aa(): void;
    private ac;
    x(a: CellModel): void;
    w(a: CellPath): void;
    y(a: number, b: string): void;
    private v;
    private u;
    private ab;
    ae(): void;
    af(a: number): void;
    ag(a: number): void;
    private t;
    ah(a: number): void;
    ad(): void;
    private z;
    r(): number;
}
/**
 * @hidden
 */
export declare class SelectionManager extends Base {
    static $t: Type;
    private a;
    private b;
    private f;
    private e;
    private c;
    private d;
    private i;
    private readonly g;
    private readonly h;
    private r;
    private q;
    private j;
    constructor(a: Grid, b: GridAnimationManager);
    an(a: CellModel): void;
    am(a: CellModel): void;
    o(a: CellModel): boolean;
    private m;
    private k;
    private n;
    private l;
    private aq;
    private aj;
    private ak;
    private al;
    private as;
    private ar;
    private ai;
    private ah;
    private ag;
    private ap;
    private ao;
    private s;
    av(): void;
    au(): void;
    at(): void;
    private u;
    private p;
    z(): void;
    ad(a: number): void;
    ae(a: number): void;
    ac(a: number, b: Column): void;
    aa(a: number, b: Column): void;
    ab(a: number, b: number, c: Column): void;
    private t;
    af(a: number): void;
    w(): void;
    private v;
    private y;
    private x;
}
/**
 * @hidden
 */
export declare class SortManager extends Base {
    static $t: Type;
    private c;
    private e;
    constructor(a: Grid);
    d(a: Column): boolean;
    f(a: Column, b: ColumnSortDirection): boolean;
    private g;
    h(): void;
    private a;
    private b;
}
/**
 * @hidden
 */
export interface IDataAdapter {
    setDataSource(a: IDataSource): void;
    getItemForKey(a: PrimaryKeyValue): any;
    getItemKey(a: string[], b: any): PrimaryKeyValue;
    getRowKey(a: string[], b: number): PrimaryKeyValue;
    getRowCount(): number;
    getSectionCount(): number;
    getStickyRows(): number[];
    getStickyRowsInRange(a: number, b: number): number[];
    getStickRowPriority(a: number): number;
    isExclusivelySticky(a: number): boolean;
    pinRow(a: PrimaryKeyValue): void;
    unpinRow(a: PrimaryKeyValue): void;
    clearPinnedRows(): void;
    isRowPinned(a: number): boolean;
    firstVisibleIndexRequested: number;
    lastVisibleIndexRequested: number;
    indexOfKey(a: PrimaryKeyValue): number;
    fastGetItemIndexForKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    indexOfVisibleItemByKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    getDataRow(a: CellPath): number;
    resolveValue(a: number, b: string): any;
    resolveValueForPath(a: Grid, b: CellPath): any;
    resolveRow(a: number): any;
    resolveValueForDataRow(a: number): any;
    resolveValueForRow(a: CellPath): any;
    getSectionForRow(a: number): number;
    getRowPathForRow(a: number): RowPath;
    isPlaceholderValue(a: CellPath): boolean;
    isPlaceholderItem(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    isRowSpanning(a: DataSourceRowType): boolean;
    getRowIndent(a: number): number;
    getRootSummaryRowCount(): number;
}
/**
 * @hidden
 */
export declare let IDataAdapter_$type: Type;
/**
 * @hidden
 */
export declare class DataAdapter extends Base implements INotifyPropertyChanged, IDataAdapter {
    static $t: Type;
    private a;
    private f;
    private g;
    e: ColumnController;
    constructor(a: ColumnController);
    private b;
    c: IDataSource;
    setDataSource(a: IDataSource): void;
    getItemForKey(a: PrimaryKeyValue): any;
    getItemKey(a: string[], item_: any): PrimaryKeyValue;
    getRowKey(a: string[], b: number): PrimaryKeyValue;
    private l;
    protected m(a: string, b: any, c: any): void;
    getRowCount(): number;
    k(a: PrimaryKeyValue, b: any): number;
    indexOfKey(a: PrimaryKeyValue): number;
    fastGetItemIndexForKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    indexOfVisibleItemByKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    j(a: number): number;
    getSectionCount(): number;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private d;
    getDataRow(a: CellPath): number;
    resolveValue(a: number, b: string): any;
    resolveValueForPath(a: Grid, b: CellPath): any;
    resolveRow(a: number): any;
    resolveValueForDataRow(a: number): any;
    resolveValueForRow(a: CellPath): any;
    getSectionForRow(a: number): number;
    getRowPathForRow(a: number): RowPath;
    private h;
    firstVisibleIndexRequested: number;
    private i;
    lastVisibleIndexRequested: number;
    isPlaceholderValue(a: CellPath): boolean;
    isPlaceholderItem(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    getStickyRows(): number[];
    getStickyRowsInRange(a: number, b: number): number[];
    getStickRowPriority(a: number): number;
    isExclusivelySticky(a: number): boolean;
    isRowSpanning(a: DataSourceRowType): boolean;
    pinRow(a: PrimaryKeyValue): void;
    unpinRow(a: PrimaryKeyValue): void;
    clearPinnedRows(): void;
    isRowPinned(a: number): boolean;
    getRowIndent(a: number): number;
    getRootSummaryRowCount(): number;
}
/**
 * @hidden
 */
export declare class ColumnMovingSeparator extends DefinitionBase {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected dq(): Brush;
    private d0;
    d1: number;
    protected cl(a: Grid, b: Grid): void;
    protected cs(): void;
    private d3;
}
/**
 * @hidden
 */
export declare class DateTimeColumn extends Column {
    static $t: Type;
    private gt;
    private gu;
    gv: DateTimeFormats;
    private gz;
    g2: string;
    private gx;
    gy: any;
    protected cn(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    constructor();
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    private gw;
}
/**
 * @hidden
 */
export interface IExternalDefinitionBase {
    resolveStyleKey(a: string, b: CellPath, c: Grid, d: any): string;
}
/**
 * @hidden
 */
export declare let IExternalDefinitionBase_$type: Type;
/**
 * @hidden
 */
export declare class DataBindingEventArgs extends EventArgs {
    static $t: Type;
    private _resolvedValue;
    resolvedValue: any;
    private _rowObject;
    rowObject: any;
    private _cellInfo;
    cellInfo: CellModel;
}
/**
 * @hidden
 */
export declare abstract class Header extends DefinitionBase {
    static $t: Type;
    constructor();
    protected dv(): Brush;
    protected dq(): Brush;
    protected eq(): Brush;
    protected af(): FontInfo;
    protected cl(a: Grid, b: Grid): void;
    protected cs(): void;
    protected cy(): void;
    protected cz(): void;
    protected el(): void;
    protected em(): void;
    private ek;
    private eo;
    er: Brush;
    private en;
    ep: Brush;
    private d1;
    d3: SortIndicatorStyle;
    private d0;
    d2: SortIndicatorStyle;
    private d5;
    d9: number;
    private d7;
    eb: number;
    private d6;
    ea: number;
    private d4;
    d8: number;
    protected ak(a: string): boolean;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class ColumnResizingSeparator extends DefinitionBase {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected dq(): Brush;
    private d0;
    d1: number;
    protected cl(a: Grid, b: Grid): void;
    protected cs(): void;
    private d3;
}
/**
 * @hidden
 */
export declare class HeaderSeparator extends DefinitionBase {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected dq(): Brush;
    protected d0(): number;
    protected cl(a: Grid, b: Grid): void;
    private d1;
    protected cs(): void;
    private d2;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class ImageColumn extends Column {
    static $t: Type;
    private gv;
    gw: ImageStretchOptions;
    private gt;
    gu: ImageResourceType;
    constructor();
    protected i(): CellContentVerticalAlignment;
    protected d2(): CellContentHorizontalAlignment;
    protected d3(): CellContentVerticalAlignment;
    protected d(): CellContentHorizontalAlignment;
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    private gx;
}
/**
 * @hidden
 */
export declare class NumericColumn extends Column {
    static $t: Type;
    constructor();
    protected d(): CellContentHorizontalAlignment;
    private g5;
    hf: string;
    private g7;
    hj: string;
    private g6;
    hh: string;
    private g8;
    hl: string;
    private gw;
    gz: number;
    private gx;
    g0: number;
    private gy;
    g1: number;
    private gt;
    gu: boolean;
    private g4;
    ha: string;
    private g2;
    g3: any;
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    private gv;
}
/**
 * @hidden
 */
export declare class SectionFooter extends DefinitionBase {
    static $t: Type;
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class SectionHeader extends DefinitionBase {
    static $t: Type;
    private eq;
    es: Brush;
    private ep;
    er: Brush;
    private d7;
    eb: number;
    private d9;
    ed: number;
    private d8;
    ec: number;
    private d6;
    ea: number;
    private d4;
    d5: boolean;
    private d1;
    d2: GroupSummaryDisplayMode;
    sectionHeaderPropertyUpdating: (sectionHeader: SectionHeader, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    constructor();
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected dq(): Brush;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    protected cl(a: Grid, b: Grid): void;
    private em;
    eo(): void;
    protected cs(): void;
    protected cy(): void;
    protected cz(): void;
    en(): void;
    protected cn(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    private d0;
}
/**
 * @hidden
 */
export declare class RowSeparator extends DefinitionBase {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected cl(a: Grid, b: Grid): void;
    protected cs(): void;
    protected cv(): void;
    protected cx(): void;
    protected cu(): void;
    private d0;
    protected l(a: CellPath): CellModel;
    protected dq(): Brush;
    protected du(): Brush;
    protected dr(): Brush;
    protected ds(): Brush;
    protected av(): number;
}
/**
 * @hidden
 */
export declare abstract class SummaryRow extends DefinitionBase {
    static $t: Type;
    private el;
    eq: Brush;
    private ej;
    en: Brush;
    private em;
    er: Brush;
    private ek;
    eo: Brush;
    private d1;
    d5: number;
    private d3;
    d7: number;
    private d2;
    d6: number;
    private d0;
    d4: number;
    constructor();
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected l(a: CellPath): CellModel;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    protected cl(a: Grid, b: Grid): void;
    protected ep(): Brush;
    private eg;
    protected eh(): void;
    protected ei(): void;
    protected cz(): void;
    protected cn(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class SummaryRowRoot extends SummaryRow {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected dq(): Brush;
    protected cs(): void;
    protected eh(): void;
    protected ei(): void;
    protected cy(): void;
}
/**
 * @hidden
 */
export declare class SummaryRowSection extends SummaryRow {
    static $t: Type;
    protected b8(a: CellPath, b: Grid, c: any): string;
    protected dq(): Brush;
    protected cs(): void;
    protected eh(): void;
    protected ei(): void;
    protected cy(): void;
}
/**
 * @hidden
 */
export declare class TemplateColumn extends Column {
    static $t: Type;
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    gu(a: TemplateCellModel, b: any): void;
    cellUpdating: (sender: any, args: TemplateCellUpdatingEventArgs) => void;
}
/**
 * @hidden
 */
export declare class TemplateCellUpdatingEventArgs extends EventArgs {
    static $t: Type;
    private _cellInfo;
    cellInfo: TemplateCellModel;
    private _content;
    content: any;
}
/**
 * @hidden
 */
export declare class TextColumn extends Column {
    static $t: Type;
    private gt;
    gv: string;
    protected l(a: CellPath): CellModel;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    private gu;
    protected b8(a: CellPath, b: Grid, c: any): string;
}
/**
 * @hidden
 */
export declare class TextHeader extends Header {
    static $t: Type;
    constructor();
    protected l(a: CellPath): CellModel;
    protected b8(a: CellPath, b: Grid, c: any): string;
    ci(a: CellModel, b: Grid, c: any, d: any): void;
    ck(a: CellModel, b: Grid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class GridEffect extends Base {
    static $t: Type;
    constructor();
    bu(): void;
    bt(a: GridEffect): void;
    private s;
    t: GridEffectMainIntent;
    am(a: GridEffect): boolean;
    private u;
    v: GridEffectSubIntent;
    private br;
    bs: string;
    private af;
    as: boolean;
    private ac;
    ap: boolean;
    onFinished: (target: any) => void;
    onCanceled: (target: any, canceledBy: GridEffect) => void;
    private a3;
    private a1;
    ba: number;
    private h;
    i: (startItem: CellPath, numberOfItems: number, item: CellPath) => number;
    private a7;
    bi: number;
    private a8;
    bj: number;
    private a2;
    a9: number;
    private j;
    k: (startItem: CellPath, numberOfItems: number, item: CellPath) => number;
    private a4;
    bg: number;
    private c;
    g: CellPath;
    private a;
    e: CellPath;
    private a6;
    bh: number;
    private ad;
    aq: boolean;
    private ab;
    ao: boolean;
    private bk;
    bl: number;
    private bm;
    bo: any;
    private bn;
    bq: any;
    private w;
    x: (progress: number, fromValue: any, toValue: any, target: any, model: VisualModel) => void;
    private p;
    q: (progress: number) => number;
    private aa;
    al: boolean;
    private n;
    o: (target: any, model: VisualModel) => any;
    private ae;
    ar: boolean;
    bx(a: GridAnimationPhaseSettings): void;
    private r;
    private ay;
    au(a: ColumnInfo, b: VisualModel, c: GridLayerController, d: number): boolean;
    av(a: any, b: VisualModel, c: GridLayerController, d: number): boolean;
    private a0;
    private an;
    bz(a: CellPath, b: VisualModel, c: GridLayerController, d: number): void;
    at(a: CellModel, b: VisualModel, c: GridLayerController, d: number): boolean;
    private az;
    by(a: any, b: VisualModel, c: any): void;
    private bp;
    aw(a: SectionInfo, b: VisualModel, c: GridLayerController, d: number): boolean;
    ag(a: CellPath, b: VisualModel): boolean;
    ah(a: ColumnInfo, b: VisualModel): boolean;
    ai(a: RowPath, b: VisualModel): boolean;
    aj(a: GridColumnSpacer, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
    private a5;
    private b;
    protected readonly f: CellPath;
    bf(a: VisualModel, b: GridLayerController, c: CellPath, d: number): number;
    private ax;
    private bd;
    private bb;
    be(a: VisualModel, b: CellPath): number;
    bc(a: VisualModel, b: GridLayerController, c: CellPath, d: number): number;
    protected d(a: VisualModel): CellPath;
    protected y(a: RowPath, b: RowPath): RowPath;
    protected z(a: RowPath, b: RowPath): RowPath;
    ak(a: VisualModel, b: GridLayerController, c: number): boolean;
}
/**
 * @hidden
 */
export declare class ColumnEffect extends GridEffect {
    static $t: Type;
    b0: number;
    ah(a: ColumnInfo, b: VisualModel): boolean;
}
/**
 * @hidden
 */
export declare class SpacerEffect extends GridEffect {
    static $t: Type;
    b0: number;
    aj(a: GridColumnSpacer, b: VisualModel): boolean;
}
/**
 * @hidden
 */
export declare class ColumnCellsEffect extends GridEffect {
    static $t: Type;
    b2: number;
    b1: number;
    b0: FixedCellPositions;
    ag(a: CellPath, b: VisualModel): boolean;
    protected d(a: VisualModel): CellPath;
    be(a: VisualModel, b: CellPath): number;
}
/**
 * @hidden
 */
export declare class CellEffect extends GridEffect {
    static $t: Type;
    b4: number;
    b3: number;
    b1: FixedCellPositions;
    b0: CellPath;
    b2: boolean;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class CellPositionEffect extends CellEffect {
    static $t: Type;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class RowEffect extends GridEffect {
    static $t: Type;
    b0: RowPath;
    ai(a: RowPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class RowCellsEffect extends GridEffect {
    static $t: Type;
    b0: RowPath;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
    be(a: VisualModel, b: CellPath): number;
}
/**
 * @hidden
 */
export declare class GridEffectManager extends Base {
    static $t: Type;
    private b;
    protected readonly c: ITickProvider;
    constructor(a: ITickProvider, b: Grid);
    ae(a: RowPath): void;
    af(a: RowPath): void;
    private k;
    private j;
    private m;
    private l;
    private i;
    private n;
    private q;
    private o;
    a: Grid;
    private ad;
    d(): boolean;
    ac(): void;
    ab(): void;
    an(a: boolean): void;
    private p;
    private am;
    private aa;
    u(a: ColumnInfo, b: ColumnEffect): void;
    ai(a: number, b: boolean, c: GridEffect): void;
    z(a: GridColumnSpacer, b: SpacerEffect): void;
    al(a: GridColumnSpacer, b: boolean, c: GridEffect): void;
    t(a: ColumnInfo, b: ColumnCellsEffect): void;
    x(a: ColumnCellsEffect): void;
    y(a: ColumnCellsEffect): void;
    ah(a: number, b: boolean, c: GridEffect): void;
    w(a: RowPath, b: RowEffect): void;
    ak(a: RowPath, b: boolean, c: GridEffect): void;
    v(a: RowPath, b: RowCellsEffect): void;
    aj(a: RowPath, b: boolean, c: GridEffect): void;
    r(a: CellPath, b: CellEffect, c: number): void;
    s(a: CellPath, b: CellPositionEffect): void;
    ag(a: CellPath, b: boolean, c: GridEffect): void;
    f(a: number, b: VisualModel, c: GridLayerController): boolean;
    h(a: number, b: VisualModel, c: GridLayerController): boolean;
    g(a: number, b: VisualModel, c: GridLayerController): boolean;
    e(a: number, b: VisualModel, c: GridLayerController): boolean;
}
/**
 * @hidden
 */
export declare class GridLayerController extends Base {
    static $t: Type;
    private e;
    a(a: CellPath, b: VisualModel): CellModel;
    b(a: CellPath, b: Grid, c: VisualModel, d: GridLayer, e: ModelTypes, f: boolean, g: boolean, h: boolean): CellModel;
    private d;
    private g;
    private f;
    i(a: CellPath, b: VisualModel): void;
    j(a: CellPath, b: GridLayer, c: VisualModel): void;
    c(a: CellPath, b: VisualModel): CellModel;
    h(a: CellModel, b: VisualModel, c: number, d: number, e: number, f: number): void;
}
/**
 * @hidden
 */
export declare class VisibilityEngine extends Base {
    static $t: Type;
    private j;
    private k;
    private c;
    private b;
    e: boolean;
    private l;
    m: number;
    constructor();
    private d;
    w(): void;
    n(a: Grid): void;
    o(a: Grid, b: VisualModel, c: SpatialEngine, d: boolean): void;
    a(a: Grid, b: VisualModel, c: SpatialEngine, d: Rect): CalculationParameters;
    private v;
    private u;
    private r;
    i(a: Grid, b: VisualModel, c: Rect): List$1<PinnedRowInfo>;
    h(a: Grid, b: VisualModel, c: Rect, d: CalculationParameters, e: boolean): List$1<PinnedRowInfo>;
    private z;
    private g;
    private f;
    private q;
    private s;
    private t;
    private p;
    private x;
    private y;
    private aa;
    private ab;
    private ac;
    private ad;
    private ah;
    private ae;
    private af;
    private ag;
}
/**
 * @hidden
 */
export declare class PinnedRowInfo extends Base {
    static $t: Type;
    k: number;
    m: string;
    j: number;
    readonly h: number;
    i: number;
    g: number;
    d: boolean;
    private c;
    f: boolean;
    a: DataSourceRowType;
    e: boolean;
    l: number;
    b: VisualModel;
}
/**
 * @hidden
 */
export interface ICellRenderingEngine {
    refresh(a: VisualModel, b: boolean): void;
    viewportChanged(): void;
    invalidateVisibility(a: () => void): void;
    readonly initialRefreshFinished: boolean;
}
/**
 * @hidden
 */
export declare let ICellRenderingEngine_$type: Type;
/**
 * @hidden
 */
export declare class SpatialEngine extends Base {
    static $t: Type;
    private d;
    private c;
    n(a: Grid, b: VisualModel, c: number): void;
    m(a: Grid, b: VisualModel, c: number): void;
    e(a: ColumnInfo): number;
    private static l;
    h(a: number, b: number, c: Grid, d: VisualModel): number;
    i(a: number, b: number, c: Grid, d: VisualModel): number;
    g(a: number, b: Grid, c: VisualModel): number;
    j(a: number, b: Grid, c: VisualModel): number;
    k(a: number, b: Grid, c: VisualModel): number;
    b(a: number, b: VisualModel): RowPath;
    q(a: GridLayerController, b: number, c: Column, d: VisualModel): void;
    o(a: number, b: Column, c: VisualModel): void;
    s(a: RowPath, b: VisualModel): void;
    t(a: GridLayerController, b: RowPath, c: VisualModel): void;
    private v;
    private a;
    private w;
    private u;
    r(a: GridLayerController, b: VisualModel): void;
    p(a: GridLayerController, b: VisualModel, c: number, d: number, e: number): void;
    f(a: VisualModel, b: RowPath): number;
}
/**
 * @hidden
 */
export declare class ColumnExchanger extends Base {
    static $t: Type;
    c: any;
    a: Column;
    b: number;
    constructor(a: number);
    constructor(a: number, b: Column, c: number);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class ColumnExchangersCollection extends ObservableCollection$1<ColumnExchanger> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ResponsiveEngine extends Base {
    static $t: Type;
    private c;
    private l;
    private m;
    private k;
    private h;
    private i;
    private j;
    private a;
    private f;
    g: ResponsiveStatesCollection;
    private b;
    private d;
    constructor(a: Grid);
    x(a: ResponsiveState): void;
    y(a: number, b: number): void;
    private w;
    private q;
    private t;
    private u;
    private o;
    private p;
    private r;
    private v;
    private s;
    private e;
    private n;
}
/**
 * @hidden
 */
export declare class ResponsivePhase extends Base {
    static $t: Type;
    j: any;
    k: string;
    i: number;
    private d;
    readonly e: ColumnPropertySettersCollection;
    private a;
    readonly b: ColumnExchangersCollection;
    g(a: ColumnPropertySetter): ResponsivePhase;
    c(): ColumnPropertySetter;
    f(a: ColumnExchanger): ResponsivePhase;
    h(): ResponsivePhase;
}
/**
 * @hidden
 */
export declare class ResponsivePhasesCollection extends ObservableCollection$1<ResponsivePhase> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ResponsiveState extends Base {
    static $t: Type;
    m: any;
    n: string;
    k: number;
    j: number;
    stateEntering: (sender: any, eventArgs: ResponsiveStateEnteringEventArgs) => void;
    stateEntered: (sender: any, eventArgs: ResponsiveStateEnteredEventArgs) => void;
    stateExited: (sender: any, eventArgs: ResponsiveStateExitedEventArgs) => void;
    private h;
    i: boolean;
    l: number;
    private b;
    readonly c: ResponsivePhasesCollection;
    d(a: ResponsivePhase): ResponsiveState;
    a(): ResponsivePhase;
    p(): void;
    o(): void;
    q(): void;
}
/**
 * @hidden
 */
export declare class ResponsiveStatesCollection extends ObservableCollection$1<ResponsiveState> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class GridLayer extends FastIterationDictionary$2<CellPath, CellModel> {
    static $t: Type;
    v: string;
    constructor(a: string);
}
/**
 * @hidden
 */
export declare class ColumnInfo extends Base {
    static $t: Type;
    constructor();
    l: number;
    b: ColumnWidth;
    h: number;
    j: number;
    k: number;
    n: string;
    m: number;
    c: FixedCellPositions;
    f: number;
    i: number;
    g: number;
    d(a: VisualModel): number;
    e(a: VisualModel): number;
    a: ColumnStates;
}
/**
 * @hidden
 */
export declare class SectionInfo extends Base {
    static $t: Type;
    h: number;
    m: number;
    q: number;
    o: number;
    g: number;
    d: number;
    n: number;
    p: number;
    i: number;
    b: List$1<number>;
    c: List$1<number>;
    l(): number;
    e(a: number): number;
    f(a: number): number;
    k(): number;
    j(a: number): number;
    a(a: number): RowPath;
}
/**
 * @hidden
 */
export declare class VisualModel extends Base {
    static $t: Type;
    private _actualVisibleRegion;
    actualVisibleRegion: Rect;
    private _absoluteWidth;
    absoluteWidth: number;
    private _absoluteHeight;
    absoluteHeight: number;
    bs: number;
    bu: number;
    bv: number;
    br: number;
    bp: number;
    bq: number;
    bo: number;
    bz: number;
    b0: number;
    bx: number;
    readonly bk: number;
    readonly bi: number;
    readonly bj: number;
    readonly bh: number;
    readonly bl: number;
    private u;
    ao: GridLayer;
    private h;
    ab: GridLayer;
    private x;
    ar: GridLayer;
    private k;
    ae: GridLayer;
    private i;
    ac: GridLayer;
    private w;
    aq: GridLayer;
    private v;
    ap: GridLayer;
    private m;
    ag: GridLayer;
    private l;
    af: GridLayer;
    private z;
    at: GridLayer;
    private y;
    as: GridLayer;
    private j;
    ad: GridLayer;
    private n;
    ah: GridLayer;
    private o;
    ai: GridLayer;
    private p;
    aj: GridLayer;
    private q;
    ak: GridLayer;
    private r;
    al: GridLayer;
    private s;
    am: GridLayer;
    private t;
    an: GridLayer;
    private aa;
    au: GridLayer;
    private c;
    d(a: number, b: number): CellModel;
    private ax;
    ay: FastIterationDictionary$2<CellPath, List$1<CellModel>>;
    bf: List$1<SectionInfo>;
    ba: List$1<ColumnInfo>;
    a5: Dictionary$2<number, number>;
    bb: List$1<ColumnInfo>;
    a6: Dictionary$2<number, number>;
    a9: List$1<ColumnInfo>;
    a1: boolean;
    a3: boolean;
    private a8;
    bg: List$1<GridColumnSpacerCollection>;
    a4: Dictionary$2<number, number>;
    aw: RowPath;
    av: RowPath;
    a2(): boolean;
    private b2;
    private e;
    f(a: number): ColumnInfo;
    b3(a: ColumnInfo): void;
    b4(a: ColumnInfo): void;
    b5(a: ColumnInfo): void;
    constructor();
    private b9;
    private a7;
    readonly be: List$1<GridLayer>;
    az(): boolean;
    b8(): void;
    b7(): void;
    b(): VisualModelExport;
    private a;
    bw: number;
    by: number;
    a0: boolean;
    b1: number;
    g(a: number, b: ColumnInfo, c: number, d: boolean, e: boolean): GridColumnSpacer;
    b6(a: GridColumnSpacer): void;
    bd(a: ColumnInfo): List$1<GridColumnSpacer>;
    bc(a: ColumnInfo): List$1<CellModel>;
    bt(): number;
}
