import { CellKey as CellKey_internal } from "./CellKey";
import { IgxPrimaryKeyValue } from './igx-primary-key-value';
import { IgxColumnComponent } from './igx-column-component';
/**
 * An indentifier for a specific cell in the grid.
*/
export declare class IgxCellKey {
    protected _implementation: any;
    private _primaryKey;
    readonly i: CellKey_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the primary key of the row associated with the cell.
    */
    primaryKey: IgxPrimaryKeyValue;
    /**
 * Gets or sets the row data object associated with the cell.
*/
    rowItem: any;
    /**
     * Gets or sets the column name associated with the cell.
     * All columns in the grid must have a unique name. That unique name is what is used for this property.
    */
    columnUniqueKey: string;
    /**
     * Gets or sets the resolved column object associated with this cell.
    */
    readonly resolvedColumn: IgxColumnComponent;
}
