import { EventEmitter } from '@angular/core';
import { IgxFormatGroupTextEventArgs } from "./igx-format-group-text-event-args";
import { IgxColumnSortDescription } from "./igx-column-sort-description";
import { ColumnGroupDescription as ColumnGroupDescription_internal } from "./ColumnGroupDescription";
/**
 * Represents an element in the current grouping applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgxColumnGroupDescription extends IgxColumnSortDescription {
    protected createImplementation(): ColumnGroupDescription_internal;
    /**
                                 * @hidden
                                 */
    readonly i: ColumnGroupDescription_internal;
    constructor();
    /**
     * Gets or sets an INTL.DateTimeFormat or INTL.NumericFormat to use to format the value.
    */
    formatOverride: any;
    /**
     * Gets or sets the display text for the group name.
    */
    displayName: string;
    private _formatText;
    /**
     * Called when the value is being formatted.
    */
    readonly formatText: EventEmitter<{
        sender: any;
        args: IgxFormatGroupTextEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
