import { ColumnSortDescription as ColumnSortDescription_internal } from "./ColumnSortDescription";
import { ListSortDirection } from "igniteui-angular-core";
/**
 * Represents an element in the current sort applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgxColumnSortDescription {
    protected createImplementation(): ColumnSortDescription_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColumnSortDescription_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the property being sorted.
    */
    propertyPath: string;
    /**
     * Gets or sets the direction to sort based on the property.
    */
    sortDirection: ListSortDirection;
    /**
     * Returns if the SortDescription is equal to another.
    
    * @param other  * The SortDescription to compare to.
    */
    equals(other: any): boolean;
    /**
     * Returns the hash code for the SortDescription.
    
    */
    getHashCode(): number;
}
