import { EventEmitter } from '@angular/core';
import { IgxFormatSummaryTextEventArgs } from "./igx-format-summary-text-event-args";
import { ColumnSummaryDescription as ColumnSummaryDescription_internal } from "./ColumnSummaryDescription";
import { SummaryOperand } from "igniteui-angular-core";
import { SummaryCalculator } from "igniteui-angular-core";
/**
 * Represents a summary that is applied to a datasource. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgxColumnSummaryDescription {
    protected createImplementation(): ColumnSummaryDescription_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColumnSummaryDescription_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    propertyPath: string;
    operand: SummaryOperand;
    calculator: SummaryCalculator;
    /**
     * Gets or sets the name to use when displaying the calculator name.
    */
    calculatorDisplayName: string;
    /**
     * Gets or sets the display name for the summary.
    */
    displayName: string;
    /**
     * Gets or sets an INTL.DateTimeFormat or INTL.NumericFormat to use to format the value.
    */
    formatOverride: any;
    /**
     * Gets or sets the minimum fraction digits. If FormatOverride is specificied this value is ignored.
    */
    maxFractionDigits: number;
    equals(other: any): boolean;
    getHashCode(): number;
    private _formatText;
    /**
     * Called when the value is being formatted.
    */
    readonly formatText: EventEmitter<{
        sender: any;
        args: IgxFormatSummaryTextEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
