import { ColumnWidth as ColumnWidth_internal } from "./ColumnWidth";
/**
 * Represents a width of a column.
*/
export declare class IgxColumnWidth {
    protected createImplementation(): ColumnWidth_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColumnWidth_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets whether to use star sizing for the column's width
    */
    isStarSized: boolean;
    /**
     * Gets or sets the fixed width or the proportional width of the column, depending on whether this width is a star width.
    */
    value: number;
    /**
     * Gets or sets a minimum width to use when star sizing.
    */
    minimumWidth: number;
}
