import { DateTimeFormats } from "./DateTimeFormats";
import { IgxCellInfo } from "./igx-cell-info";
import { DateTimeCellModel as DateTimeCellModel_internal } from "./DateTimeCellModel";
/**
 * Backing information about a date time cell for the grid.
*/
export declare class IgxDateTimeCellInfo extends IgxCellInfo {
    protected createImplementation(): DateTimeCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: DateTimeCellModel_internal;
    constructor();
    /**
     * Sets or gets the DateTime value for the cell.
    */
    dateTimeValue: Date;
    /**
     * The format options to apply to the value
    */
    formatOverride: any;
    /**
     * Sets or gets the simple DateTimeFormat to use for the cell.
    */
    dateTimeFormat: DateTimeFormats;
    /**
     * Sets or gets whether the value to use is a DateTimeOffset value.
    */
    isOffsetValue: boolean;
}
