import { Type } from '@angular/core';
import { DateTimeFormats } from "./DateTimeFormats";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { DateTimeColumn } from "./DateTimeColumn";
/**
 * A column for displaying date/time values.
*/
export declare const IgxDateTimeColumnComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxDateTimeColumnComponent extends IgxColumnComponent {
    protected createImplementation(): DateTimeColumn;
    /**
                                 * @hidden
                                 */
    readonly i: DateTimeColumn;
    constructor();
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    dateTimeFormat: DateTimeFormats;
    /**
     * Gets or sets the INTL DateTimeFormat object to use for formatting the date values.
    */
    formatOverride: any;
}
