import { GridEasingFunctionType } from "./GridEasingFunctionType";
import { GridAnimationPhaseSettings as GridAnimationPhaseSettings_internal } from "./GridAnimationPhaseSettings";
/**
 * This class is used to group the settings to define an animation phase.
*/
export declare class IgxGridAnimationPhaseSettings {
    protected createImplementation(): GridAnimationPhaseSettings_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridAnimationPhaseSettings_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The duration of an animation, in milliseconds
    */
    durationMilliseconds: number;
    /**
     * The amount of time to delay an animation, in milliseconds.
    */
    holdInitialMilliseconds: number;
    /**
     * The amount of time to delay each item animating, in milliseconds
    */
    perItemDelayMilliseconds: number;
    /**
     * The amount of time each item animating should take, in milliseconds
    */
    subItemDurationMilliseconds: number;
    /**
     * The desired amount of time each item animating should take, in milliseconds
    */
    desiredSubItemDurationMilliseconds: number;
    /**
     * Configures whether all items animating should finish simultaneously
    */
    shouldItemsFinishSimultaneously: boolean;
    /**
     * Configures the Easing function used to animate the individual items
    */
    easingFunctionType: GridEasingFunctionType;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
