import { Type } from '@angular/core';
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { Header } from "./Header";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare const IgxHeaderComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare abstract class IgxHeaderComponent extends IgxDefinitionBaseComponent {
    /**
                                 * @hidden
                                 */
    readonly i: Header;
    constructor();
    /**
     * Gets or sets the color to use for the sort indicator icon
    */
    sortIndicatorColor: string;
    /**
     * Gets the actual background color that is used for the cells when they are selected
    */
    actualSortIndicatorColor: string;
    sortIndicatorStyle: SortIndicatorStyle;
    actualSortIndicatorStyle: SortIndicatorStyle;
    /**
     * Gets or sets the amount of left padding to use for the cell content.
    */
    paddingLeft: number;
    /**
     * Gets or sets the amount of top padding to use for the cell content.
    */
    paddingTop: number;
    /**
     * Gets or sets the amount of right padding to use for the cell content.
    */
    paddingRight: number;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content.
    */
    paddingBottom: number;
}
