import { ImageStretchOptions } from "./ImageStretchOptions";
import { ImageResourceType } from "./ImageResourceType";
import { IgxCellInfo } from "./igx-cell-info";
import { ImageCellModel as ImageCellModel_internal } from "./ImageCellModel";
/**
 * Backing information for an image cell in the grid.
*/
export declare class IgxImageCellInfo extends IgxCellInfo {
    protected createImplementation(): ImageCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: ImageCellModel_internal;
    constructor();
    /**
     * Sets or gets the resource path to use to get the image for the cell.
    */
    imagePath: string;
    /**
     * Sets or gets the image stretching behavior for the image.
    */
    imageStretchOption: ImageStretchOptions;
    /**
     * Sets or gets the image resource type. Indicates which type of resource should be fetched and how ImagePath should be interpreted.
    */
    imageResourceType: ImageResourceType;
}
