import { Type } from '@angular/core';
import { ImageStretchOptions } from "./ImageStretchOptions";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ImageColumn } from "./ImageColumn";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
export declare const IgxImageColumnComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxImageColumnComponent extends IgxColumnComponent {
    protected createImplementation(): ImageColumn;
    /**
                                 * @hidden
                                 */
    readonly i: ImageColumn;
    constructor();
    /**
     * Gets or sets the stretch option to use when rendering images
    */
    imageStretchOption: ImageStretchOptions;
}
