import { EventEmitter, OnInit } from '@angular/core';
import { IgxGridFilterDialogOpeningEventArgs } from "./igx-grid-filter-dialog-opening-event-args";
import { IgxGridFilterDialogFilterChangeEventArgs } from "./igx-grid-filter-dialog-filter-change-event-args";
import { GridFilterDialog } from "./GridFilterDialog";
/**
 * An advanced grid for displaying data.
*/
export declare const IgxLiveGridFilterDialogComponent_PROVIDERS: any[];
export declare class IgxLiveGridFilterDialogComponent implements OnInit {
    protected createImplementation(): GridFilterDialog;
    ngOnInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridFilterDialog; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxLiveGridFilterDialogComponent;
    private onImplementationCreated;
    constructor();
    isAnimationEnabled: boolean;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio: number;
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    actualPixelScalingRatio: number;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    notifySizeChanged(width: number, height: number): void;
    private _dialogOpening;
    readonly dialogOpening: EventEmitter<{
        sender: any;
        args: IgxGridFilterDialogOpeningEventArgs;
    }>;
    private _filterChanging;
    readonly filterChanging: EventEmitter<{
        sender: any;
        args: IgxGridFilterDialogFilterChangeEventArgs;
    }>;
    private _filterChanged;
    readonly filterChanged: EventEmitter<{
        sender: any;
        args: IgxGridFilterDialogFilterChangeEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
