import { EventEmitter, OnInit } from '@angular/core';
import { ColumnSortDirection } from "./ColumnSortDirection";
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { IgxSortIndicatorRenderCompletedEventArgs } from "./igx-sort-indicator-render-completed-event-args";
import { GridSortIndicator } from "./GridSortIndicator";
/**
 * An advanced grid for displaying data.
*/
export declare const IgxLiveGridSortIndicatorComponent_PROVIDERS: any[];
export declare class IgxLiveGridSortIndicatorComponent implements OnInit {
    protected createImplementation(): GridSortIndicator;
    ngOnInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridSortIndicator; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxLiveGridSortIndicatorComponent;
    private onImplementationCreated;
    constructor();
    sortDirection: ColumnSortDirection;
    iconColor: string;
    isAnimationEnabled: boolean;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio: number;
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    actualPixelScalingRatio: number;
    sortIndicatorStyle: SortIndicatorStyle;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getDesiredScale(): number;
    notifySizeChanged(width: number, height: number): void;
    private _renderCompleted;
    readonly renderCompleted: EventEmitter<{
        sender: any;
        args: IgxSortIndicatorRenderCompletedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
