import { Type } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { NumericColumn } from "./NumericColumn";
/**
 * Represents a Numeric grid column, used to allow the developer to display a formatted number in a cell.
*/
export declare const IgxNumericColumnComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxNumericColumnComponent extends IgxColumnComponent {
    protected createImplementation(): NumericColumn;
    /**
                                 * @hidden
                                 */
    readonly i: NumericColumn;
    constructor();
    /**
     * Gets or sets the string to prefix a negative value. If FormatString is specificied this value is ignored.
    */
    negativePrefix: string;
    /**
     * Gets or sets the string to prefix a positive value. If FormatString is specificied this value is ignored.
    */
    positivePrefix: string;
    /**
     * Gets or sets the string to suffix a negative value. If FormatString is specificied this value is ignored.
    */
    negativeSuffix: string;
    /**
     * Gets or sets the string to suffix a positive value. If FormatString is specificied this value is ignored.
    */
    positiveSuffix: string;
    /**
     * Gets or sets the maximum fraction digits. If FormatString is specificied this value is ignored.
    */
    maxFractionDigits: number;
    /**
     * Gets or sets the minimum fraction digits. If FormatString is specificied this value is ignored.
    */
    minFractionDigits: number;
    /**
     * Gets or sets the minimum integer digits. If FormatString is specificied this value is ignored.
    */
    minIntegerDigits: number;
    /**
     * Gets or sets whether to show a grouping separator. If FormatString is specificied this value is ignored.
    */
    showGroupingSeparator: boolean;
    /**
     * Gets or sets the INTL NumericFormat object to use for formatting the date values.
    */
    formatOverride: any;
}
