import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { IgxCellInfo } from "./igx-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
/**
 * Backing information for a section header cell in the grid.
*/
export declare class IgxSectionHeaderCellInfo extends IgxCellInfo {
    protected createImplementation(): SectionHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: SectionHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets the resolved text for the section header cell.
    */
    resolvedText: string;
    /**
     * Sets or gets the resolved summary text for the section header cell.
    */
    resolvedSummaryText: string;
    /**
     * Sets or gets how summaries are displayed in the section header cell.
    */
    summaryDisplayMode: GroupSummaryDisplayMode;
}
