import { Type } from '@angular/core';
import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SectionHeader } from "./SectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export declare const IgxSectionHeaderComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxSectionHeaderComponent extends IgxDefinitionBaseComponent {
    protected createImplementation(): SectionHeader;
    /**
                                 * @hidden
                                 */
    readonly i: SectionHeader;
    constructor();
    selectedBackground: string;
    actualSelectedBackground: string;
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    paddingLeft: number;
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    paddingTop: number;
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    paddingRight: number;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    paddingBottom: number;
    isCollapsable: boolean;
    summaryDisplayMode: GroupSummaryDisplayMode;
}
