import { IgxCellInfo } from './igx-cell-info';
import { TemplateCellUpdatingEventArgs as TemplateCellUpdatingEventArgs_internal } from "./TemplateCellUpdatingEventArgs";
/**
 * Information about the cell that has content which is being created or updated.
*/
export declare class IgxTemplateCellUpdatingEventArgs {
    protected createImplementation(): TemplateCellUpdatingEventArgs_internal;
    protected _implementation: any;
    readonly i: TemplateCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    readonly isCanvasBased: boolean;
    /**
     * The host in which to add or update content if this is a DOM based cell.
    */
    readonly content: Element;
    ensureCorrectSize(): boolean;
    readonly context: CanvasRenderingContext2D;
    renderStandardBackground(): void;
    renderStandardContent(): void;
    /**
     * The backing information for the current cell.
    */
    readonly cellInfo: IgxCellInfo;
}
