import { Type, EventEmitter } from '@angular/core';
import { IgxTemplateCellUpdatingEventArgs } from "./igx-template-cell-updating-event-args";
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateColumn } from "./TemplateColumn";
/**
 * A column with customizable content.
*/
export declare const IgxTemplateColumnComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTemplateColumnComponent extends IgxColumnComponent {
    protected createImplementation(): TemplateColumn;
    /**
                                 * @hidden
                                 */
    readonly i: TemplateColumn;
    constructor();
    private _cellUpdating;
    /**
     * Called when the cell content is being created or updated.
    */
    readonly cellUpdating: EventEmitter<{
        sender: any;
        args: IgxTemplateCellUpdatingEventArgs;
    }>;
}
