import { Type, EventEmitter } from '@angular/core';
import { IgxTemplateHeaderCellUpdatingEventArgs } from "./igx-template-header-cell-updating-event-args";
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateHeader } from "./TemplateHeader";
/**
 * A type of header with customizable content.
*/
export declare const IgxTemplateHeaderComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTemplateHeaderComponent extends IgxHeaderComponent {
    protected createImplementation(): TemplateHeader;
    /**
                                 * @hidden
                                 */
    readonly i: TemplateHeader;
    constructor();
    private _cellUpdating;
    /**
     * Called when the header cell content is being created or updated.
    */
    readonly cellUpdating: EventEmitter<{
        sender: any;
        args: IgxTemplateHeaderCellUpdatingEventArgs;
    }>;
}
