import { Type, EventEmitter } from '@angular/core';
import { IgxTemplateSectionHeaderCellUpdatingEventArgs } from "./igx-template-section-header-cell-updating-event-args";
import { IgxSectionHeaderComponent } from "./igx-section-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export declare const IgxTemplateSectionHeaderComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTemplateSectionHeaderComponent extends IgxSectionHeaderComponent {
    protected createImplementation(): TemplateSectionHeader;
    /**
                                 * @hidden
                                 */
    readonly i: TemplateSectionHeader;
    constructor();
    private _cellUpdating;
    /**
     * Called when the cell content is being created or updated.
    */
    readonly cellUpdating: EventEmitter<{
        sender: any;
        args: IgxTemplateSectionHeaderCellUpdatingEventArgs;
    }>;
}
